#include<iostream>
#include<cmath>
#include<vector>

#define ll long long
#define pb push_back


using namespace std;

const int maxn = 1e7 + 21;

vector < ll > v;
bool used[maxn];

bool prime (ll n) {
	for (ll i = 0; i < v.size() && v[i] < n; i++)
		if (!(n % v[i]))
			return false;
	return true;
}

ll a, b, ans, p[122];

void rec (ll n, ll power) {
	if (!prime(n) || n > b)
		return;
	if (n >= a)  
		ans++;    
	for (ll i = 1; i < 10; ++i)
		rec(n + i*p[power], power + 1);	
}
    
int main () {
	   	cin >> a >> b;
	   	//****************************
	   	for (int i = 4; i < maxn; i += 2)
	   		used[i] = false;
	   	v.pb(2);
		for (int i = 3; i < maxn; i += 2)
			if (!used[i]) {
				v.pb(i);
				for (long long j = i + i + i; j < maxn; j += i + i)
					used[j] = true;
			}		   			
	   	p[0] = 1;
	   	for (int i = 1; i <= 12; ++i)
	   		p[i] = p[i - 1] * 10;
	   	rec(2, 1);
	   	rec(3, 1);
	   	rec(5, 1);
	   	rec(7, 1);
	   	cout << ans;
	   	return 0;
}