#include <bits/stdc++.h>

#define F first
#define S second
#define FF first.first
#define FS first.second
#define SF second.first
#define SS second.second

#define all (x) (x).begin(), (x).end()
#define rall (x) (x).rbegin(), (x).rend()

#define pb push_back
#define mp make_pair
#define sz(x) (int)(x).size()

#define ll long long
#define ull unsigned long long
#define ld long double

#define pii pair <int, int>
#define pll pair <ll, ll>

#define LS (v << 1), tl, tm
#define RS ((v << 1) | 1), tm + 1, tr

using namespace std;

const int mod = 1e9 + 7;
const int iinf = INT_MAX;
const ll linf = LLONG_MAX;
const double pi = acos (-1.0);
const double eps = 1e-7;

ll l, r;
ll ans;

ll get(string s) {
	ll res = 0;
	for (int i = 0; i < sz(s); ++i) {
		res = res * 10 + (s[i] - '0');
	}
	return res;
}

ll mul(ll a, ll n, ll m) {
	ll res = 0;
	while (n) {
		if (n & 1) res = (res + a) % m;
		a = (a + a) % m;
		n >>= 1;
	}
	return res;
}

ll bp(ll a, ll n, ll m) {
	ll res = 1;
	while (n) {
		if (n & 1) res = mul(res, a, m);
		a = mul(a, a, m);
		n >>= 1;
	}
	return res;
}

bool ok(string s) {
	ll x = get(s);
	if (x == 1) return false;
	if (x == 2) return true;
	srand(time(NULL));
	for (int i = 0; i < 10; ++i) {
		ll a = (rand() % (x - 2)) + 2;
		if (__gcd(a, x) != 1) return false;
		if (bp(a, x - 1, x) != 1) return false;
	}
	return true;
}

ll calc(string s = "") {
	if (get(s) > r) return 0;
	ll res = 0;
	if (get(s) >= l && get(s) <= r) {
		//cout << s << endl;
		res++;
	}
	for (char i = '1'; i <= '9'; ++i) {
		if (ok(i + s)) {
			res += calc(i + s);
		}
	}
	return res;
}

int main () {
	ios_base :: sync_with_stdio (false);
	cin.tie (NULL); cout.tie (NULL);
	cin >> l >> r;
	ans = calc();
	cout << ans;
	return 0;
}