#include <bits/stdc++.h>
#define pb push_back

using namespace std;
typedef unsigned long long ll;

const ll MOD = 1000000000 + 7;

const ll MAXN = 1e6 + 5;

ll pref[MAXN];

vector <ll> zers;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    string s;
    cin >> s;
    for(int i = 0; i < s.size(); i++) {
        pref[i + 1] = pref[i];
        if(s[i] == '1') {
            pref[i + 1]++;
        }
        if(s[i] == '0') {
            zers.pb(i+1);
        }
    }
    if(s[0] == s[s.size() - 1]) {
        cout << 1 << " " << s.size() - 1 << " " << 2 << " " << s.size();
        return 0;
    } else {
        ll cur1 = 0, cur0 = s.size() - 1;
        while(s[cur1] == s[0]) cur1++;
        while(s[cur0] == s[s.size() - 1]) cur0--;
        cout << cur1 << " " << cur0 - 1 << " " << cur1 + 1 << " " << cur0;
        return 0;
    }
    ll l1, r1, l2, r2;
    ll l = 0, r = s.size();
    while(r - l > 1) {
        bool ok = false;
        ll mid = (r + l) / 2;
        for(int i = 0; i <= s.size() - mid; i++) {
            for(int j = i + 1; j <= s.size() - mid; j++) {
                if(pref[i + mid] - pref[i] == pref[j + mid] - pref[j]) {
                    l = mid;
                    ok = 1;
                    l1 = i + 1;
                    r1 = i + mid;
                    l2 = j + 1;
                    r2 = j + mid;
                    break;
                }
            }
            if(ok) break;
        }
        if(!ok) r = mid;
    }
    cout << l1 << " " << r1 << " " << l2 << " " << r2;
}
