#include <bits/stdc++.h>

#define all(v) v.begin(), v.end()
#define sz(v) int(v.size())
#define ll long long
#define pb push_back
#define vec vector<int>

using namespace std;

const int N = (int) 1e5 + 10;
const int INF = (int) 1e9 + 7;

set<vec> st;
ll k;

void shift(vec &v) {
    int last = v[3];
    for (int i = 1; i < 4; i++) v[i] = v[i - 1];
    v[0] = last;
}

vec mirror(vec v) {
    swap(v[1], v[3]);
    return v;
}

vec rt(vec v) {
    map<int, int> id;
    int sz = 0;
    for (int i = 0; i < 4; i++) {
        if (!id.count(v[i])) id[v[i]] = sz++;
        v[i] = id[v[i]];
    }
    return v;
}

vec get_min(vec v) {
    vec res = rt(v);
    for (int i = 0; i < 4; i++) {
        res = min(res, rt(v));
        res = min(res, rt(mirror(v)));
        shift(v);
    }
    return res;
}

void rec (vec v = {}) {
    if (sz(v) == 4) {
        st.insert(get_min(v));
        return;
    }
    for (int i = 0; i < 4; i++) {
        vec go = v;
        go.pb(i);
        rec(go);
    }
}

    ll total = 0;

void do_it() {
    for (auto it : st) {
        for (auto i : it) cout << i << ' '; cout << endl;
        set<int> r;
        for (auto i : it) r.insert(i);
        ll val = 1;
        for (int i = 0; i < sz(r); i++) {
            val *= (2 * k - i);
        }
        total += val;
    }
}

int main() {
    #ifdef witch
        //freopen("input.txt", "r", stdin);
        //freopen("output.txt", "w", stdout);
    #endif // sony
    rec();
    cin >> k;
    total += 4 * k * k;
    total += 8 * k * k * k;
    total += 2 * k;
    total += k * (2 * k - 1);
    total += 2 * k * (2 * k - 1);
    total += 2 * k * (2 * k - 1) / 2;
    total += (2 * k * (2 * k - 1) * (2 * k - 2) * (2 * k - 3)) / 8;
    cout << total;
    return 0;
}
