#include <iostream>
#include <string>
#include <stack>
#include <map>
#include <vector>

using namespace std;

map<string, stack<int>> a;
int level = 1;
int fast_pow(int a, int b) {
	int ans = 1;
	while (b) {
		if (b & 1) ans *= a;
		a *= a;
		b >>= 1;
	}
	return ans;
}

long long toi(string x) {
	long long ans = 0;
	int len = x.length();
	int a = fast_pow(10, len);
	for (int i = 0; i < len; i++) {
		ans += (x[i] - '0') * a;
		a /= 10;
	}
	return ans;
}

int main() {
	int n;
	cin >> n;
	int s = 0;
	int mod = 1000000007;
	vector<string> a(n);
	for (auto &e : a) cin >> e;
	if (n == 1) {
		cout << toi(a[0]) % mod;
	}
	else {
		for (int i = 0; i < n; i++) {
			for (int j = i + 1; j < n; j++) {
				s += toi(a[i] + a[j]) + toi(a[j] + a[i]);
			}
		}
		cout << s % mod / 10 << endl;
	}
	return 0;
}
