#include <iostream>
#include <string>
#include <stack>
#include <map>
#include <vector>


using namespace std;
map<string, stack<int>> a;
int level = 1;
int fast_pow(int a, int b) {
    int ans = 1;
    while (b) {
        if (b & 1) ans *= a;
        a *= a;
        b >>= 1;
    }
    return ans;
}

long long toi(string x) {
    bool otr = x[0] == '-';
    long long ans = 0;
    int len = x.length();
    int a = fast_pow(10, len - 1 - otr);
    for (int i = 0 + otr; i < len; i++) {
        ans += (x[i] - '0') * a;
        a /= 10;
    }
    if (otr) return -ans;
    return ans;
}

void ch(string kl, int zn) {
    if (a.count(kl)) {
        a[kl].pop();
        a[kl].push(zn);
    }
    else {
        stack<int> tmp;
        for (int i = 0; i < level - 1; i++) {
            tmp.push(0);
        }
        tmp.push(zn);
        a[kl] = tmp;
    }
}

int sch(int a) {
    int ans = 0;
    while (a) {
        a /=10;
        ans++;
    }
    return ans;
}

int main() {
    int n;
    cin >> n;
    int ans = 0;
    vector<int> a(n);
    vector<int> ah(n);
    for (auto &e : a) {
        cin >> e;
        ans += e;
        ans %= 1000000000 + 7;
    }
    ans = (1LL * ans * (n - 1)) % (1000000000 + 7);
    vector<int> g(10, 0);
    for (int i =0; i < n; i++) {
        ah[i] = sch(a[i]);
        g[ah[i]]++;
    }

    for (int i = 0; i < n; i++) {
        g[ah[i]] -= 1;
        for (int j = 1; j < 10; j++) {
            ans += 1LL * a[i] * g[j] * fast_pow(10, j) % (1000000000 + 7);
        }
        g[ah[i]] += 1;
    }
    cout << ans;
    return 0;
}
