#include <iostream>
#include <string>
#include <map>
#include <stack>

using namespace std;

const int p = 31, MOD = 998244353;

long long ppows[13];

int h(string& a) {
	int ans = 0;
	for (int i = 0; i < a.size(); ++i) {
		ans = (ans + (a[i] - 'a' + 1) * ppows[i]) % MOD;
	}
	return ans;
}

stack <map <int, int> > s;

int pows[] = {
	1,
	10,
	100,
	1000,
	10000,
	100000,
	1000000,
	10000000,
	100000000,
	1000000000
};

void parse(string& s, string& a, string& b) {
	bool f = true;
	a = "";
	b = "";
	for (char& c : s) {
		if (c == '=')
			f = false;
		else
			(f ? a : b) += c;
	}
}

int parseInt(string& a) {
	int ans = 0;
	bool kek = true;
	if (a[0] == '-')
		kek = false;
	for (int i = kek ? 0 : 1; i < a.size(); ++i) {
		ans += (a[i] - '0') * pows[a.size() - i - 1];
	}
	return kek ? ans : -ans;
}

int main() {
	string com, a, b;
	map <int, int> mp;
	s.push(mp);
	ppows[0] = p;
	for (int i = 1; i < 12; ++i) {
		ppows[i] = (ppows[i - 1] * p) % MOD;
	}
	while (cin >> com) {
		if (com == "{") {
			auto newMap = s.top();
			s.push(newMap);
			continue;
		}
		if (com == "}") {
			s.pop();
			continue;
		}
		map<int, int>& cur = s.top();
		parse(com, a, b);
		int hashA = h(a);
		if (b[0] >= '0' && b[0] <= '9' || b[0] =='-') {
			int bb = parseInt(b);
			cur[hashA] = bb;
		}
		else {
			int hashB = h(b);
			if (cur[hashB]) {
				cur[hashA] = cur[hashB];
				cout << cur[hashB] << endl;
			}
			else {
				cur[hashA] = 0;
				cout << 0 << endl;
			}
		}
	}
	return 0;
}