#include <string>
#include <map>
#include <stack>
#include <cstdio>
#include <cstring>

using namespace std;

const int p = 31, MOD = 998244353;

long long ppows[13];

int h(char* a) {
	long long ans = 0;
	int keks = strlen(a);
	for (int i = 0; i < keks; ++i) {
		ans += (a[i] - 'a' + 1) * ppows[i];
	}
	return ans % MOD;
}

map <int, int> sss[100010];

int pows[] = {
	1,
	10,
	100,
	1000,
	10000,
	100000,
	1000000,
	10000000,
	100000000,
	1000000000
};

void parse(char * s, char * a, char * b) {
	bool f = true;
	a[0] = '\0';
	b[0] = '\0';
	int l1 = 0, keks = strlen(s);
	for (int i = 0; i < keks; ++i) {
		if (s[i] == '=') {
			f = false;
			a[l1] = '\0';
			l1 = 0;
		}
		else {
			(f ? a[l1] : b[l1 - 1]) = s[i];
		}
		l1++;
	}
	b[l1 - 1] = '\0';
	
}

int parseInt(char * a) {
	int ans = 0, keks = strlen(a);
	bool kek = true;
	if (a[0] == '-')
		kek = false;
	for (int i = kek ? 0 : 1; i < keks; ++i) {
		ans += (a[i] - '0') * pows[keks - i - 1];
	}
	return kek ? ans : -ans;
}

int main() {
	char* com = (char *) malloc (25*sizeof(char));
	char * a = (char *)malloc(12 * sizeof(char));;
	char * b = (char *)malloc(12 * sizeof(char));;
	map <int, int> mp;
	//s.push(mp);
	sss[0] = mp;
	ppows[0] = p;
	for (int i = 1; i < 12; ++i) {
		ppows[i] = (ppows[i - 1] * p) % MOD;
	}
	int hh = 1;
	while (scanf("%s", com) == 1) {
		if (com[0] == '{') {
			if(hh % 9 == 0 && hh >= 9) {
				auto newMap = sss[hh-9];
				sss[hh] = newMap;
				//s.push(newMap);
			}
			else {
				map <int, int> qweqwe;
				//s.push(qweqwe);
				sss[hh] = qweqwe;
			}
			hh++;
			continue;
		}
		if (com[0] == '}') {
			//s.pop();
			hh--;
			continue;
		}
		map<int, int>& cur = sss[hh - 1];
		parse(com, a, b);
		int hashA = h(a);
		if (b[0] >= '0' && b[0] <= '9' || b[0] =='-') {
			int bb = parseInt(b);
			cur[hashA] = bb;
		}
		else {
			int hashB = h(b);
			if (cur[hashB]) {
				cur[hashA] = cur[hashB];
				printf("%d\n", cur[hashB]);
			}
			else {
				int hc = hh - 2;
				bool fff = true;
				for (int i = 0; i < 12; ++i) {
					if (hc < 0)
						break;
					map<int, int>& ncur = sss[hc];
					if (ncur[hashB]) {
						cur[hashA] = ncur[hashB];
						printf("%d\n", ncur[hashB]);
						fff = false;
						break;
					}
					hc--;
				}
				if (fff) {
					cur[hashA] = 0;
					printf("0\n");
				}
			}
		}
	}
	return 0;
}