#include <map>
#include <unordered_map>
#include <iostream>
#include <list>
#include <cstring>
#include <cstdio>

using namespace std;

#define map_t unordered_map

bool isN(const char *ch) {
    do {
        if ((*ch < '0' || *ch > '9') && *ch != '-')
            return false;
    } while (*(++ch) != 0);
    return true;
}

int getVar(const list<map_t<string, int>> &st, const string &name) {
    for (auto i = st.crbegin(); i != st.crend(); i++) {
        auto j = i->find(name);
        if (j != i->end())
            return j->second;
    }
    return 0;
}

int findch(char *s) {
    for (int i = 0; s[i] != 0; i++) {
        if (s[i] == '=')
            return i;
    }
    return -1;
}

int main() {
//    cin.tie({0});
//    cin.sync_with_stdio(false);
//    cout.tie({0});
//    cout.sync_with_stdio(false);

//    string s = "{";
    char ss[64] = {'{'};
    list<map_t<string, int>> st;
    do {
        if (ss[0] == '{')
            st.push_back(map_t<string, int>());
        else if (ss[0] == '}')
            st.pop_back();
        else {
            int n = findch(ss);
            if (n == -1)
                continue;

            string s(ss);
            string a = s.substr(0, n);
            string b = s.substr(n + 1, s.length() - n - 1);

            if (isN(b.c_str())) {
                st.back()[a] = atoi(b.c_str());
            } else {
                int t = getVar(st, b);
                st.back()[a] = t;
                cout << t << endl;
            }
        }
    } while (scanf("%s", ss) == 1);
}

/*

a=b
b=123
var=b
b=-34
{
c=b
b=1000000000
d=b
{
a=b
e=var
}
}
b=b



 */