#include <map>
#include <iostream>
#include <list>

using namespace std;

bool isN(const string &s) {
    for (char c : s) {
        if ((c < '0' || c > '9') && c != '-')
            return false;
    }
    return true;
}

int getVar(const list<map<string, int>> &st, const string &name) {
    for (auto i = st.crbegin(); i != st.crend(); i++) {
        auto j = i->find(name);
        if (j != i->end())
            return j->second;
    }
    return 0;
}

int main() {
    cin.tie({0});
    cin.sync_with_stdio(false);
    

    string s = "{";
    list<map<string, int>> st;
    do {
        if (s[0] == '{')
            st.push_back(map<string, int>());
        else if (s[0] == '}')
            st.pop_back();
        else {
            int n = s.find('=');
            string a = s.substr(0, n);
            string b = s.substr(n + 1, s.length() - n - 1);

            if (isN(b)) {
                st.back()[a] = atoi(b.c_str());
            } else {
                int t = getVar(st, b);
                st.back()[a] = t;
                cout << t << endl;
            }
        }
    } while (cin >> s);
}

/*

a=b
b=123
var=b
b=-34
{
c=b
b=1000000000
d=b
{
a=b
e=var
}
}
b=b



 */