#include <map>
#include <unordered_map>
#include <iostream>
#include <list>
#include <cstring>
#include <cstdio>

using namespace std;

#define map_t unordered_map

bool isN(const char *ch) {
    do {
        if ((*ch < '0' || *ch > '9') && *ch != '-')
            return false;
    } while (*(++ch) != 0);
    return true;
}

int getVar(const list<map_t<size_t, int>> &st, const size_t name) {
    for (auto i = st.crbegin(); i != st.crend(); i++) {
        auto j = i->find(name);
        if (j != i->end())
            return j->second;
    }
    return 0;
}

int findch(char *s) {
    for (int i = 0; s[i] != 0; i++) {
        if (s[i] == '=')
            return i;
    }
    return -1;
}

int main() {
//    cin.tie({0});
//    cin.sync_with_stdio(false);
//    cout.tie({0});
//    cout.sync_with_stdio(false);

//    string s = "{";
    char s[64] = {'{'};
    list<map_t<size_t, int>> st;
    do {
        if (s[0] == '{')
            st.push_back(map_t<size_t, int>());
        else if (s[0] == '}')
            st.pop_back();
        else {
            int n = findch(s);
            if (n == -1)
                continue;

            size_t a = _Hash_bytes(s, n, 1337);

            if (isN(s + n + 1)) {
                st.back()[a] = atoi(s + n + 1);
            } else {
                int t = getVar(st, _Hash_bytes(s + n + 1, strlen(s) - n - 1, 1337));
                st.back()[a] = t;
                printf("%d\n", t);
            }
        }
    } while (scanf("%s", s) == 1);
}

/*

a=b
b=123
var=b
b=-34
{
c=b
b=1000000000
d=b
{
a=b
e=var
}
}
b=b



 */