#include <fstream>
#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <time.h>
#include <set>
#include <string>
#include <map>

using namespace std;

#define fori(i,a,b) for(int i = a; i < b; i++)
#define ifor(i,a,b) for(int i = b-1; i >= a; i++)

//ifstream in("input.txt");
//ofstream out("output.txt");
//#define in cin
//#define out cout

int main() {
	vector<map<string, int> > stack;
	stack.emplace_back();
	string s;
	map<string,int>* current = &stack.back();
	while (getline(cin, s)) {
		if (s.length() <= 0) break;
		if (s[0] == '{') {
			stack.emplace_back(stack.back());
			current = &stack.back();
		}
		else if (s[0] == '}') {
			stack.pop_back();
			current = &stack.back();
		}
		else {
			auto ix = s.find('=');
			string a = s.substr(0, ix);
			string b = s.substr(ix + 1, s.length() - ix - 1);
			if (b[0] == '-' || (b[0] <= '9' && b[0] >= '0')) {
				(*current)[a] = stoi(b);
			}
			else {
				cout << (*current)[b] << '\n';
				(*current)[a] = (*current)[b];
			}
		}
	}
	return 0;
}