#include <cmath>
#include <map>
#include <iostream>

using namespace std;
typedef unsigned long long ull;
bool isnumeric(string s) {
    bool flag = false;
    for (int i = 0; i < s.size(); i++)
    {
        if (s[i] != '-' && !(s[i]<='9' && s[i]>='0'))
            flag=true;
    }
    if (flag)
        return false;
    return true;
}

bool parse(string s, string &v1, string &v2)
{
    v1 = "";
    v2 = "";
    int i = 0;
    bool v2_isv = false;
    while (s[i] != '=')
    {
        v1 += s[i];
        i++;
    }
    i++;
    while (i < s.size())
    {
        v2 += s[i];
        i++;
    }
    return !isnumeric(v2);
}

void func(map<string, int> &g_vars)
{
    map<string, int> vars = {};
    auto e = g_vars.begin();
    while (e != g_vars.end()){
        vars[e->first] = e->second;
        e++;
    }
    string s;
    cin >> s;
    while (s != "}"){
        if (s == "{"){
            func(vars);
        }
        else{
            string v1, v2;
            bool v2_isv = parse(s, v1, v2);
            if (v2_isv)
            {
                vars[v1] = vars[v2];
                cout << vars[v1] << endl;
            }
            else
                vars[v1] = stoi(v2);
        }
        cin >> s;
    }
}
int main(){
    map<string, int> vars = {};
    func(vars);
}

