#include <stdio.h>
#include <bits/stdc++.h>
using namespace std;

typedef long long ll;

const ll INF = 1e18;
const int maxn = 1e5 + 10;

ll pos[5] = {-INF, 0, 0, 0, INF};
ll cnt[5] = {0, 0, 0, 0, 0};
ll a[maxn];

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(nullptr);
    for (int i = 1; i <= 3; ++i) {
        cin >> pos[i] >> cnt[i];
    }
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    sort(a, a + n);
    ll ans = 0;
    for (int i = 0; i < n; ++i) {
        int l = (int)(lower_bound(pos, pos + n, a[i]) - pos);
        if (pos[l] > a[i])
            l--;
        while (l > 0 && cnt[l] == 0)
            l--;
        int r = (int)(upper_bound(pos, pos + n, a[i]) - pos);
        while (r < 4 && cnt[r] == 0)
            r++;

        //cout << l << ' ' << r << ' ' << pos[l] << ' ' << pos[r] << endl;
        if (a[i] - pos[l] <= pos[r] - a[i] && cnt[l]) {
            ans += a[i] - pos[l];
            cnt[l]--;
            //cout << "l" << endl;
        } else {
            ll rem = 0;
            for (int j = r; j < 5; ++j)
                rem += cnt[j];
            if (rem - 1 >= n - i) {
                ans += pos[r] - a[i];
                cnt[r]--;
                //cout << "r" << endl;
            } else {
                assert(cnt[l] > 0);
                ans += a[i] - pos[l];
                cnt[l]--;
                //cout << "l" << endl;
            }
        }
        //cout << ans << endl;
    }
    cout << ans;
    return 0;
}
/*
0 1
3 2
6 3
4
-2 1 3 2
*/
