#include <stdio.h>
#include <bits/stdc++.h>
using namespace std;

typedef long long ll;

const int INF = INT_MAX - 1;

struct Item{

    int cord;
    ll sum;
    Item(int cord, ll sum) : cord(cord), sum(sum) {}

};

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(nullptr);
    int a, na, b, nb, c, nc;
    cin >> a >> na >> b >> nb >> c >> nc;
    int n;
    cin >> n;
    vector<Item> cur;
    for(int i = 0; i < n; i++) {
        ll cord;
        cin >> cord;
        cur.push_back(Item(cord, abs(cord - a) + abs(cord - b) + abs(cord - c)));
    }
    sort(cur.begin(), cur.end(), [](const Item &left, const Item &right) {
       return left.sum > right.sum;
    });
    ll ans = 0;
    int cnt[256] = {};
    for(int i = 0; i < n; i++) {
        int mmin = INF;
        bool ac = false, bc = false, cc = false;
        if(cnt['a'] < na) {
            if(abs(cur[i].cord - a) < mmin) {
                mmin = abs(cur[i].cord - a);
                ac = true;
                bc = false;
                cc = false;
            }
        }
        if(cnt['b'] < nb) {
            if(abs(cur[i].cord - b) < mmin) {
                mmin = abs(cur[i].cord - b);
                ac = false;
                bc = true;
                cc = false;
            }
        }
        if(cnt['c'] < nc) {
            if(abs(cur[i].cord - c) < mmin) {
                mmin = abs(cur[i].cord - c);
                ac = false;
                bc = false;
                cc = true;
            }
        }
        ans += mmin;
        if(ac == true) {
            cnt['a']++;
        } else if(bc == true) {
            cnt['b']++;
        } else if(cc == true) {
            cnt['c']++;
        }
    }
    cout << ans;
    return 0;
}
