#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int MOD = 1e9 + 7;
const int inf = 1e9 + 228;

inline int add(int a, int b)
{
    return ((a + b) % MOD + MOD) % MOD;
}

inline int mul(int a, int b)
{
    return (a * (ll) b) % MOD;
}

set <pair <int, int> > s;

void add(int pos)
{
    int l = pos, r = pos;
    auto it = s.upper_bound({pos - 1, inf});
    if (it != s.begin())
    {
        auto p = it;
        p = prev(p);
        if (p->second == pos - 1)
        {
            l = p->first;
            s.erase(p);
        }
    }
    it = s.lower_bound({pos + 1, -inf});
    if (it != s.end())
    {
        if (it->first == pos + 1)
        {
            r = it->second;
            s.erase(it);
        }
    }
    s.insert({l, r});
}

int bin(int a, int n)
{
    int ret = 1;
    while (n)
    {
        if (n % 2 == 0)
        {
            a = mul(a, a);
            n /= 2;
        }
        else
        {
            ret = mul(ret, a);
            n--;
        }
    }
    return ret;
}

const int M = MOD;

int main()
{
    #ifdef ONPC
        freopen("a.in", "r", stdin);
        freopen("a.out", "w", stdout);
    #endif // ONPC
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int dv2 = bin(2, M - 2);
    int n;
    cin >> n;
    vector <int> a(n);
    vector <pair <int, int> > e;
    for (int i = 0; i < n; i++)
    {
        cin >> a[i];
        e.push_back({a[i], i});
    }
    sort(e.begin(), e.end());
    int j = -1;
    int ret = 0;
    for (int i = 0; i < n; i++)
    {
        vector <int> pos;
        while (j + 1 < n && e[j + 1].first == e[i].first)
        {
            add(e[j + 1].second);
            pos.push_back(e[j + 1].second);
            j++;
        }
        vector <int> one;
        int was = -1;
        int wr = -1;
        vector <int> hv;
        for (int x : pos)
        {
            auto it = s.upper_bound({x, inf});
            it--;
            if (was == -1)
            {
                was = it->first;
                one.push_back(x);
            }
            else
            {
                if (it->first != was)
                {
                    int l = was;
                    int r = wr;
                    vector <pair <int, int> > kek;
                    for (int i = 0; i < (int) one.size(); i++)
                    {
                        if (i == 0)
                        {
                            if (one[i] != l)
                                kek.push_back({0, one[i] - l});
                        }
                        else if (one[i] != one[i - 1] + 1)
                        {
                            kek.push_back({0, one[i] - one[i - 1] - 1});
                        }
                        kek.push_back({1, 1});
                        if (i == (int) one.size() - 1)
                        {
                            if (r != one[i])
                                kek.push_back({0, r - one[i]});
                        }
                    }
                    vector <int> res;
                    int s = 0;
                    for (auto c : kek)
                    {
                        if (c.first == 0)
                        {
                            res.push_back(mul(c.second, s));
                        }
                        s += c.second;
                        if (c.first == 1)
                        {
                            res.push_back(s);
                        }
                    }
                    int kk = 0;
                    for (int x : res) kk = add(kk, x);
                    hv.push_back(kk);
                    auto pref = res;
                    s = 0;
                    vector <int> suf;
                    for (int i = (int) kek.size() - 1; i >= 0; i--)
                    {
                        if (kek[i].first == 0)
                        {
                            suf.push_back(mul(kek[i].second, s));
                            int ok = pref[i];
                            ok = mul(ok, kek[i].second - 1);
                            ok = mul(ok, s);
                            ok = mul(ok, dv2);
                            ret = add(ret, ok);
                        }
                        s += kek[i].second;
                        if (kek[i].first == 1)
                        {
                            suf.push_back(s);
                        }
                    }
                    reverse(suf.begin(), suf.end());
                    vector <int> R = suf;
                    for (int i = (int) R.size() - 2; i >= 0; i--) R[i] = add(R[i], R[i + 1]);
                    for (int i = 0; i + 1 < (int) R.size(); i++)
                    {
                        ret = add(ret, mul(pref[i], R[i + 1]));
                    }
                    one.clear();
                    one.push_back(x);
                }
                else
                {
                    one.push_back(x);
                }
            }
            was = it->first;
            wr = it->second;
        }
        {
           int l = was;
                    int r = wr;
                    vector <pair <int, int> > kek;
                    for (int i = 0; i < (int) one.size(); i++)
                    {
                        if (i == 0)
                        {
                            if (one[i] != l)
                                kek.push_back({0, one[i] - l});
                        }
                        else if (one[i] != one[i - 1] + 1)
                        {
                            kek.push_back({0, one[i] - one[i - 1] - 1});
                        }
                        kek.push_back({1, 1});
                        if (i == (int) one.size() - 1)
                        {
                            if (r != one[i])
                                kek.push_back({0, r - one[i]});
                        }
                    }
                    vector <int> res;
                    int s = 0;
                    for (auto c : kek)
                    {
                        if (c.first == 0)
                        {
                            res.push_back(mul(c.second, s));
                        }
                        s += c.second;
                        if (c.first == 1)
                        {
                            res.push_back(s);
                        }
                    }
                    int kk = 0;
                    for (int x : res) kk = add(kk, x);
                    hv.push_back(kk);
                    auto pref = res;
                    s = 0;
                    vector <int> suf;
                    for (int i = (int) kek.size() - 1; i >= 0; i--)
                    {
                        if (kek[i].first == 0)
                        {
                            suf.push_back(mul(kek[i].second, s));
                            int ok = pref[i];
                            ok = mul(ok, kek[i].second - 1);
                            ok = mul(ok, s);
                            ok = mul(ok, dv2);
                            ret = add(ret, ok);
                        }
                        s += kek[i].second;
                        if (kek[i].first == 1)
                        {
                            suf.push_back(s);
                        }
                    }
                    reverse(suf.begin(), suf.end());
                    vector <int> R = suf;
                    for (int i = (int) R.size() - 2; i >= 0; i--) R[i] = add(R[i], R[i + 1]);
                    for (int i = 0; i + 1 < (int) R.size(); i++)
                    {
                        ret = add(ret, mul(pref[i], R[i + 1]));
                    }
        }
        int s = 0;
        for (int x : hv)
        {
            ret = add(ret, mul(s, x));
            s = add(s, x);
        }
        i = j;
    }
    cout << ret << '\n';
}
