#include <iostream>
#include <algorithm>
#include <cmath>
using namespace std;

typedef long long Int;

inline Int len(Int num) {
    Int i(0);
    for(; num; ++i)
        num /= 10;
    return i;
}

#define MAX_N 100019
#define MOD Int(1000000007)
#define a(x) Int(1e ## x)

Int n, a[MAX_N] = {}, suff[MAX_N][12] = {},
    pows[12] = {1, 10, a(2), a(3), a(4), a(5), a(6), a(7), a(8), a(9), a(10), a(11)},
    pref[MAX_N][12] = {}, suffk[MAX_N][12] = {}, prefk[MAX_N][12] = {};

int main() {
    ios::sync_with_stdio(false);
    cin >> n;
    for(int i(0); i < n; ++i)
        cin >> a[i];
    sort(a, a + n);

    for(int i(n - 1); i > -1; --i) {
        for(int j(0); j < 12; ++j)
            suff[i][j] = suff[i + 1][j],
            suffk[i][j] = suffk[i+1][j];
        suff[i][len(a[i])] += a[i];
        suffk[i][len(a[i])] += 1;
    }
    pref[0][len(a[0])] += a[0];
    prefk[0][len(a[0])] = 1;
    for(int i(1); i < n; ++i) {
        for(int j(0); j < 12; ++j)
            pref[i][j] = pref[i - 1][j],
            prefk[i][j] = prefk[i - 1][j];
        pref[i][len(a[i])] += a[i];
        prefk[i][len(a[i])] += 1;
    }
    long long sum = 0, ls;
    for(int i(0); i < n; ++i) {
        for(int j(0); j < 12; ++j) {
            if(suffk[i + 1][j] != 0)
                sum += a[i] * pows[j] * suffk[i+1][j] + suff[i + 1][j];
            if (i && prefk[i - 1][j] != 0)
                sum += a[i] * pows[j] * prefk[i-1][j] + pref[i - 1][j];
            sum %= MOD;
        }
    }
    cout << sum << endl;
    return 0;
}
