#include <iostream>
#include <vector>
#include<string>
#include<stack>
#include<map>
#include<set>
#include<algorithm>
using namespace std;

const long long N = 100003;
long long n, cnt;
vector<vector<long long>> g[N];
long long p[N];

long long getp(long long v) {
	if (p[v] != v)
		p[v] = getp(p[v]);
	return p[v];
}

void merge(long long v, long long u) {
	v = getp(v);
	u = getp(u);
	if (v != u) {
		cnt--;
		p[v] = u;
	}
}

int main() {
	long long u, v, w, t, ans = 0;
	long long inf = 1e16;
	cin >> n;
	for (long long i = 0; i < n - 1; i++) {
		cin >> u >> v >> w;
		w *= 2;
		g[u].push_back({ v, w, i });
		g[v].push_back({ u, w, i });
	}
	vector<long long> d(n + 1, inf);
	cin >> t;
	for (long long i = 0; i < t; i++) {
		cin >> v;
		d[v] = 0;
	}
	set <pair<long long, long long>> s;
	for (long long i = 1; i <= n; i++)
		s.insert({ d[i], i });
	while (!s.empty()) {
		v = (*s.begin()).second;
		s.erase(s.begin());
		for (auto e : g[v]) {
			if (d[e[0]] == inf) {
				s.erase({ d[e[0]], e[0] });
				d[e[0]] = d[v] + e[1];
				s.insert({ d[e[0]], e[0] });
			}
		}
	}
	vector<vector<long long>> ev;
	for (long long i = 1; i <= n; i++) {
		p[i - 1] = i - 1;
		ev.push_back({ -d[i], i });
		for (auto e : g[i]) {
			if (i > e[0])
				continue;
			long long x = d[i], y = d[e[0]];
			if (x > y)
				swap(x, y);
			t = y - x > e[1] ? x + e[1] : y + (e[1] - y + x) / 2;
			ev.push_back({ -t, -1 });
		}
	}
	sort(ev.begin(), ev.end());
	ev.push_back({ 1 });
	for (long long i = 0; i < ev.size() - 1; i++) {
		if (ev[i][1] == -1) {
			cnt++;
		}
		else {
			v = g[ev[i][1]][0][2];
			for (auto e : g[ev[i][1]]) {
				merge(v, e[2]);
			}
		}
		if (ev[i][0] < ev[i + 1][0])
			ans = max(ans, cnt);
	}
	cout << ans;
	return 0;
}