#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <string>
#include <set>

using namespace std;

typedef long long ll;

int main()
{
	string s;
	cin >> s;
	ll l = 0, r = s.size();
	vector <ll> pref_sums(s.size(), 0);
	for (int i = 0; i < s.size(); ++i)
	{
		if (i == 0)
		{
			pref_sums[i] = s[0] - '0';
		}
		else
		{
			pref_sums[i] = pref_sums[i - 1] + s[i] - '0';
		}
	}
	ll ans_count = -1;
	while (l + 1 < r)
	{
		ll m = (r + l) / 2;
		set <ll> sums;
		for (int i = 0; i < s.size() - m; ++i)
		{
			ll temp;
			if (i != 0)
				temp = pref_sums[i + m] - pref_sums[i - 1];
			else
				temp = pref_sums[m];
			if (sums.count(temp) == 1)
			{
				l = m;
				ans_count = temp;
				break;
			}
			else
			{
				sums.insert(temp);
			}
		}
		if (l != m)
		{
			r = m;
		}
	}
	bool flag = false;
	pair<int, int> first_ans(-1, -1), second_ans(-1, -1);
	for (int i = 0; i < s.size() - l; ++i)
	{
		ll sum;
		if (i == 0)
		{
			sum = pref_sums[l];
		}
		else
		{
			sum = pref_sums[i + l] - pref_sums[i - 1];
		}
		if (flag && sum == ans_count)
		{
			second_ans = { i + 1, i + l + 1 };
			break;
		}
		if (!flag && sum == ans_count)
		{
			flag = true;
			first_ans = { i + 1, i + l + 1 };
		}
	}
	cout << first_ans.first << " " << first_ans.second << " " << second_ans.first << " " << second_ans.second;
	return 0;
}