#define _CRT_SECURE_NO_WARNINGS
#include <algorithm>
#include <iostream>
#include <string>
#include <vector>
#include <map>

using namespace std;

void run();

typedef long long ll;

#define rep(i, s, t) for (auto i = (s); i < (t); ++(i))
#define sz(x) ((int) (x).size())

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	run();
#ifdef _DEBUG
	cerr << endl << "OK" << endl;
	while (1);
#endif
	return 0;
}

const int N = 1e5 + 123;

int n = 0;
string a[N];
map<string, int> cur;
map<string, int> m[N];

int to_save[N];
vector<int> st;

void run() {
	string s;
	while (getline(cin, s))
	{
		a[n++] = s;
	}
	int bal = 0;
	for (int i = 0; i < n; i++)
	{
		if (a[i] == "{")
		{
			st.push_back(i);
		}
		else if (a[i] == "}")
		{
			to_save[st.back()] = i;
			st.pop_back();
		}
	}
	int last = -1;
	for (int i = 0; i < n; i++)
	{
		if (a[i] == "{")
		{
			last = i;
		}
		else if (a[i] == "}")
		{
			for (auto it : m[i])
			{
				cur[it.first] = it.second;
			}
		}
		else
		{
			string p1 = "", p2 = "";
			int k;
			int j = 0;
			while (1)
			{
				p1.push_back(a[i][j]);
				++j;
				if (a[i][j] == '=')
					break;
			}
			++j;
			for (; j < a[i].length(); j++)
			{
				p2.push_back(a[i][j]);
			}
			if (p2[0] == '-' || ('0' <= p2[0] && p2[0] <= '9'))
			{
				if (last != -1)
				{
					m[to_save[last]][p1] = cur[p1];
				}
				cur[p1] = stoi(p2);
			}
			else
			{
				if (last != -1)
				{
					m[to_save[last]][p1] = cur[p1];
				}
				int res = cur[p2];
				cout << res << "\n";
				cur[p1] = res;
			}
		}
	}
}