#define _CRT_SECURE_NO_WARNINGS
#include <algorithm>
#include <iostream>
#include <string>
#include <vector>

using namespace std;

void run();

typedef long long ll;

#define rep(i, s, t) for (auto i = (s); i < (t); ++(i))
#define sz(x) ((int) (x).size())

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	run();
#ifdef _DEBUG
	cerr << endl << "OK" << endl;
	while (1);
#endif
	return 0;
}

const ll MOD = (ll) 1e9 + 7;
const int N = (int) 1e5 + 123;
const int L = 40;

int n;
ll a[N], b[N];
ll cnt[L];
ll len[L];
ll pow10[L];

void run() {
	pow10[0] = 1;
	rep(i, 1, L) {
		pow10[i] = pow10[i - 1] * 10 % MOD;
	}

	cin >> n;
	rep(i, 0, n) {
		cin >> a[i];
		b[i] = a[i];
		vector<ll> d;
		while (a[i] > 0) {
			d.push_back(a[i] % 10);
			a[i] /= 10;
		}
		len[sz(d)]++;
		a[i] = b[i];
	}

	ll ans = 0;

	rep(i, 0, n) {
		vector<ll> d;
		while (a[i] > 0) {
			d.push_back(a[i] % 10);
			a[i] /= 10;
		}
		a[i] = b[i];
		len[sz(d)]--;
		rep(q, 0, L) {
			ans += (a[i] % MOD) * pow10[q] % MOD * len[q] % MOD;
			ans += (a[i] % MOD) * len[q] % MOD;
			ans %= MOD;
		}
		len[sz(d)]++;
	}

	cout << ans << "\n";
}