import sys
from collections import defaultdict

if len(sys.argv) > 1:
    sys.stdin = open('input.txt')
    sys.stdout = open('output.txt', 'w')

a = sys.stdin.read().split('\n')
if not a[-1]:
    a.pop()
d = defaultdict(list)
blocks = []
blocks.append([])

for i in a:
    if i == '{':
        blocks.append([])
    elif i == '}':
        last = blocks.pop()
        for j in last:
            d[j].pop()
    else:
        var1, var2 = i.split('=')
        blocks[-1].append(var1)
        if not d.get(var1, None):
            d[var1] = []
        try:
            d[var1].append(int(var2))
        except ValueError:
            if d[var2]:
                print(d[var2][-1])
                d[var1].append(d[var2][-1])
            else:
                print(0)
                d[var1].append(0)
