#include <cstdio>
#include <bits/stdc++.h>
#include <cstdio>

using namespace std;

typedef long long ll;

const int N = 4001;
const ll INF = 100000000000000000;

ll dp[N][N];
int pr[N][N];
ll d[N], c[N], p[N];
set<pair<int, int> > best[N];
vector<int> answ;

int main()
{
    ios::sync_with_stdio(0); cin.tie(0);
    int n, m;
    cin >> n >> m;
    for (int i = 1; i <= n; i++)
        cin >> d[i] >> p[i] >> c[i];
    for (int i = 0; i < N; i++)
        for (int j = 0; j < N; j++)
            dp[i][j] = INF, pr[i][j] = -1;
    dp[0][0] = 0;
    for (int i = 1; i <= n; i++)
        for (int j = N - 1; j >= 0; j--)
        {
            if (j <= p[i])
            {
                dp[i][j] = c[i];
                pr[i][j] = 0;
            }
            if (j >= p[i])
            {
                if (best[j - p[i]].size())
                {
                    auto kek = best[j - p[i]].lower_bound(make_pair(d[i], -1e9));
                    if (kek != best[j - p[i]].end())
                    {
                        int r = kek->second;
                        if (dp[i][j] > dp[r][j - p[i]] + c[i])
                        {
                            dp[i][j] = dp[r][j - p[i]] + c[i];
                            pr[i][j] = r;
                        }
                    }
                }
            }
            while (best[j].size())
            {
                auto kek = best[j].lower_bound(make_pair(d[i] + 1, -1e9));
                if (kek == best[j].begin())
                    break;
                kek--;
                if (dp[kek->second][j] >= dp[i][j])
                    best[j].erase(kek);
                else
                {
                    break;
                }
            }
            auto kek = best[j].lower_bound(make_pair(d[i], -1e9));
            if (kek == best[j].end() || dp[kek->second][j] >= dp[i][j])
                best[j].insert(make_pair(d[i], i));
        }
   /* for (int i = 0; i <= n; i++)
    {for (int j = 0; j <= m; j++)

            cout << dp[i][j]<< " ";
            cout << endl;
    }
    cout << endl;
    for (int j = 0; j <= m; j++)
    {
        cout << j << " " << best[j].size() << ": ";
        for (auto i : best[j])
            cout << i.second << " ";
        cout << endl;
    }*/
    ll ans = INF - 10LL;
    int pos = -1;
    int mem = -1;
    for (int i = 1; i <= n; i++)
        for (int j = m; j < N; j++)
            if (dp[i][j] < ans)
            {
                ans = dp[i][j];
                mem = j;
                pos = i;
            }
   // cout << dp[2][6] << endl;
    if (pos == -1)
    {
        cout << -1;
        return 0;
    }
    cout << dp[pos][mem] << endl;
    while (pos > 0)
    {
        answ.push_back(pos);
        int x = mem - p[pos];
        pos = pr[pos][mem];
        mem = x;
    }
    cout << answ.size() << endl;
    sort(answ.begin(), answ.end());
    for (int i = 0; i < answ.size(); i++)
        cout << answ[i] << " ";
    return 0;
}
/*
2 2
1 1 1
2 3 2

2 4
1 1 1
2 3 2

2 4
1 1 1
1 3 2

2 6
2 2 1
1 4 1
*/
