#include <iostream>
#include <vector>
#include <algorithm>
#include <fstream>

using namespace std;

#define int int64_t

const int mod = 1e9 + 7;

int32_t main()
{
	//ifstream cin("input.txt");
	int n;
	cin >> n;
	vector<int> arr(n);
	for (int &i : arr)
		cin >> i;
	auto zip = arr;
	sort(zip.begin(), zip.end());
	zip.resize(unique(zip.begin(), zip.end()) - zip.begin());
	for (int &i : arr)
		i = lower_bound(zip.begin(), zip.end(), i) - zip.begin();
	vector<int> L(n, -1);
	for (int i = 1; i < n; i++)
		for (L[i] = i - 1; L[i] >= 0 && arr[L[i]] < arr[i]; L[i] = L[L[i]]);
	vector<int> R(n, n);
	for (int i = n - 2; i >= 0; --i)
		for (R[i] = i + 1; R[i] < n && arr[R[i]] <= arr[i]; R[i] = R[R[i]]);
	vector<vector<int> > blocks(zip.size());
	for (int i = 0; i < n; i++)
		blocks[arr[i]].push_back(i);
	int ans = 0;
	for (auto &block : blocks)
	{
		//cerr << "block " << arr[block[0]] << "\n";
		int m = block.size();
		int seg_cnt = 0;
		for (int i = 0; i < m;)
		{
			int l = L[block[i]];
			int j = i;
			int r = R[block[i]];
			for (; i < m && R[block[i]] == r; i++)
			{
				//cerr << L[block[i]] << " " << block[i] << " " << R[block[i]] << "\n";
				int my_cnt = ((block[i] - L[block[i]]) * (R[block[i]] - block[i])) % mod;
				//cerr << my_cnt << " ";
				seg_cnt += my_cnt;
				seg_cnt %= mod;
				ans -= (my_cnt * (my_cnt - 1) / 2) % mod;
				ans += mod;
				ans %= mod;
			}
			//cerr << "\n" << i << " " << j << "\n";
			for (int k = j + 1; k < i; k++)
			{
				int mult = ((block[k - 1] - l) * (r - block[k])) % mod;
				//cerr << mult << "\n";
				int cnt = (block[k] - block[k - 1]) * (block[k] - block[k - 1] - 1) / 2ll;
				cnt += (block[k] - block[k - 1]) * (r - block[k]);
				//cerr << cnt << "\n";
				cnt %= mod;
				ans -= (mult * cnt) % mod;
				ans += mod;
				ans %= mod;
			}
		}
		ans += seg_cnt * (seg_cnt - 1) / 2ll;
		ans %= mod;
		//cerr << ans << "\n";
	}
	cout << ans;
	return 0;
}
