#include <bits/stdc++.h>
using namespace std;

#define int int64_t

int a, b;

bool check_prime1(int n)
{
    if (n == 0 || n == 1)
    {
        return false;
    }
    for (int i = 2; i * i <= n; ++i)
    {
        if (n % i == 0)
        {
            return false;
        }
    }
    return true;
}

int gcd(int a, int b)
{
    return b == 0 ? a : gcd(b, a % b);
}

int prod(int rem, int a, int n)
{
    int newrem = (a * (rem >> 20ll)) % n;
    newrem <<= 20ll;
    newrem %= n;
    newrem += a * (rem & ((1ll << 20ll) - 1ll)) % n;
    newrem %= n;
    return newrem;
}

int powmod(int a, int b, int m)
{
    int res = 1;
    while (b)
    {
        if (b & 1)
        {
            res = prod(res, a, m);
            --b;
        }
        else
        {
            a = prod(a, a, m);
            b >>= 1;
        }
    }
    return res;
}

bool miller_reabin(int n)
{
    int b = (rand() | (((rand() * 1ll) << 28))) % n;
    if (b < 3)
    {
        b = 2;
    }
    for (int g; (g = gcd(n, b)) != 1; ++b)
    {
        if (n > g)
        {
            return false;
        }
    }
    int p = 0, q = n - 1;
    while ((q % 2) == 0)
    {
        ++p;
        q /= 2;
    }
    int rem = powmod(b, q, n);
    if (rem == 1 || rem == n - 1)
    {
        return true;
    }
    for (int i = 1; i < p; ++i)
    {
        rem = prod(rem, rem, n);
        if (rem == n - 1)
        {
            return true;
        }
    }
    return rem == 1;
}

bool check_prime(int n)
{
    if (n == 1 || n % 2 == 0)
    {
        return false;
    }
    if (n == 2)
    {
        return true;
    }
    for (int i = 0; i < 20; ++i)
    {
        if (!miller_reabin(n))
        {
            return false;
        }
    }
    return true;
}

int cnt = -1;
int cnt1 = -1;

void g(int a, int curr, int ln)
{
    if (curr > b)
    {
        return;
    }
    ++cnt;
    if (curr < a)
    {
        ++cnt1;
    }
    int curr1 = 0;
    for (int i = 1; i <= 9; ++i)
    {
        curr1 = curr + ln * i;
        if (check_prime(curr1))
        {
            g(a, curr1, ln * 10);
        }
    }
}

int f()
{
    cnt = 0;
    cnt1 = 0;
    g(a, 3, 10);
    g(a, 7, 10);
    g(a, 2, 10);
    g(a, 5, 10);
    return cnt;
}

signed main()
{
    cin >> a >> b;
    f();
    cout << cnt - cnt1 << endl;
    return 0;
}
