// COlymp.cpp : Defines the entry polong long for the console application.
//

#include <iostream>

using namespace std;

long long length(long long n);
long long tp(long long a);
long long smart(long long n, long long nums[]);
long long dumb(long long n, long long nums[]);

int main()
{
	long long n;
	cin >> n;
	long long count[9];
	long long sum[9];
	long long nums[100000];


	for (long long i = 0; i < n; i++)
	{
		long long t;
		cin >> t;
		nums[i] = t;
	}

	cout << smart(n, nums);

	return 0;
}

long long smart(long long n, long long nums[])
{
	long long count[9];
	long long sum[9];

	for (long long i = 0; i < 9; i++)
	{
		count[i] = sum[i] = 0;
	}

	for (long long i = 0; i < n; i++)
	{
		long long t = nums[i];
		long long l = length(t);
		sum[l - 1] += t;
		count[l - 1]++;
	}

	long long mm = 0;

	for (long long i = 0; i < n; i++)
	{
		long long num = nums[i];
		long long l = length(num);
		for (long long j = 1; j <= 9; j++)
		{
			long long p = tp(j);
			mm += nums[i] * p * (j == l ? count[j - 1] - 1 : count[j - 1]) + (j == l ? sum[j - 1] - num : sum[j - 1]);
			mm %= 1000000007;
		}
	}

	return mm;
}

long long dumb(long long n, long long nums[])
{
	long long mm = 0;
	for (long long i = 0; i < n; i++)
	{
		for (long long j = 0; j < n; j++)
		{
			if (i != j)
			{
				long long l1 = length(nums[i]);
				long long l2 = length(nums[j]);
				mm += tp(l1) * nums[j] + nums[i];
				mm %= 1000000007;
			}
		}
	}
	return mm;
}

long long length(long long n)
{
	long long r = 0;
	while (n > 0)
	{
		r++;
		n /= 10;
	}
	return r;
}

long long tp(long long a)
{
	long long r = 1;
	for (long long i = 0; i < a; i++)
		r *= 10;
	return r;
}
