// COlymp.cpp : Defines the entry point for the console application.
//

#include <iostream>

using namespace std;

int length(long long n);
int tp(int a);
int smart(long long n, long long nums[]);
int dumb(long long n, long long nums[]);

int main()
{
	long long n;
	cin >> n;
	long long count[9];
	long long sum[9];
	long long nums[100000];


	for (long long i = 0; i < n; i++)
	{
		long long t;
		cin >> t;
		nums[i] = t;
	}

	cout << dumb(n, nums);

	return 0;
}

int smart(long long n, long long nums[])
{
	long long count[9];
	long long sum[9];

	for (int i = 0; i < 9; i++)
	{
		count[i] = sum[i] = 0;
	}

	for (long long i = 0; i < n; i++)
	{
		long long t = nums[i];
		int l = length(t);
		sum[l - 1] += t;
		count[l - 1]++;
	}

	long long mm = 0;

	for (long long i = 0; i < n; i++)
	{
		long long num = nums[i];
		int l = length(num);
		for (int j = 1; j <= 9; j++)
		{
			long long p = tp(j);
			mm += nums[i] * p * (j == l ? count[j - 1] - 1 : count[j - 1]);
			while (mm >= 1000000007)
				mm -= 1000000007;
			mm += (j == l ? sum[j - 1] - num : sum[j - 1]);
			while (mm >= 1000000007)
				mm -= 1000000007;
		}
	}

	return mm;
}

int dumb(long long n, long long nums[])
{
	long long mm = 0;
	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < n; j++)
		{
			if (i != j)
			{
				int l1 = length(nums[i]);
				int l2 = length(nums[j]);
				mm += tp(l1) * nums[j] + nums[i];
				//mm %= 1000000007;
			}
		}
	}
	return mm;
}

int length(long long n)
{
	int r = 0;
	while (n > 0)
	{
		r++;
		n /= 10;
	}
	return r;
}

int tp(int a)
{
	long long r = 1;
	for (int i = 0; i < a; i++)
		r *= 10;
	return r;
}
