import java.io.*;
import java.util.Locale;
import java.util.StringTokenizer;

public class Main {

    public void solve() throws IOException {
        int n = nextInt();
        int a[] = new int[n];
        int cnt[] = new int[n];
        for (int i = 0; i < n; i++) {
            a[i] = nextInt();
        }
        long h = 0;
        long res = 0, mod = 1000000000 + 7;
        for (int i = n - 1; i >= 0; i--) {
            res += a[i] * (n - 1);
            res %= mod;
            int r = 10;
            while (r <= a[i]) {
                r *= 10;
            }
            cnt[i] = r;
            h += r;
            h %= mod;
        }
        for (int i = 0; i < n; i++) {
            if (cnt[i] <= h) {
                res += (h - cnt[i]) * a[i];
                res %=  mod;
            }else{
                res += (mod + h - cnt[i]) * a[i];
                res %= mod;
            }
        }
        out.print(res);
    }

    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new Main().run();
    }

}
