#include <iostream>
#include <cstdio>
#include <cmath>
#include <queue>
#include <algorithm>

using namespace std;

#define ff first
#define ss second
typedef long long ll;

int solve();

int main(){
    ios_base::sync_with_stdio(0);
#ifdef home
    freopen ("input.txt", "r", stdin);
#else
    cin.tie(0);
    cout.tie(0);
#endif // home
    solve();
}

const ll MAXN = (ll)2e6 + 7;
ll a, b, lg[20];
ll ans[MAXN];
ll n, nn;
queue < pair <ll, ll > > v;
ll l;
ll mx = MAXN - 4;

ll pr[MAXN];
bool is[MAXN];

bool check (ll x){
    if (x > b) return 0;
    if (x <= mx)
    {
        return (!is[x]);
    }
    for (ll i = 0; pr[i] <= sqrt(x) && i < nn; ++i){
        if (x % pr[i] == 0) return 0;
    }
    return 1;
}

void go (ll x, ll len){
    for (ll i = 1; i <= 9; ++i){
        if (check(x + i * lg[len])){
            v.push({x + i * lg[len], len + 1});
        }
    }
}

ll x;
ll ln, lb;

ll fn(ll e){
    ll aa = 0;
    while(e){
        aa++;
        e /= 10;
    }
    return aa;
}

int solve(){
    cin >> a >> b;
    lb = fn(b);
    lg[0] = 1;
    for (ll i = 1; i <= 18; ++i){
        lg[i] = lg[i - 1] * 10;
    }

    is[0] = is[1] = 1;

    for (ll i = 2; i * i <= mx; ++i){
        if (!is[i])
        if (i * i <= mx)
            for (ll j = i * i; j <= mx; j += i)
                is[j] = 1;
    }

    for (ll i = 2; i <= mx; ++i){
        if (!is[i]) pr[nn++] = i;
    }

    ln = 1;

    v.push({2, 1}), v.push({3, 1}), v.push({5, 1}), v.push({7, 1});
    while(!v.empty()){
        x = v.front().ff;
        ln = v.front().ss;
        if (x > b) continue;
        if (ln > lb) break;
        ans[l++] = x;
        v.pop();
        go(x, ln);
    }

    sort(ans, ans + l);

    cout << upper_bound(ans, ans + l, b) - lower_bound(ans, ans + l, a);
    return 0;
}

