#include <bits/stdc++.h>
using namespace std;
#define x first
#define y second
#define mp make_pair
#define pb push_back
#define MAXN MAXN228
#define left left228
#define right right228
#define slice slice228
#define int long long
typedef long double ld;
const int MOD = 1e9 + 7, MAXN = 1e5 + 7;

bool is_c(char c){
    return (('0' <= c && c <= '9') || (c == '-'));
}

int get_p(string s){
    for (int i = 0; i < s.size(); ++i){
        if (s[i] == '=') return i;
    }
}

int get_type(string s){
    if (s == "{") return 1;
    if (s == "}") return 2;
    int p = get_p(s);
    if (is_c(s[p + 1])) return 3;
    return 4;
}

string slice(string s, int l, int r){
    string res = "";
    for (int i = l; i <= r; ++i){
        res += s[i];
    }
    return res;
}

vector <pair <string, int> > h;
stack <int> st;
map <string, int> d;

void downgrate(int last_sz){
    while (h.size() > last_sz){
        auto elem = h[h.size() - 1];
        d[elem.first] = elem.second;
        h.pop_back();
    }
}

void solve() {
    //freopen("in.txt", "r", stdin);
    vector <string> a;
    string s;
    while (cin >> s){
        a.push_back(s);
        int type = get_type(s);
        if (type == 3){
            int p = get_p(s);
            string name = slice(s, 0, p - 1);
            d[name] = 0;
        }
        else if (type == 4){
            int p = get_p(s);
            string name1 = slice(s, 0, p - 1);
            string name2 = slice(s, p  |1, s.size() - 1);
            d[name1] = 0;
            d[name2] = 0;
        }
    }
    int n = a.size();
    for (int i = 0; i < n; ++i){
        s= a[i];
        int type = get_type(s);
        //cout << s << '#' << type<<endl;

        //cout << type << '\n';
        if (type == 1){
            st.push(h.size());
        }
        else if (type == 2){
            downgrate(st.top());
            st.pop();
        }
        else if (type == 3){
            int p = get_p(s);
            string name = slice(s, 0, p - 1);
            int val = stoi(slice(s, p + 1, s.size() - 1));
            //cout << name << ' ' << val << '\n';
            if (d.find(name) == d.end()) d[name] = -1;
            h.push_back({name, d[name]});
            d[name] = val;
        }
        else{
            int p = get_p(s);
            string s1 = slice(s, 0, p - 1);
            string s2 = slice(s, p + 1, s.size() - 1);
            cout << d[s2] << '\n';
            h.push_back({s1, d[s1]});
            d[s1] = d[s2];
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);

    solve();

    return 0;
}