#include <bits/stdc++.h>

#define ll long long
#define rep(i, l, r) for (int i = l; i < r; i++)
#define repb(i, l, r) for (int i = l; i > r; i--)
#define fi first
#define se second

using namespace std;

const int inf = (int)1e9 + 1;
const int MOD = (int)1e9 + 7;

ll cnt(ll x)
{
    return x * (x - 1) / 2 % MOD;
}

int main()
{
    //freopen("ans.txt", "w", stdout);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n;
    int a[n];
    rep(i, 0, n)
        cin >> a[i];
    int to_left[n], to_right[n];
    vector<pair<int, int> > st;
    st.push_back({inf, -1});
    rep(i, 0, n)
    {
        while (st.back().fi <= a[i])
            st.pop_back();
        to_left[i] = st.back().se;
        st.push_back({a[i], i});
    }
    st.clear();
    st.push_back({inf, n});
    repb(i, n - 1, -1)
    {
        while (st.back().fi <= a[i])
            st.pop_back();
        to_right[i] = st.back().se;
        st.push_back({a[i], i});
    }
    ll ans = 0;
    map<int, int> last;
    rep(i, 0, n)
    {
        if (last.find(a[i]) == last.end())
        {
            last[a[i]] = i;
            continue;
        }
        int j = last[a[i]];
        if (to_left[i] > j)
        {
            ans = (ans + ((ll)(i - to_left[i]) * (to_right[i] - i) % MOD) * ((ll)(j - to_left[j]) * (to_right[j] - j) % MOD)) % MOD;
        }
        else
        {
            ans = (ans + (ll)(j - to_left[j]) * cnt(i - j + 1) % MOD * (to_right[i] - i)) % MOD;
        }
        last[a[i]] = i;
    }
    cout << ans << "\n";
    return 0;
}
