#include <bits/stdc++.h>

#define ll long long
#define rep(i, l, r) for (int i = l; i < r; i++)
#define repb(i, l, r) for (int i = l; i > r; i--)
#define fi first
#define se second
#define sz(a) (int)a.size()

#define left aaaaaaaaaa
#define right bbbbbbbbb

using namespace std;

const int inf = (int)1e9 + 1;
const int MOD = (int)1e9 + 7;

ll cnt(ll x)
{
    return x * (x - 1) / 2 % MOD;
}

int main()
{
    //freopen("in.txt", "r", stdin);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n;
    int a[n];
    rep(i, 0, n)
        cin >> a[i];
    vector<int> diff;
    rep(i, 0, n)
        diff.push_back(a[i]);
    sort(diff.begin(), diff.end());
    diff.resize(unique(diff.begin(), diff.end()) - diff.begin());
    rep(i, 0, n)
        a[i] = lower_bound(diff.begin(), diff.end(), a[i]) - diff.begin();

    int left[n], right[n];
    vector<pair<int, int> > st;
    st.push_back({inf, -1});
    rep(i, 0, n)
    {
        while (st.back().fi <= a[i])
            st.pop_back();
        left[i] = i - st.back().se;
        st.push_back({a[i], i});
    }
    st.clear();
    st.push_back({inf, n});
    repb(i, n - 1, -1)
    {
        while (st.back().fi <= a[i])
            st.pop_back();
        right[i] = st.back().se - i;
        st.push_back({a[i], i});
    }

    int left_1[n], right_1[n];
    st.clear();
    st.push_back({inf, -1});
    rep(i, 0, n)
    {
        while (st.back().fi < a[i])
            st.pop_back();
        left_1[i] = i - st.back().se;
        st.push_back({a[i], i});
    }
    st.clear();
    st.push_back({inf, n});
    repb(i, n - 1, -1)
    {
        while (st.back().fi < a[i])
            st.pop_back();
        right_1[i] = st.back().se - i;
        st.push_back({a[i], i});
    }

    /*rep(i, 0, n)
        cout << left[i] << " ";
    cout << "\n";
    rep(i, 0, n)
        cout << right[i] << " ";
    cout << "\n";
    rep(i, 0, n)
        cout << left_1[i] << " ";
    cout << "\n";
    rep(i, 0, n)
        cout << right_1[i] << " ";
    cout << "\n";*/

    vector<int> pos[n];
    vector<int> pref[n];
    rep(i, 0, n)
        pref[i].push_back(0);

    ll ans = 0;
    rep(i, 0, n)
    {
        if (sz(pos[a[i]]) == 0)
        {
            pos[a[i]].push_back(i);
            pref[a[i]].push_back(((ll)left[i] * right_1[i] + pref[a[i]].back()) % MOD);
            continue;
        }
        int j = pos[a[i]].back();
        if (left[i] >= (i - j + 1))
        {
            ans = (ans + (ll)left[j] * cnt(i - j + 1) % MOD * right[i]) % MOD;
            ans = (ans + (ll)left_1[i] * right[i] % MOD * pref[a[i]][sz(pref[a[i]]) - 2]) % MOD;
        }
        else
        {
            ans = (ans + (ll)left_1[i] * right[i] % MOD * pref[a[i]][sz(pref[a[i]]) - 1]) % MOD;
        }
        pos[a[i]].push_back(i);
        pref[a[i]].push_back(((ll)left[i] * right_1[i] + pref[a[i]].back()) % MOD);
    }
    cout << ans << "\n";
    return 0;
}
