#include <bits/stdc++.h>

#define ll long long
#define rep(i, l, r) for (int i = l; i < r; i++)
#define repb(i, l, r) for (int i = l; i > r; i--)
#define fi first
#define se second
#define sz(a) (int)a.size()

#define left aaaaaaaaaa
#define right bbbbbbbbb

using namespace std;

const int N = 100000;
const int inf = (int)1e9 + 1;
const int MOD = (int)1e9 + 7;
const ll big = (ll)1e18 + 1;

vector<pair<int, int> > g[N];
set<pair<ll, int> > q;
ll d[N];

void djikstra()
{
    while (sz(q) > 0)
    {
        int u = (*q.begin()).se;
        q.erase(q.begin());
        for (auto v : g[u])
            if (d[v.fi] > d[u] + v.se)
            {
                q.erase({d[v.fi], v.fi});
                d[v.fi] = d[u] + v.se;
                q.insert({d[v.fi], v.fi});
            }
    }
}

vector<int> g1[N * 2];

ll die[N * 2];

int cnt = 0;
int p[N * 2], r[N * 2];
bool ok[N * 2];

void add(int x)
{
    ok[x] = true;
    p[x] = x;
    r[x] = 1;
    cnt++;
}

int get(int x)
{
    if (p[x] != x)
        p[x] = get(p[x]);
    return p[x];
}

void uni(int x, int y)
{
    x = get(x);
    y = get(y);
    if (x == y)
        return;
    if (r[x] >= r[y])
        p[y] = x;
    else
        p[x] = y;
    if (r[x] == r[y])
        r[x]++;
    cnt--;
}

int main()
{
    //freopen("in.txt", "r", stdin);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n;
    int edge[n][3];
    rep(i, 0, n - 1)
    {
        int u, v, l;
        cin >> u >> v >> l;
        u--; v--;
        g[u].push_back({v, l});
        g[v].push_back({u, l});
        edge[i][0] = u;
        edge[i][1] = v;
        edge[i][2] = l;
    }
    fill(d, d + n, big);
    int m;
    cin >> m;
    rep(i, 0, m)
    {
        int x;
        cin >> x;
        x--;
        d[x] = 0;
        q.insert({d[x], x});
    }
    djikstra();
    /*rep(i, 0, n)
        cout << d[i] << " ";
    cout << "\n";*/
    rep(i, 0, n)
        die[i] = d[i] * 2;
    rep(i, 0, n - 1)
    {
        int u = edge[i][0], v = edge[i][1];
        ll l = edge[i][2];
        if (abs(die[u] - die[v]) / 2 <= l)
            die[n + i] = min(die[u], die[v]) + abs(die[u] - die[v]) + (l - abs(die[u] - die[v]) / 2);
        else
            die[n + i] = max(die[u], die[v]);
        g1[u].push_back(n + i);
        g1[n + i].push_back(u);
        g1[v].push_back(n + i);
        g1[n + i].push_back(v);
    }
    /*rep(i, 0, n)
        cout << die[i] << " ";
    cout << "\n";
    rep(i, 0, n - 1)
        cout << die[n + i] << " ";
    cout << "\n";*/
    n += (n - 1);
    int ans = 0;
    pair<ll, int> e[n];
    rep(i, 0, n)
        e[i] = {die[i], i};
    sort(e, e + n);
    reverse(e, e + n);
    rep(i, 0, n)
    {
        int u = e[i].se;
        add(u);
        for (int v : g1[u])
            if (ok[v])
                uni(u, v);
        if (i == n - 1 || e[i].fi != e[i + 1].fi)
            ans = max(ans, cnt);
    }
    cout << ans << "\n";
    return 0;
}
