#include <iostream>
#include <cmath>

#define MOD 1000000007

unsigned long long int numbers[100000];
int temp[1000];

long long int tens[11];

void mergesort(int *data, int length)
{
    if (length < 2)
        return;

    int lenA = length / 2;
    int lenB = length - lenA;
    int *dataA = data;
    int *dataB = data + lenA;

    mergesort(dataA, lenA);
    mergesort(dataB, lenB);

    int pA = 0;
    int pB = 0;

    while (pA < lenA && pB < lenB)
    {
        if (dataB[pB] < dataA[pA])
        {
            temp[pA + pB] = dataB[pB];
            pB++;
        } else
        {
            temp[pA + pB] = dataA[pA];
            pA++;
        }
    }

    while (pA < lenA)
    {
        temp[pA + pB] = dataA[pA];
        pA++;
    }

    while (pB < lenB)
    {
        temp[pA + pB] = dataB[pB];
        pB++;
    }

    for (int i = 0; i < length; i++)
        data[i] = temp[i];
}

long long int findTen(unsigned long long int num)
{
    for (int i = 0; i < 11; i++)
        if (num < tens[i])
            return tens[i];
}

int main()
{
    int n;

    tens[0] = 1;
    for (int i = 1; i < 11; i++)
        tens[i] = tens[i - 1] * 10;

    std::cin >> n;

    long long int totalLength = 0;

    for (int i = 0; i < n; i++)
    {
        std::cin >> numbers[i];
        totalLength += /*tens[((int) std::log10(numbers[i])) + 1]*/findTen(numbers[i]);
    }

    long long int result = 0;

    for (int i = 0; i < n; i++)
    {
        result += numbers[i] * ((n - 1 + totalLength - findTen(numbers[i]) % MOD)/*tens[((int) std::log10(numbers[i])) + 1]*/);
        result %= MOD;
    }

    std::cout << result << std::endl;

    return 0;
}
