#include <iostream>

int numbers[1000];
int temp[1000];

void mergesort(int *data, int length)
{
    if (length < 2)
        return;

    int lenA = length / 2;
    int lenB = length - lenA;
    int *dataA = data;
    int *dataB = data + lenA;

    mergesort(dataA, lenA);
    mergesort(dataB, lenB);

    int pA = 0;
    int pB = 0;

    while (pA < lenA && pB < lenB)
    {
        if (dataB[pB] < dataA[pA])
        {
            temp[pA + pB] = dataB[pB];
            pB++;
        } else
        {
            temp[pA + pB] = dataA[pA];
            pA++;
        }
    }

    while (pA < lenA)
    {
        temp[pA + pB] = dataA[pA];
        pA++;
    }

    while (pB < lenB)
    {
        temp[pA + pB] = dataB[pB];
        pB++;
    }

    for (int i = 0; i < length; i++)
        data[i] = temp[i];
}

int main()
{
    int n, m;
    std::cin >> n >> m;

    for (int i = 0; i < m; i++)
    {
        std::cin >> numbers[i];
    }

    if (m != n - 1)
        std::cout << "No" << std::endl;
    else
    {
        //mergesort(numbers, n);

        int skips = 0;
        int skipped = 0;

        int last = 0;

        for (int i = 0; i < m; i++)
        {
            if (numbers[i] - last > 2)
            {
                std::cout << "No" << std::endl;
                return 0;
            } else if (numbers[i] - last == 2)
            {
                if (skips > 0)
                {
                    std::cout << "No" << std::endl;
                    return 0;
                } else
                {
                    skips++;
                    skipped = numbers[i] - 1;
                }
            } else if (numbers[i] <= last)
            {
                std::cout << "No" << std::endl;
                return 0;
            }

            last = numbers[i];
        }

        if (skips == 0)
            skipped = n;

        std::cout << "Yes" << std::endl;
        std::cout << skipped << std::endl;
    }

    return 0;
}
