#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define fr first
#define sc second
#define pb push_back
#define mp make_pair

const int inf = 1e9 + 88;
const ll infll = 1e18 + 88;
const int maxn = 1e3 + 88;
const ll mod = 1e9 + 7;
const ll mod2 = 1e9 + 9;

long long pref[maxn], suff[maxn];
pair<long long, long long> cnt[3];
ll t[4*maxn];
ll x[maxn];

ll build(int v, int l, int r)
{
    if (l == r)
        return t[v] = suff[l];
    ll mid = (l + r)/2;
    t[v] = min(build(2*v, l, mid), build(2*v + 1, mid + 1, r));
}

ll get(int v, int l, int r, int ql, int qr)
{
    if (l > qr || r < ql)
        return infll;
    if (l >= ql && r <= qr)
        return t[v];
    ll mid = (l + r)/2;
    return min(get(2*v, l, mid, ql, qr), get(2*v + 1, mid + 1, r, ql, qr));
}

void solve1()
{
    ll n, a, na, b, nb, c, nc, i;
    for (i = 0; i < 3; i++)
        cin >> cnt[i].fr >> cnt[i].sc;
    sort(cnt, cnt + 3);
    a = cnt[0].fr, na = cnt[0].sc;
    b = cnt[1].fr, nb = cnt[1].sc;
    c = cnt[2].fr, nc = cnt[2].sc;
    cin >> n;
    for (i = 0; i < n; i++)
        cin >> x[i];
    sort(x, x + n);
    for (i = 0; i < na; i++)
        pref[i] = abs(a - x[i]) + (i != 0 ? pref[i - 1] : 0);
    for (i = na; i < n; i++)
        pref[i] = infll;
    for (i = n - 1; i >= n - nc; i--)
        suff[i] = abs(c - x[i]) + (i != n - 1 ? suff[i + 1] : 0);
    for (i = 0; i < n - nc; i++)
        suff[i] = infll;
    ll sum = 0;
    for (i = 0; i <= n; i++)
    {
        suff[i] = min(infll, suff[i] + sum);
        sum += abs(b - x[i]);
    }
    build(1, 0, n);
    ll ans = get(1, 0, n, 0, nb);
    sum = abs(b - x[0]);
    for (i = 0; i < na; i++)
    {
        ll cur = get(1, 0, n, i + 1, i + nb + 1);
        if (cur == infll)
            continue;
        ans = min(ans, cur + pref[i] - sum);
        sum += abs(b - x[i]);
    }
    cout << ans;
}
//
//void solve(){
//
//}

int main()
{
    ios_base::sync_with_stdio(0);
//    freopen("input.txt", "r", stdin);
    cin.tie();
    cout.tie();
    solve1();
    return 0;
}
