#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define fr first
#define sc second
#define pb push_back
#define mp make_pair

const int inf = 1e9 + 88;
const ll infll = 3e18 + 88;
const int maxn = 2e1 + 5;
const ll mod = 1e9 + 7;
const ll mod2 = 1e9 + 9;

int d[maxn], c[maxn], p[maxn];
map<int,int> dm, pm;
vector<int> ds, ps;
bool fl[maxn];
pair<int, int> t[maxn][4 * maxn];
vector<pair<int, pair<int, int> > > pr[maxn][maxn];
int fp[maxn];
int lvl;

pair<int, int> inline minf(pair<int, int> a, pair<int, int> b){
    if(a.fr < b.fr)
        return a;
    if(a.fr == b.fr && a.sc > b.sc)
        return a;
    return b;
}

void build0(int v, int l, int r){
    if(l == r){
        t[lvl][v] = {0, l};
        fp[l] = v;
        return;
    }
    int c = (l + r)/2;
    build0(v * 2, l, c);
    build0(v * 2 + 1, c + 1, r);
    t[lvl][v] = minf(t[lvl][v * 2], t[lvl][v * 2 + 1]);
}

void build(int v, int l, int r){
    if(l == r){
        t[lvl][v] = {inf, l};
        fp[l] = v;
        return;
    }
    int c = (l + r)/2;
    build(v * 2, l, c);
    build(v * 2 + 1, c + 1, r);
    t[lvl][v] = minf(t[lvl][v * 2], t[lvl][v * 2 + 1]);
}

pair<int, int> getMin(int v, int tl, int tr, int l, int r){
    if(l > r)
        return {inf, -1};
    if(tl == l && tr == r){
        return t[lvl][v];
    }
    int c = (tl + tr) / 2;
    return minf(getMin(2 * v, tl, c, l, min(r, c)),
               getMin(2 * v + 1, c + 1, tr, max(l, c + 1), r));
}

bool update(int v, int l, int r, int x, int pos){
    bool res = 0;
    if(l == r){
        if(x < t[lvl][v].fr){
            t[lvl][v] = {x, l};
            return 1;
        }
        return 0;
    }
    int c = (l + r)/2;
    if(pos <= c)
        res = update(v * 2, l, c, x, pos);
    else
        res = update(v * 2 + 1, c + 1, r, x, pos);
    t[lvl][v] = minf(t[lvl][v * 2], t[lvl][v * 2 + 1]);
    return res;
}

void solve(){
    int n, m;
    cin >> n >> m;
    for(int i = 0; i < n; i++){
        cin >> d[i] >> p[i] >> c[i];
        ds.pb(d[i]);
    }
    sort(ds.begin(), ds.end());
    for(int i = 0; i < ds.size(); i++){
        dm[ds[i]] = i;
    }
    for(int i = 0; i < n; i++)
        d[i] = dm[d[i]];
    fl[0] = 1;
    build0(1, 0, n);
    for(int i = 1; i <= m; i++){
        lvl = i;
        build(1, 0, n);
    }
    for(int i = 0; i < n; i++){
        for(int j = m - 1; j >= 0; j--){
            if(fl[j]){
                lvl = j;
                pair<int, int> f = getMin(1, 0, n, d[i], n);
                lvl = min(j + p[i], m);
                bool upd = update(1, 0, n, f.fr + c[i], d[i]);
                if(upd){
                    pr[lvl][d[i]].pb({i, {f.sc, j}});
                }
                fl[lvl] = 1;
            }
        }
    }
    if(!fl[m]){
        cout << -1;
        return;
    }
    int ans1 = inf, y = -1, x = m;
    for(int i = 0; i <= n; i++){
        if(ans1 > t[m][fp[i]].fr){
            ans1 = t[m][fp[i]].fr;
            y = i;
        }
    }
    if(y != -1){
        vector<int> ans;
        pair<int, pair<int, int> > f = pr[x][y].back();
        ans.pb(f.fr);
        x = f.sc.sc;
        y = f.sc.fr;
        while(x > 0){
            while(f.fr <= pr[x][y].back().fr)
                pr[x][y].pop_back();
            f = pr[x][y].back();
            ans.pb(f.fr);
            x = f.sc.sc;
            y = f.sc.fr;
        }
        reverse(ans.begin(), ans.end());
        cout << ans1 << " " << ans.size() << "\n";
        for(int x : ans)
            cout << x + 1  << " ";
    }
    else{
        cout << -1;
        return;
    }
}

int main()
{
    ios_base::sync_with_stdio(0);
//    freopen("input.txt", "r", stdin);
    cin.tie();
    cout.tie();
    solve();
    return 0;
}
