#include <iostream>
#include <vector>
#include <algorithm>
#include <climits>
#include <cmath>
#include <set>
#include <map>
#include <stack>
#include <cctype>
#include <string>

using namespace std;

/*int main()
{
	long long n;
	cin >> n;

	long long ans = (2 * n)*(2 * n) + (2 * n)*(2 * n)*(2 * n);

	ans += 2*n + 2*(2*n)*(2*n - 1);

	if (2 * n >= 3)
		ans += (2 * n)*(2 * n - 1)*(2 * n - 2);

	if (2 * n >= 4)
		ans += (2 * n)*(2 * n - 1)*(2 * n - 2)*(2*n - 3) / 4;

	cout << ans;
}*/

/*int main()
{
	string s;
	cin >> s;
	int n = (int)s.size();
	vector<int> p(n);
	vector<int> c(n + 1, 0);
	p[0] = s[0] == '1';
	for (int i = 1; i < n; i++) {
		p[i] = p[i - 1] + (s[i] == '1');
		c[p[i]]++;
	}
	
	for (int)
}*/

const int BASE1 = 1e+9 + 9;
const int BASE2 = 1e+9 + 7;
const int p1 = 29;
const int p2 = 31;

pair<int, int> get_hash(const string &s)
{
	long long h1 = 0, h2 = 0;
	for (int i = 0; i < s.size(); i++) {
		h1 = (h1 * p1 + s[i] - 'a' + 1) % BASE1;
		h2 = (h2 * p2 + s[i] - 'a' + 1) % BASE2;
	}

	
	return { h1, h2 };
}

int main()
{
	map<pair<int, int>, string> v; //hash, string
	map<pair<int, int>, stack<int>> cur_val; //hash, cur_v
	stack<set<pair<int, int>>> nw; //stack<hash>

	nw.push(set<pair<int, int>>());

	string s;
	while (cin >> s) {
		if (s == "{")
			nw.push(set<pair<int, int>>());
		else if (s == "}") {
			for (auto x : nw.top())
				cur_val[x].pop();
			nw.pop();
		}
		else {
			string a = s.substr(0, s.find('='));
			string b = s.substr(a.size() + 1);
			pair<int, int> h1 = get_hash(a);

			if (v.count(h1) == 0) {
				v.insert({ h1, a });
				cur_val.insert({ h1, stack<int>() });
				cur_val[h1].push(0);
			}

			if (b[0] == '-' || b[0] <= '9' && b[0] >= '0') {
				if (nw.top().count(h1))
					cur_val[h1].pop();

				nw.top().insert(h1);
				int t = stoi(b);
				cur_val[h1].push(t);
			}
			else {
				if (a == b) {
					cout << cur_val[h1].top() << '\n';
					continue;
				}

				pair<int, int> h2 = get_hash(b);

				if (v.count(h2) == 0) {
					v.insert({ h2, b });
					cur_val.insert({ h2, stack<int>() });
					cur_val[h2].push(0);
				}

				if (nw.top().count(h1))
					cur_val[h1].pop();
				else
					nw.top().insert(h1);

				cur_val[h1].push(cur_val[h2].top());
				cout << cur_val[h1].top();
				cout << '\n';
			}
		}
	}
}
