#include <iostream>
#include <vector>
#include <algorithm>
#include <climits>
#include <cmath>
#include <set>

using namespace std;

int main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);

	vector<pair<int, int>> h(3);
	for (int i = 0; i < 3; i++)
		cin >> h[i].first >> h[i].second;

	sort(h.begin(), h.end());

	int n;
	cin >> n;
	vector<int> a(n);

	for (int i = 0; i < n; i++)
		cin >> a[i];

	sort(a.begin(), a.end());

	long long ans = 0;
	for (int i = 0; i < n; i++) {
		int dst, d = INT_MAX;
		for (int j = 0; j < 3; j++) {
			if (h[j].second > 0 && d > abs(a[i] - h[j].first)) {
				dst = j;
				d = abs(a[i] - h[j].first);
			}
		}

		h[dst].second--;
		ans += (long long)d;
	}

	cout << ans << endl;
}