#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <stack>
#include <time.h>
#include <unordered_map>
#include <unordered_set>
#include <string>
#include <cmath>
#include <cstdio>

using namespace std;

typedef long long ll;
typedef double dl;

ll INF = 1e9;
ll inf = 1e9;

ll maxn = 1e5;


int main()
{
	//freopen("input.txt", "r", stdin);
	
	string s;
	unordered_map<string, ll> mapp;

	vector<ll> e;
	vector<vector<ll>> v(maxn, {0});
	ll cntper = 0;

	char str[10000];

	while (scanf("%s", &str) == 1)
	{
		s = str;
		if (s == "{")
		{
			e.push_back(-1);
		}
		else if (s == "}")
		{
			for (int i = e.size() - 1; i >= 0 && e[i] != -1; --i)
			{
				v[e[i]].pop_back();
				e.pop_back();
			}

			if (e.back() == -1)
				e.pop_back();
		}
		else
		{
			string n1, n2;
			ll oper = 0;
			for (int i = 0; i < s.size(); ++i)
			{
				if ((s[i] >= 'a' && s[i] <= 'z') || (s[i] >= '0' && s[i] <= '9') || s[i] == '-')
				{
					if (oper)
						n2 += s[i];
					else
						n1 += s[i];
				}
				else
				{
					oper = 1;
				}
			}

			int fl = 1;
			ll val = 0;
			for (int i = 0; i < n2.size(); ++i)
			{
				if (n2[i] >= '0' && n2[i] <= '9')
				{
					fl = 0;
					val *= 10;
					val += (n2[i] - '0');
				}
			}
			if (n2[0] == '-')
				val *= (-1);

			ll num1 = 0;
			if (!mapp.count(n1))
			{
				mapp[n1] = ++cntper;
			}

			num1 = mapp[n1];
			if (fl)
			{
				ll num2 = 0;
				if (!mapp.count(n2))
				{
					mapp[n2] = ++cntper;
				}
				num2 = mapp[n2];

				val = v[num2].back();
			}

			v[num1].push_back(val);
			e.push_back(num1);

			if (fl)
			{
				printf("%lld\n", val);
			}
		}
	}

	return 0;
}

/*
a=b
b=123
var=b
b=-34
{
c=b
b=1000000000
d=b
{
a=b
e=var
}
}
b=b

*/