#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <stack>
#include <time.h>
#include <unordered_map>
#include <unordered_set>
#include <string>
#include <cmath>
#include <cstdio>

using namespace std;

typedef long long ll;
typedef double dl;

ll INF = 1e9;
ll inf = 1e9;
vector<ll>pr;

bool check(ll n) {
	for (auto now : pr) {
		if (now*now > n) {
			break;
		}
		if (n%now == 0) {
			return 0;
		}
	}
	return 1;
}

int main()
{
	ll a, b;
	cin >> a >> b;
	vector<ll>good(1e6, 1);
	for (ll i = 2; i < good.size(); i++) {
		if (good[i] == 1) {
			for (ll j = i*i; j < good.size(); j += i) {
				good[j] = 0;
			}
			pr.push_back(i);
		}
	}

	vector<vector<ll>>numbers(12);
	numbers[1] = { 2,3,5,7 };
	ll p_pow = 10;
	for (ll i = 2; i < 12; i++) {
		for (ll j = 0; j < numbers[i - 1].size(); j++) {
			for (ll k = 1; k <= 9; k++) {
				if (check(k*p_pow + numbers[i - 1][j])) {
					numbers[i].push_back(k*p_pow + numbers[i - 1][j]);
				}
			}
		}
		p_pow *= 10;
	}
	ll ans = 0;
	for (ll i = 1; i < 12; i++) {
		for (ll j = 0; j < numbers[i].size(); j++) {
			if (numbers[i][j] >= a && numbers[i][j] <= b)
				ans++;
		}
	}
	cout << ans;
	return 0;
}

/*
4 3 1 3 4
4 3 3 3 3
4 2 1 2
4 4 1 2 3 4
4 3 4 3 1

*/