#include <iostream>
#include <algorithm>
#include <vector>
#include <map>
#include <string>

using namespace std;

typedef long long ll;

const int MAXN = 1e6 + 7;

vector<int> bbn[MAXN];
vector<int> vbn[MAXN];

map<string, int> stn;
int cb = 0, maxn = 0;
vector<int> nib[MAXN];

int main() {
	string cs;
	while (cin >> cs) {
		if (cs[0] == '{') {
			++cb;
			continue;
		}
		if (cs[0] == '}') {
			for (int n : nib[cb]) {
				vbn[n].pop_back();
				bbn[n].pop_back();
			}
			nib[cb].resize(0);
			--cb;
			continue;
		}
		int n = cs.size();
		string s1 = "";
		int i = 0;
		for (; cs[i] != '='; ++i)
			s1 += cs[i];
		++i;
		if (stn.find(s1) == stn.end()) {
			stn[s1] = maxn;
			++maxn;
		}
		if (!bbn[stn[s1]].size() || bbn[stn[s1]].back() != cb) {
			bbn[stn[s1]].push_back(cb);
			vbn[stn[s1]].push_back(0);
			nib[cb].push_back(stn[s1]);
		}
		int res = 0;
		if (('0' <= cs[i] && cs[i] <= '9') || cs[i] == '-') {
			bool neg = 0;
			if (cs[i] == '-') {
				neg = 1;
				++i;
			}
			for (; i < n; ++i) {
				res *= 10;
				res += cs[i] - '0';
			}
			if (neg)
				res = -res;
		} else {
			string s2;
			for (; i < n; ++i) {
				s2 += cs[i];
			}
			if (stn.find(s2) == stn.end())
				res = 0;
			else
				res = vbn[stn[s2]].back();
			cout << res << '\n';
		}
		vbn[stn[s1]].back() = res;
	}
}

