#include <bits/stdc++.h>
using namespace std;

#define pii pair<int, int>
#define fi first
#define se second
#define vi vector<int>
#define vvi vector<vi>
#define pb push_back
#define int int64_t


const int INF = 1000000000000000000;
const int m = 3;

signed main()
{
#ifdef PC
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // PC

    vector<pii> pts(m);
    for (int i = 0; i < m; ++i) {
        cin >> pts[i].fi >> pts[i].se;
    }
    sort(pts.begin(), pts.end());

    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    sort(a.begin(), a.end());
    vector<vector<int> > pref(m, vector<int>(n + 1));
    for (int j = 0; j < m; ++j) {
        for (int i = 0; i < n; ++i) {
            pref[j][i + 1] = pref[j][i] + abs(pts[j].fi - a[i]);
        }
    }

    int i = 0, j = n - 1;
    while (i < pts[0].se && i < n &&
           abs(a[i] - pts[0].fi) < abs(a[i] - pts[1].fi)
            && abs(a[i] - pts[0].fi) < abs(a[i] - pts[2].fi)) {
        ++i;
    }
    while (n - j - 1 < pts[2].se && j >= 0 &&
           abs(a[j] - pts[2].fi) < abs(a[j] - pts[0].fi)
            && abs(a[j] - pts[2].fi) < abs(a[j] - pts[1].fi)) {
        --j;
    }

    int ans = INF;
    int base_right = n - j - 1;
    if (n - i - base_right > pts[1].se) {
        int delta = n - i - base_right - pts[1].se;
        for (int add_left = 0; add_left <= delta; ++add_left) {
            int add_right = delta - add_left;
            if (i + add_left <= pts[0].se && n - j - 1 + add_right <= pts[2].se) {
                ans = min(ans, pref[0][i + add_left] +
                       pref[2][n] - pref[2][j + 1 - add_right]
                       + pref[1][j + 1 - add_right] - pref[1][i + add_left]);
            }
        }
    }
    else {
        ans = pref[0][i] + pref[2][n] - pref[2][j + 1] + pref[1][j + 1] - pref[1][i];
    }
    cout << ans << endl;

    return 0;
}

