import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.Map;

public class C {
    public static String[] code;


    static void exec(Map<String, String> vars) throws IOException {
        while (reader.ready()) {
            String command = reader.readLine();
            if (command.equals("{")) {
                exec(new HashMap<>(vars));
            } else if (!command.equals("}")) {
                String[] ss = command.split("=");
                String name = ss[0];
                String value = ss[1];
                boolean needOut = false;
                try {
                    Integer.parseInt(value);
                } catch (NumberFormatException e) {
                    needOut = true;
                    if (vars.containsKey(value)) {
                        value = vars.get(value);
                    } else {
                        value = "0";
                    }
                }
                vars.put(name, value);
                if (needOut) {
                    System.out.println(value);
                }
                ;
            } else {
                return;
            }
        }
    }

    public static BufferedReader reader;

    public static void main(String[] args) throws IOException {
        // reader = new BufferedReader(new InputStreamReader(new FileInputStream("input.in")));
        reader = new BufferedReader(new InputStreamReader(System.in));

        exec(new HashMap<String, String>());
    }
}
