#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cmath>
#include <set>
#include <algorithm>
#include <iomanip>
#include <map>
#include <string>
#include <vector>
#include <queue>
using namespace std;

#define X first
#define Y second

const long long len = 5e5;
long long x;
vector < pair < long long, long long > > g[len];
long long tp;
void ed(long long l, long long r, long long c) {
	g[l].push_back({ r, c });
	g[r].push_back({ l, c });
}

long long p[len];

map < double, vector < long long > > t;

bool used[len];
const long long inf = 1ll << 62;
long long d[len];

long long cnt = 0;

long long gt(long long v) {
	return p[v] = (p[v] == v ? v : gt(p[v]));
}

void merge(long long l, long long r) {
	l = gt(l);
	r = gt(r);
	if (l != r) {
		cnt--;
		p[l] = r;
	}
}

vector < int > gg[len];

void credge(int l, int r) {
	gg[l].push_back(tp);
	gg[tp].push_back(r);
	gg[r].push_back(tp);
	gg[tp].push_back(l);
	tp++;
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	cin >> x;
	tp = x;
	vector < pair < long long, pair < long long, long long > > > e;
	for (long long i = 0; i < x - 1; i++) {
		long long l, r, v;
		cin >> l >> r >> v;
		--l;
		--r;
		e.push_back({ v, { l, r } });
		ed(l, r, v);
	}

	for (long long i = 0; i < tp; i++) {
		p[i] = -1;
	}
	for (long long i = 0; i < tp; i++) {
		d[i] = inf;
	}

	long long y;
	cin >> y;
	priority_queue < pair < long long, long long > > q;
	for (long long i = 0; i < y; i++) {
		long long f;
		cin >> f;
		--f;
		d[f] = 0;
		q.push({ 0, f });
	}

	vector < double > tms;

	while (!q.empty()) {
		auto nw = q.top();
		q.pop();
		long long tme = -nw.first;
		long long v = nw.second;

		if (used[v])
			continue;

		t[-d[v]].push_back(v);
		used[v] = true;
		
		for (auto ed : g[v]) {
			if (d[ed.first] > d[v] + ed.second) {
				d[ed.first] = d[v] + ed.second;
				q.push({ -d[ed.first], ed.first });
			}
		}
	}

	for (int i = 0; i < e.size(); i++) {
		int l, r;
		l = e[i].second.first;
		r = e[i].second.second;
		long long f = e[i].first;
		double kek = (double)min(d[l], d[r]) +
			(double)max(0ll, f - abs(d[l] - d[r])) / 2.0 +
			(double)min(abs(d[l] - d[r]), f);

		//cout << d[l] << ' ' << d[r] << ' ' << kek << endl;

		t[-kek].push_back(tp);
		credge(l, r);
	}

	long long ans = 0;

	for (auto nw : t) {
		for (auto kek : nw.second) {
			long long v = kek;
			p[v] = v;
			cnt++;
		}
		for (auto kek : nw.second) {
			long long v = kek;
			for (auto ed : gg[v]) {
				long long to = ed;
				if (p[to] != -1) {
					merge(v, to);
				}
			}
		}
		ans = max(ans, cnt);
	}

	cout << ans;
}