#include<bits/stdc++.h>
using namespace std;
#define int long long
vector<vector<int> > rmq;
int n, m;
vector<int> th;
bool cmp(vector<int> &a, vector<int> &b){
    if (a[0] > b[0]) return true;
    if (a[0] < b[0]) return false;
    return (a[3] < b[3]);
}
int INF = 1e15;
void rev(int x){
    for (int i=0; i <= m; i++){
        rmq[x][i] = min(rmq[2*x+1][i], rmq[2*x+2][i]);
    }
}
void create(int i, int l, int r){
    if (r - l == 1){
        if (l == 0) rmq[i][0] = 0;
        return;
    }
    int mid = (l+r) / 2;
    create(2*i+1, l, mid);
    create(2*i+2, mid, r);
    rev(i);
}
void get(int i, int l, int r, int l1, int r1){
    if (l1 >= r1) return;
    if (l == l1 && r == r1){
        for (int j=0; j <= m; j++){
            th[j] = min(th[j], rmq[i][j]);
        }
        return;
    }
    int mid = (l+r) / 2;
    get(2*i+1, l, mid, l1, min(r1, mid));
    get(2*i+2, mid, r, max(l1, mid), r1);
}
void change(int i, int l, int r, int ind){
    if (r - l == 1){
        for (int j=0; j <= m; j++){
            rmq[i][j] = th[j];
        }
        return;
    }
    int mid = (l+r) / 2;
    if (ind < mid) change(2*i+1, l, mid, ind);
    else change(2*i+2, mid, r, ind);
    rev(i);
}
signed main() {
    ios_base::sync_with_stdio(false);
    cin >> n >> m;
    vector<vector<int> > v;
    for (int i=0; i < n; i++){
        int d, c, p;
        cin >> d >> c >> p;
        vector<int> help;
        help.push_back(d);
        help.push_back(c);
        help.push_back(p);
        help.push_back(i);
        v.push_back(help);
    }
    vector<vector<int> > vc = v;
    sort(v.begin(), v.end(), cmp);
    for (int i=0; i < 4*n+4; i++){
        vector<int> now;
        for (int j=0; j < m+1; j++){
            now.push_back(INF);
        }
        rmq.push_back(now);
    }
    vector<int> ind(n);
    for (int i=0; i < n; i++){
        int I = v[i][3];
        ind[I] = i;
    }
    create(0, 0, n+1);
    int ans = INF, gd = -1;
    for (int j=0; j <= m; j++) th.push_back(0);
    for (int i=0; i < n; i++){
        fill(th.begin(), th.end(), INF);
        int wh = ind[i];
        get(0, 0, n+1, 0, wh+1);
        int eat = v[i][1];
        int pr = v[i][2];
        int C = max((int) 0, m-eat);
        for (int j=C; j < m; j++){
            th[m] = min(th[m], th[j] + pr);
        }
        for (int j=m-1; j >= 0; j--){
            int nv = j - eat;
            if (nv >= 0) th[j] = th[nv] + pr;
            else th[j] = INF;
        }
        if (th[m] < ans){
            ans = th[m];
            gd = i;
        }
        change(0, 0, n+1, wh+1);
    }
    if (ans >= INF){
        cout << -1 << endl;
        return 0;
    }
    cout << ans << " ";
    vector<int> answer;
    answer.push_back(ind[gd]);
    int cop = m;
    while (gd != 0){
        int eat = v[ind[gd]][1];
        int pr = v[ind[gd]][2];
        for (int i=gd-1; i >= 0; i--){
            bool vyk = false;
            int wh = ind[i];
            get(0, 0, n+1, wh+1, wh+2);
            if (cop == m){
                int C = max((int) 0, m-eat);
                for (int j=C; j < m; j++){
                    if (th[j] + pr == ans){
                        ans -= th[j];
                        vyk = true;
                        break;
                    }
                }
            }
            else{
                int C = m - eat;
                if (th[C] + pr == ans){
                    ans -= th[C];
                    vyk = true;
                    break;
                }
            }
            if (vyk){
                gd = i;
                answer.push_back(ind[i]);
                break;
            }
        }
    }
    sort(answer.begin(), answer.end());
    cout << answer.size() << endl;
    for (int i=0; i < answer.size(); i++) cout << answer[i] + 1 << " ";
    return 0;
}

