#define _USE_MATH_DEFINES
#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <string>
#include <map>
#include <vector>
#include <set>
#include <algorithm>
#include <math.h>
#include <cmath>
#include <stack>
#include <queue>
#include <deque>
#include <climits>
#include <stdio.h>
#include <ctime>
using namespace std;

typedef long long ll;
typedef unsigned long long llu;

#define all(n) n.begin(), n.end()
#define speed ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
#define files freopen("input.txt", "rt", stdin); freopen("output.txt", "wt", stdout)
#define mp(_first, _second) make_pair(_first, _second)

struct shkol
{
	int x;
	pair<ll, ll> rs[3];
};

bool operator<(shkol a, shkol b)
{
	for (int i = 1; i < 3; ++i)
		if (abs(a.rs[i].first - a.rs[i - 1].first) != abs(b.rs[i].first - b.rs[i - 1].first))
			return abs(a.rs[i].first - a.rs[i - 1].first) > abs(b.rs[i].first - b.rs[i - 1].first);
	return a.rs[0].first > b.rs[0].first;
}

int main()
{
	//files;
	pair<ll, ll> punkt[3];
	for (int i = 0; i < 3; ++i)
		cin >> punkt[i].first >> punkt[i].second;
	int n;
	cin >> n;
	vector<shkol> q;
	for (int i = 0; i < n; ++i)
	{
		shkol x;
		cin >> x.x;
		for (int i = 0; i < 3; ++i)
			x.rs[i] = mp(abs(x.x - punkt[i].first), i);
		q.push_back(x);
	}
	for (int i = 0; i < n; ++i)
		sort(q[i].rs, q[i].rs + 3);
	sort(all(q));
	ll rz = 0;
	for (int i = 0; i < n; ++i)
	{
		int j = 0;
		while (!punkt[q[i].rs[j].second].second)
			++j;
		rz += q[i].rs[j].first;
		punkt[q[i].rs[j].second].second--;
	}
	cout << rz;
	return 0;
}