#include <algorithm>
#include <bitset>
#include <complex>
#include <deque>
#include <exception>
#include <fstream>
#include <functional>
#include <iomanip>
#include <ios>
#include <iosfwd>
#include <iostream>
#include <istream>
#include <iterator>
#include <limits>
#include <list>
#include <locale>
#include <map>
#include <memory>
#include <new>
#include <numeric>
#include <ostream>
#include <queue>
#include <set>
#include <sstream>
#include <stack>
#include <stdexcept>
#include <streambuf>
#include <string>
#include <typeinfo>
#include <utility>
#include <valarray>
#include <vector>

#define ll long long int
#pragma warning(disable : 4996)
using namespace std;

const int N = 1e5 + 100;
int t[N];
bool used[N];

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	int a, b, c, na, nb, nc, n;
	scanf("%d%d%d%d%d%d%d", &a, &na, &b, &nb, &c, &nc, &n);
	if (a > b) {
		swap(a, b);
		swap(na, nb);
	}
	if (b > c) {
		swap(b, c);
		swap(nb, nc);
	}
	if (a > b) {
		swap(a, b);
		swap(na, nb);
	}

	for (int i = 0; i < n; i++) {
		scanf("%d", &t[i]);
	}
	sort(t, t + n);

	ll ans = 0, w = 0;

	int mab = (b + a) / 2, mbc = (b + c) / 2;
	for (int i = 0; i < n && t[i] <= mab; i++) {
		if (na > 0) {
			ans += abs(a - t[i]);
			na--;
			w++;
		}
		else if (nb > 0) {
			nb--;
			w++;
			ans += abs(b - t[i]);
		}
		else {
			nc--;
			w++;
			ans += abs(c - t[i]);
		}
		used[i] = 1;
	}

	for (int i = n - 1; i >= 0 && t[i] >= mbc && nc > 0; i--) {
		if (nc > 0) {
			ans += abs(c - t[i]);
			nc--;
			w++;
		}
		else if (nb > 0) {
			nb--;
			ans += abs(b - t[i]);
			w++;
		}
		else {
			na--;
			ans += abs(a - t[i]);
			w++;
		}
		used[i] = 1;
	}
	
	ll rest = n - w, z = rest - nb - nc;
	for (int i = 0; i < n && z > 0; i++) {
		if (used[i])
			continue;
		z--;
		na--;
		ans += t[i] - a;
		used[i] = 1;
	}

	for (int i = 0; i < n; i++) {
		if (used[i])
			continue;
		if (nb > 0) {
			nb--;
			ans += abs(b - t[i]);
		}
		else {
			nc--;
			ans += abs(c - t[i]);
		}
	}

	ll mn = ans;
	int p = 0, q = n - 1;
	for (int tol = 0; tol < na; tol++) {
		while (used[p] && p < n)
			p++;
		if (p == n)
			break;
		ans += abs(t[p] - a) - abs(t[p] - b);
		p++;
		while (used[q])
			q--;
		ans += abs(t[p] - b) - abs(t[p] - c);
		q--;
		mn = min(ans, mn);
	}

	printf("%lld", mn);


	return 0;
}

  
