#include <iostream>
#include <string>

using namespace std;

int f[1001000];

int main()
{
    string s;
    cin >> s;
    if ( s[0] == '0' )
        f[0] = 0;
    else
        f[0] = 1;
    for (int i = 1; i < s.size(); i++)
        if ( s[i] == '1' )
            f[i] = f[i-1] + 1;
        else
            f[i] = f[i-1];
    int l = 0, r = s.size() - 1;
    while ( l < r ){
        int q1 = f[r] - f[l];
        int q2 = f[r-1];
        if ( l > 0 )
            q2 -= f[l-1];
        if ( q1 == q2 ){
            cout << l+2 << " " << r +1<< " " << l +1<< " " << r;
            return 0;
        }
        if ( s[l] == '0' && s[r] == '1' ){
            l++;
            continue;
        }
        if ( s[l] == '1' && s[r] == '0' ){
            r--;
            continue;
        }
        if ( s[l] == '1' && s[r] == '1' ){
            if ( q1 > q2 )
                l++;
            else
                r--;
            continue;
        }
        if ( s[l] == '0' && s[r] == '0' ){
            if ( q1 > q2 )
                r--;
            else
                l++;
            continue;
        }
    }
    return 0;
}
