#include <iostream>
#include <string>
#include <unordered_map>
#include <vector>
#include <algorithm>
#include <stack>

using namespace std;

unordered_map <string, vector <long long> > m;
stack <vector <string> > curBlock;
string str, name1, name2;
vector <string> cur;

int toInt(string str);

int main()
{
    curBlock.push(vector <string>());

    while (getline(cin, str)) {
        if (str == "{") {
            curBlock.push(vector <string>());
        }
        else if (str == "}") {
            cur = curBlock.top();
            curBlock.pop();

            for (int i = 0; i < cur.size(); i++)
                m[cur[i]].pop_back();
        }
        else {
            int pos = str.find('=');
            name1 = str.substr(0, pos);
            name2 = str.substr(pos + 1, str.size() - pos - 1);
            curBlock.top().push_back(name1);

            if ((name2[0] == '-') || ((name2[0] >= '0') && (name2[0] <= '9')))
                m[name1].push_back(toInt(name2));
            else {
                int value = 0;

                if (!m[name2].empty())
                    value = m[name2].back();

                m[name1].push_back(value);

                cout << value << endl;
            }
        }
    }

    return 0;
}

int toInt(string str) {
    long long res = 0;
    int start = 0;

    if (str[0] == '-')
        start = 1;

    for (int i = start; i < str.size(); i++)
        res = res * 10 + (str[i] - '0');

    if (start == 1)
        res *= -1;

    return res;
}
