#include <iostream>
#include <vector>
#include <set>
#include <string>
#include <algorithm>
#include <map>
#define int long long
using namespace std;
#define INF (int)1e18
//struct node
//{
//	int l, r;
//	pair<int, int> x;
//	node *left = nullptr, *right = nullptr;
//	node(int l, int r) :l(l), r(r) {
//		x = { INF, l };
//		if (r - l > 1) {
//			int m = (l + r) / 2;
//			left = new node(l, m);
//			right = new node(m, r);
//		}
//	}
//	pair<int, int> query(int L) {
//		if (L >= r)
//			return { INF, -1 };
//		if (L <= l)
//			return x;
//		return min(left->query(L), right->query(L));
//	}
//	void update(int j, int nx) {
//		if (left) {
//			int m = (l + r) / 2;
//			if (j < m)
//				left->update(j, nx);
//			else
//				right->update(j, nx);
//			x = min(left->x, right->x);
//		}
//		else
//			x.first = nx;
//	}
//};

signed main()
{
	cin.tie();
	cout.tie();
	ios::sync_with_stdio(false);
	int n, m;
	cin >> n >> m;
	vector<pair<int, pair<int, int>>> kop(n);
	map<int, vector<int>> a;
	for (int i = 0; i < n; ++i) {
		cin >> kop[i].first >> kop[i].second.first >> kop[i].second.second;
		a[kop[i].first].push_back(i);
	}
	int j = 0;
	for (const auto & x : a) {
		for (const auto & y : x.second) {
			kop[y].first = j;
		}
		++j;
	}
	vector<vector<int>> dp(m, vector<int>(j, INF));
	//vector<node*> dpc(m);
	//for (int i = 0; i < m; ++i)
	//	dpc[i] = new node(0, j);
	dp[0].back() = 0;
	//dpc[0]->update(j - 1, 0);
	vector<vector<int>> bk(m, vector<int>(j, -1));
	vector<vector<int>> pd(m, vector<int>(j, -1));
	int res = INF, bk_res = -1, pd_res = -1, x_res = -1;
	for (int i = 0; i < n; ++i) {
		for (int k = m - 1; k >= 0; --k) {
			//auto xy = dpc[k]->query(kop[i].first);
			pair<int, int> xy(INF, -1);
			for (int l = kop[i].first; l < j; ++l)
				xy = min(xy, { dp[k][l], l });
			if (k + kop[i].second.first < m) {
				if (dp[k + kop[i].second.first][kop[i].first] > xy.first + kop[i].second.second) {
					dp[k + kop[i].second.first][kop[i].first] = xy.first + kop[i].second.second;
					bk[k + kop[i].second.first][kop[i].first] = i;
					pd[k + kop[i].second.first][kop[i].first] = xy.second;
					//dpc[k + kop[i].second.first]->update(kop[i].first, dp[k + kop[i].second.first][kop[i].first]);
				}
			}
			else {
				if (res > xy.first + kop[i].second.second) {
					res = xy.first + kop[i].second.second;
					bk_res = i;
					pd_res = xy.second;
					x_res = k;
				}
			}
		}
	}
	if (bk_res == -1) {
		cout << -1;
		return 0;
	}
	cout << res << ' ';
	vector<int> ans(1, bk_res);
	int x = x_res, y = pd_res;
	while (x) {
		ans.push_back(bk[x][y]);
		y = pd[x][y];
		x -= kop[ans.back()].second.first;
	}
	reverse(ans.begin(), ans.end());
	cout << ans.size() << '\n';
	for (int i = 0; i < ans.size(); ++i)
		cout << ans[i] + 1 << ' ';
}
