import java.util.*;
import java.io.*;

public class C {
	FastScanner in;
	PrintWriter out;

	public void solve() {
		HashMap<String, Integer> mem = new HashMap<String, Integer>();

		while (in.hasNext()) {
			String s = in.next();
			if (s.compareTo("{") == 0) {
				HashMap<String, Integer> send = new HashMap<String, Integer>();
				send.putAll(mem);
				work(send);
				continue;
			}
			int i = 0;
			for (; i < s.length(); i++) {
				if (s.charAt(i) == '=')
					break;
			}

			String a = s.substring(0, i);
			String b = s.substring(i + 1);

			if (b.charAt(0) == '-' || ('0' <= b.charAt(0) && b.charAt(0) <= '9')) {
				mem.put(a, Integer.parseInt(b));
			} else {
				if (!mem.containsKey(a)) {
					mem.put(a, 0);
				}
				if (!mem.containsKey(b)) {
					mem.put(b, 0);
				}
				mem.put(a, mem.get(b));
				out.println(mem.get(b));
			}
		}
	}

	public void work(HashMap<String, Integer> mem) {
		while (true) {
			String s = in.next();
			if (s.compareTo("{") == 0) {
				HashMap<String, Integer> send = new HashMap<String, Integer>();
				send.putAll(mem);
				work(send);
				continue;
			}
			if (s.compareTo("}") == 0) {
				return;
			}
			int i = 0;
			for (; i < s.length(); i++) {
				if (s.charAt(i) == '=')
					break;
			}

			String a = s.substring(0, i);
			String b = s.substring(i + 1);

			if (b.charAt(0) == '-' || ('0' <= b.charAt(0) && b.charAt(0) <= '9')) {
				mem.put(a, Integer.parseInt(b));
			} else {
				if (!mem.containsKey(a)) {
					mem.put(a, 0);
				}
				if (!mem.containsKey(b)) {
					mem.put(b, 0);
				}
				mem.put(a, mem.get(b));
				out.println(mem.get(b));
			}
		}
	}

	public void run() {
		in = new FastScanner();
		out = new PrintWriter(new BufferedWriter(new OutputStreamWriter(System.out)));
		solve();
		out.close();
	}

	class FastScanner {
		StringTokenizer st;
		BufferedReader br;

		FastScanner() {
			br = new BufferedReader(new InputStreamReader(System.in));
		}

		String next() {
			while (st == null || !st.hasMoreTokens()) {
				try {
					st = new StringTokenizer(br.readLine());
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
			return st.nextToken();
		}

		int nextInt() {
			return Integer.parseInt(next());
		}

		long nextLong() {
			return Long.parseLong(next());
		}

		double nextDouble() {
			return Double.parseDouble(next());
		}

		boolean hasNext() {
			if (st != null && st.hasMoreTokens())
				return true;
			try {
				String s = br.readLine();
				if (s == null) {
					return false;
				} else {
					st = new StringTokenizer(s);
					return true;
				}
			} catch (IOException e) {
				e.printStackTrace();
			}
			return false;
		}
	}

	public static void main(String[] args) {
		new C().run();
	}
}
