#include <bits/stdc++.h>
using namespace std;

#define F first
#define S second
#define pb push_back
#define mp make_pair
#define fst first
#define snd second
#define rep(i,a,n) for(int i=(a);i<(n);++i)
#define per(i,a,n) for(int i=(n)-1;i>=(a);--i)
#define all(x) (x).begin(),(x).end()

template <typename T1, typename T2>
bool umin(T1 &x, const T2 &y) {if(x>y)return x=y,true; return false;}
template <typename T1, typename T2>
bool umax(T1 &x, const T2 &y) {if(x<y)return x=y,true; return false;}

template<typename T>
T getint() {
    T x = 0, p = 1;
    char ch;
    do {ch = getchar();} while(ch <= ' ');
    if (ch == '-') p = -1, ch = getchar();
    while ('0' <= ch && ch <= '9') {
        x = x*10 + ch-'0';
        ch = getchar();
    }
    return x*p;
}

typedef long long ll;
typedef long double ld;
typedef pair<int,int> pii;
typedef vector<int> vi;
typedef vector<pii> vpii;
typedef vector<ll> vll;

const int N = (int)4e3+10;
const int INF = (int)2e9+10;
const ll mod = (ll)1e9+7;
const ll LLINF = (ll)1e18+10;
const ld pi = (ld)acos(-1.0);

struct fenwick {
    int n;
    pair<ll,ll> f[4003];
    fenwick() {
        n = 4001;
        rep(i, 0, n+1) f[i] = mp(LLINF, LLINF);
    }
    pair<ll,ll> getmin(int p) {
        p = n-p;
        pair <ll, ll> res = mp(LLINF, LLINF);
        for(; p >= 0; p = (p&(p+1))-1)
            umin(res, f[p]);
        return res;
    }
    void update(int p, pair<ll, ll> val) {
        p = n-p;
        for(; p <= n; p|=p+1)
            umin(f[p], val);
    }
};

int n, m;
ll dp[N][N];
ll pr[N][N];
ll d[N], c[N], p[N];
fenwick f[4003];

int main()
{
    ios_base::sync_with_stdio(0);
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
//    cin >> n;
//    for(int i = 1; i <= n; ++i) {
//        cin >> a[i];
//    }
//    for(int i = 1; i <= n; ++i) {
//        if(a[i-1]>=a[i] || i == 1) le[i] = i;
//        else le[i] = le[i-1];
//    }
//    for(int i = n; i >= 1; --i) {
//        if(a[i+1] > a[i]) ri[i] = i;
//        else ri[i] = ri[i+1];
//    }
//    for(int i = 1; i <= n; ++i) {
//        v.pb(mp(a[i], ri[i]-le[i]+1));
//    }
    cin >> n >> m;
    vector<ll> ord;
    rep(i, 0, n) {
        cin >> d[i] >> c[i] >> p[i];
        ord.push_back(d[i]);
    }
    sort(all(ord));
    ord.erase(unique(all(ord)), ord.end());
    ll ans = LLINF;
    rep(i, 0, n) {
        rep(j, 0, m+2001) {
            dp[i][j] = LLINF;
        }
    }
    rep(i, 0, 4002) {
        f[i] = fenwick();
    }
    f[0].update(4000, mp(0, -1));
    int ai = -1, aj = -1;
    rep(i, 0, n) {
//        cout << i << endl;
        rep(j, 0, m+2001) {
            int ps = lower_bound(all(ord), d[i])-ord.begin();
            if (j < c[i]) continue;
//            cout << j-c[i]  << '-' << ps << endl;
            pair<ll,ll> mn = f[j-c[i]].getmin(ps);
//            cout << mn.fst << ' ' << mn.snd << endl;
            if (umin(dp[i][j], mn.fst+p[i])) {
                pr[i][j] = mn.snd;
            }
            if (j >= m && umin(ans, dp[i][j])) {
                ai = i;
                aj = j;
            }
        }
        rep(j, 0, m+2001) {
            if (dp[i][j] == LLINF) continue;
            if (j < c[i]) continue;
            int ps = lower_bound(all(ord), d[i])-ord.begin();
//            cout << "Update: " << j << ' ' << ps << ' ' << dp[i][j] << endl;
            f[j].update(ps, mp(dp[i][j], i));
        }
//        cout << f[1].getmin(0).fst << endl;
    }
    if (ans == LLINF) {
        cout << -1 << endl;
        return 0;
    }
    vector<int> ct;
    while (ai != -1) {
        ct.push_back(ai+1);
        int ai1 = pr[ai][aj];
        int aj2 = aj-c[ai];
        ai = ai1;
        aj = aj2;
    }
    cout << ans << ' ' << ct.size() << endl;
    sort(all(ct));
    for(int idx:ct) cout << idx << ' ';

    return 0;
}
