#include <bits/stdc++.h>

using namespace std;


string s;

pair< bool, pair< pair<int, int>, pair<int, int> > > check(int mid) {

    vector<bool> used(s.size() + 1);
    vector< pair<int, int> > a1(s.size() + 1);

    int sum = 0;
    for (int i = 0; i < mid; ++i)
        sum += s[i] - '0';
    used[sum] = true;
    a1[sum] = {1, mid};
    for (int i = 1; i + mid <= s.size(); ++i) {
        sum = sum - s[i - 1] + s[i + mid - 1];
        if (used[sum]) {
            return {true, {a1[sum], {i + 1, i + mid}}};
        } else {
            used[sum] = true;
            a1[sum] = {i + 1, i + mid};
        }
    }
    return {false, {{-1, -1}, {-1, -1}}};
}

void solve() {
    cin >> s;
    int left = 0, right = s.size();
    pair< pair<int, int>, pair<int, int> > ans;
    while (left != right - 1) {
        int mid = (left + right) >> 1;
        auto res = check(mid);
        if (res.first) {
            left = mid;
            ans = res.second;
        } else {
            right = mid;
        }
    }
    cout << ans.first.first << ' ' << ans.first.second << ' ' << ans.second.first << ' ' << ans.second.second << endl;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    solve();

    return 0;
}

