#include <iostream>
#include <string>
#include <vector>

using namespace std;

string s;

int _find(string p)
{
    for (int i = 0; i < s.length() - 1; i++)
    {
        if (s[i] == p[0] && s[i + 1] == p[1])
        {
            return i;
        }
    }
    return -1;
}

int _rfind(string p)
{
    for (int i = s.length() - 1; i > 0; i--)
    {
        if (s[i] == p[1] && s[i - 1] == p[0])
        {
            return i;
        }
    }
    return -1;
}

int main()
{
    cin >> s;
    int _min = -1, _max = -1;

    vector<string> a = {"01", "10", "00", "11"}, b = {"10", "01", "00", "11"};

    vector<int> ans1(4), ans2(4);
    for (int i = 0; i < 4; i++)
    {
        ans1[i] = _find(a[i]);
    }
    for (int i = 0; i < 4; i++)
    {
        ans2[i] = _rfind(b[i]);
    }

    for (int i = 0; i < 4; i++)
    {
        if (ans1[i] != -1 && ans2[i] != -1)
        {
            if (_min == -1)
            {
                _min = ans1[i];
                _max = ans2[i];
            }
            else if (ans2[i] - ans1[i] > _max - _min)
            {
                _min = ans1[i];
                _max = ans2[i];
            }
        }
    }
    cout << _min + 1 << " " << _max << " " << _min + 2 << " " << _max + 1;
    return 0;
}
