#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

long long cosoe(long long x1, long long y1, long long x2, long long y2){ //    ,  
    return (x1*x2+y1*y2);
}

bool check(int x1, int y1, int x2, int y2, int x3, int y3, int x4, int y4)
{
    int x = x2-x1, y=y2-y1;
    return ((cosoe(x,y,x4-x2, y4-y2) <0 || cosoe(x,y,x3-x2,y3-y2)<0) && (cosoe(-x,-y,x4-x1, y4-y1) <0 || cosoe(-x,-y,x3-x1,y3-y1)<0));
}

int main()
{
    int n, m, x, y, l, r, mid, ind;
    long double k;
    cin >> n;
    vector<pair<int, int> > point(n + 1);
    vector<pair<long double, int> > a;
    vector<int> memory; // = 0
    for (int i = 0; i < n; i++)
    {
        cin >> point[i].first >> point[i].second;
    }
    point[n].first = point[0].first;
    point[n].second = point[0].second;
    for (int i = 0; i < n; i++)
    {
        if (point[i].first == point[i + 1].first)
        {
            memory.push_back(i);
        }
        else
        {
            a.push_back(make_pair(((point[i].second - point[i + 1].second) /(long double) (point[i].first - point[i + 1].first)), i));
        }
    }
    sort(a.begin(), a.end());
    cin >> m;
    vector<pair<int, int> > point1(m + 1);
    for (int i = 0; i < m; i++)
    {
        cin >> point1[i].first >> point1[i].second;
    }
    point1[m].first = point1[0].first;
    point1[m].second = point1[0].second;
    for (int i = 0; i < m; i++)
    {
        if (point1[i].first == point1[i + 1].first)
        {
            for (int j = 0; j < memory.size(); j++)
            {
                ind = memory[j];
                if (check(point[ind].first, point[ind].second, point[ind + 1].first, point[ind + 1].second, point1[i].first, point1[i].second, point1[i + 1].first, point1[i + 1].second))

                {
                    cout << "YES" << endl;
                    cout << ind + 1 << " " << i + 1;
                    return 0;
                }
            }
        }
        else
        {
            k = ((point1[i].second - point1[i + 1].second) /(long double) (point1[i].first - point1[i + 1].first));
            l = 0;
            r = a.size() - 1;
            while (l + 1 < r)
            {
                mid = (r + l) / 2;
                if (k > a[mid].first + 0.000000001)
                {
                    l = mid;
                }
                else
                {
                    r = mid;
                }
            }
            if (abs(k - a[r].first) < 0.00000001)
            {
                ind = a[r].second;
                if (check(point[ind].first, point[ind].second, point[ind + 1].first, point[ind + 1].second, point1[i].first, point1[i].second, point1[i + 1].first, point1[i + 1].second))
                {
                    cout << "YES" << endl;
                    cout << a[r].second + 1 << " " << i + 1;
                    return 0;
                }
            }
        }
    }
    cout << "NO";
    return 0;
}
