#include <iostream>
#include <string>
#include <vector>
#include <map>
#include <set>

using namespace std;

#define rep(i, n) for (int i = 0; i < n; i++)
#define repp(i, a, b) for (int i = a; i < b; i++)
#define sz(s) (int)s.size()
#define all(v) v.begin(), v.end()

typedef long long ll;

int get_len(ll a) {
	if (a == 0) return 0;
	return get_len(a / 10) + 1;
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int n;
	cin >> n;
	vector<ll> a(n);
	ll s = 0;
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
		s += a[i];
	}
	ll mod = (ll)(1e9) + 7;
	ll ans = 0ll;
	vector<ll> pw(20, 1ll);
	for (int i = 1; i < 20; ++i) pw[i] = pw[i - 1] * 10ll;
	//for (int i = 0; i < 10; ++i) cout << pw[i] << endl;

	for (int i = 0; i < n; ++i) {
		//cout << i << " " << (s - a[i]) * pw[get_len(a[i])] << " " << a[i] * (n - 1) << endl;
		ans += (s - a[i]) * pw[get_len(a[i])];
		ans += a[i] * (n - 1);
		ans = ans % mod;
	}

	cout << ans << endl;

}