import java.math.*;
import java.util.*;

public class A {

	static int getLen(long x) {
		return ("" + x).length();
	}
	
	public static void main(String[] args) {
		Scanner in = new Scanner(System.in);
		int n = in.nextInt();
		long[] a = new long[n];
		long sum = 0;
		for (int i = 0; i < n; ++i) {
			a[i] = in.nextLong();
			sum += a[i];
		}
		
		BigInteger[] pow = new BigInteger[20];
		pow[0] = BigInteger.ONE;
		for (int i = 1; i < 20; ++i) {
			pow[i] = pow[i - 1].multiply(BigInteger.valueOf(10));
		}
		
		BigInteger ans = BigInteger.ZERO;
		
		for (int i = 0; i < n; ++i) {
			ans = ans.add(BigInteger.valueOf(sum - a[i]).multiply(pow[getLen(a[i])]));
			ans = ans.add(BigInteger.valueOf(a[i] * (n - 1)));
			ans = ans.mod(BigInteger.valueOf(1000000007));
		}
		System.out.println(ans);
		in.close();
	}

}
