//
// Created by orspc on 10.12.2017.
//

#include <iostream>
#include <map>
#include <string>
#include <vector>
#include <unordered_map>
#include <stack>

using dict = std::map<std::string, int>;

bool isNum(std::string& s) {
    if (s[0] == '-') {
        return true;
    }
    return '0' <= s[0] && s[0] <= '9';
}

int toInt(std::string& s) {
    return atoi(s.c_str());
}
std::stack<dict> st;
int main() {
       std::ios::sync_with_stdio(0);
       std::cin.tie(0);


    st.push(dict());

    std::string s;
    while (std::cin >> s) {
        if (s == "{") {
            st.push(st.top());
        } else if (s == "}") {
            st.pop();
        } else {
            std::string var1, var2;

            int i;
            for (i = 0; s[i] != '='; ++i);

            var1 = s.substr(0, i);
            var2 = s.substr(i + 1, s.size() - i - 1);

            if (isNum(var2)) {
                st.top()[var1] = toInt(var2);
            } else {
                if (st.top().count(var2)) {
                    st.top()[var1] = st.top()[var2];
                    std::cout << st.top()[var2] << '\n';
                } else {
                    st.top()[var1] = 0;
                    std::cout << 0 << '\n';
                }
            }

        }
    }
    return 0;
}
