#include <iostream>
#include <vector>
#include <cmath>

using ll = long long;

ll MOD = 1e9 + 7;

int main() {
    int n;
    std::cin >> n;
    std::vector<ll> a(n + 1);
    std::vector<ll> pr(n + 1);
    std::vector<ll> prt(n + 1);
    for (int i = 1; i <= n; ++i) {
        std::cin >> a[i];
        if (i == 1) {
            pr[i] = a[i] % MOD;
            prt[i] = (ll)pow(10, ll(log10(a[i]) + 1)) % MOD;
        } else {
            pr[i] = (pr[i - 1] + a[i]) % MOD;
            prt[i] = (prt[i - 1] + (ll)pow(10, ll(log10(a[i]) + 1))) % MOD;
        }
    }
    ll sum = 0;
    for (int i = 1; i <= n; ++i) {
        //std::cout << pr[i - 1] + prt[i - 1] << " " << pr[n] - pr[i] + prt[n] - prt[i] << "\n";
        sum += (a[i] * (prt[i - 1]) + pr[i - 1]) % MOD;
        sum += (a[i] * (prt[n] - prt[i]) + pr[n] - pr[i]) % MOD;
    }
    std::cout << sum;
    return 0;
}

