#include <bits/stdc++.h>
  
#define mp make_pair
 
typedef std::pair<long long int, int> pii;
 
const int HEI = 12, N = (1 << HEI);
const long long int MA = 10000000000000;

std::pair<long long int, int> tree[4000][N];
int bac[4000][N / 2];

void change(int a, int i, pii k)
{
    i += (N / 2);
    tree[a][i] = k;
    while (i > 1)
    {
        i >>= 1;
        if (tree[a][i] > k)
            tree[a][i] = k;
    }
}

pii get(int a, int le, int r)
{
    le += (N / 2);
    r += (N / 2);
    std::pair<long long int, int> ans = std::mp(MA, -1);
    while (r > le)
    {
        if (le & 1)
            ans = std::min(ans, tree[a][le++]);
        if (r & 1)
            ans = std::min(ans, tree[a][--r]);
        r >>= 1;
        le >>= 1;
    }
    return ans;
}

void init()
{
    for (int i = 0; i < 4000; ++i)
        for (int j = 0; j < N; ++j)
            tree[i][j] = std::mp(MA, -1);
}

void get_ans(int n, int m)
{
    init();
    int d[n], c[n], p[n];
    for (int i = 0; i < n; ++i)
        scanf("%d %d %d", d + i, c + i, p + i);
    std::pair<int, int> rad[n];
    for (int i = 0; i < n; ++i)
        rad[i] = std::mp(-d[i], i);
    std::sort(rad, rad + n);
    for (int i = 0; i < n; ++i)
    {
        int num = std::lower_bound(rad, rad + n, std::mp(-d[i], i)) - rad;
        //dp[c[i]][num] = p[i]
        change(c[i], num, std::mp((long long int)p[i], num));
        bac[c[i]][num] = -1;
        for (int j = c[i] + 1; j < 4000; ++j)
        {
            //dp[j][num] = min(dp[j - c[i]][rk]) + p[i]
            auto hl = get(j - c[i], 0, num);
            bac[j][num] = hl.second;
            change(j, num, std::mp(hl.first + p[i], num));
        }
    }
    int mia, mib;
    long long int mi = MA;
    for (int i = m; i < 4000; ++i)
        for (int j = 0; j < n; ++j)
            if (get(i, j, j + 1).first < mi)
            {
                mi = get(i, j, j + 1).first;
                mia = i;
                mib = j;
            } 
    if (mi == MA)
    {
        printf("-1\n");
        return;
    }
    std::vector<int> ans;
    while (mia > 0)
    {
        int num = rad[mib].second;
        ans.push_back(num);
        mib = bac[mia][mib];
        printf("%d\n", num);
        mia -= c[num];
    }
    std::cout << mi;
    printf(" %d\n", ans.size());
    for (int i = ans.size() - 1; i >= 0; --i)
        printf("%d ", ans[i] + 1); 
    printf("\n");
//    std::cout << mia << " " << mib << " " << mi << "\n";
}
  
int main()
{
    int n, m;
    while (scanf("%d %d", &n, &m) == 2)
        get_ans(n, m);
    return 0;
}