//#include <bits/stdc++.h>
//
//using namespace std;
//
//const int N6 = int(1e6 + 1);
//
//int p[N6];
//vector <int> pr;
//bool used[N6];
//
//vector <int> res;
//
//int len(int x) {
//    int y = 0;
//    while (x > 0) {
//        y++;
//        x /= 10;
//    }
//    return y;
//}
//
//vector <int> pow10 = {
//    10,
//    100,
//    1000,
//    10000,
//    100000,
//    1000000,
//    10000000,
//    100000000,
//    1000000000
//};
//
//int main() {
//    #ifdef MS
//        freopen("f.in", "r", stdin);
//    #else
//        ios_base::sync_with_stdio(false);
//        cin.tie(nullptr);
//        cout.tie(nullptr);
//    #endif // MS
//    for (int i = 2; i < N6; ++i) {
//        if (p[i] == 0) {
//            p[i] = i;
//            pr.push_back(i);
//        }
//        for (int j = 0; j < int(pr.size()) && pr[j] <= p[i] && i * pr[j] < N6; ++j) {
//            p[i * pr[j]] = pr[j];
//        }
//    }
//    for (int i = 0; i < int(pr.size()); ++i) {
//        int x = pr[i] % pow10();
//        used[pr[i]] = true;
//    }
//    return 0;
//}

#include <bits/stdc++.h>

using namespace std;

const long long INF = (long long)(1e18);

int main() {
    #ifdef MY
        freopen("f.in", "r", stdin);
    #else
        ios_base::sync_with_stdio(false);
        cin.tie(nullptr);
        cout.tie(nullptr);
    #endif //MY
    vector <pair <long long, long long> > d(3);
    for (long long i = 0; i < 3; ++i) {
        cin >> d[i].first >> d[i].second;
    }
    sort(d.begin(), d.end());
    long long n;
    cin >> n;
    vector <long long> x(n);
    for (long long i = 0; i < n; ++i) {
        cin >> x[i];
    }
    sort(x.begin(), x.end());
    vector <long long> p1(n, 0), p2(n, 0), p3(n, 0);
    for (long long i = 0; i < n; ++i) {
        p1[i] = abs(d[0].first - x[i]);
        p2[i] = abs(d[1].first - x[i]);
        p3[i] = abs(d[2].first - x[i]);
        if (i > 0) {
            p1[i] += p1[i - 1];
            p2[i] += p2[i - 1];
            p3[i] += p3[i - 1];
        }
    }
    long long ans = INF;
    for (long long i = -1; i < d[0].second; ++i) {
        long long cur = 0;
        if (i >= 0) cur += p1[i];
        long long L = max(-1LL, n - d[2].second);
        long long R = min(n, i + d[1].second);
        while (R - L > 2) {
            long long M1 = L + (R - L) / 3;
            long long M2 = R - (R - L) / 3;

            long long a1 = p2[M1] - (i >= 0 ? p2[i] : 0);
            long long b1 = p3[n - 1] - p3[M1];

            long long a2 = p2[M2] - (i >= 0 ? p2[i] : 0);
            long long b2 = p3[n - 1] - p3[M2];

            if (a1 + b1 < a2 + b2) {
                R = M2;
            } else {
                L = M1;
            }
        }

        vector <pair <long long, long long> > v = {
            make_pair(p2[L] - (i >= 0 ? p2[i] : 0) + p3[n - 1] - p3[L], L),
            make_pair(p2[L + 1] - (i >= 0 ? p2[i] : 0) + p3[n - 1] - p3[L + 1], L + 1),
            make_pair(p2[R] - (i >= 0 ? p2[i] : 0) + p3[n - 1] - p3[R], R),
        };

        sort(v.begin(), v.end());

        cur += v[0].first;
        ans = min(ans, cur);
    }
    cout << ans;
    return 0;
}
