#include <iostream>
#include <vector>

using namespace std;

int main()
{
    int n;
    cin >> n;

    vector<int64_t> a(n);
    for(int i = 0; i < n; i++) cin >> a[i];
    vector<int64_t> aPows(n);

    const int powsCount = 9;
    vector<int64_t> powers(powsCount);
    int64_t powValues[] = { 10, 100, 1000, 10000, 100000, 1000000, 10000000, 100000000 , 1000000000 };

    for(int i = 0; i < n; i++)
            {
                int64_t number = a[i];
                for(int j = 0; j < powsCount; j++)
                    if(number < powValues[j])
                    {
                        powers[j]++;
                        aPows[i] = j;
                        break;
                    }
            }

    int64_t answer = 0;
            int64_t module = 1000000007;
            for(int i = 0; i < n; i++)
            {
                int64_t number = a[i];
                powers[aPows[i]]--;
                answer += number * (n - 1);
                answer %= module;

                for(int j = 0; j < powsCount; j++)
                {
                    answer += number * powers[j] * powValues[j];
                    answer %= module;
                }

                powers[aPows[i]]++;
            }

            cout << answer << endl;

    return 0;
}
