#include<bits/stdc++.h>

using namespace std;

const long long INF = 1e12 + 7;
vector<long long> pref, suf, x;
long long a, b, c;
int na, nb, nc;
int n;

long long absl(long long x)
{
    if (x < 0ll)
        return -x;
    return x;
}

long long solve(long long len)
{
    long long ans = 0ll;
    if (len == 0)
        ans = 0ll;
    else
        ans += pref[len - 1];
    long long cur = suf[len];
    long long sum = 0ll;
    for (int i = len, j = 0; i < n && j < nb; i++, j++)
    {
        sum += absl(x[i] - b);
        if (i + 1 < n && suf[i + 1] != INF && sum + suf[i + 1] < cur)
            cur = sum + suf[i + 1];
        else if (i + 1 == n && sum < cur)
            cur = sum;
    }
    ans += cur;
    //cout << len << " " <<ans << endl;
    return min(INF, ans);
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    //freopen("in.txt", "r", stdin);

    cin >> a >> na;
    cin >> b >> nb;
    cin >> c >> nc;

    cin >> n;
    x = vector<long long>(n);
    for (int i = 0; i < n; i++)
        cin >> x[i];
    sort(x.begin(), x.end());


    pref = vector<long long>(n, INF);
    suf = vector<long long> (n, INF);
    for (int i = 0; i < min(n, na); i++)
        pref[i] = (i==0?0ll:pref[i - 1]) + absl(x[i] - a);
    for (int i = n - 1, j = 1; i >= 0 && j <= nc; i--, j++)
        suf[i] = (i==n-1?0ll:suf[i + 1]) + absl(x[i] - c);

    int l = max(0, n - nb - nc);
    int r = min(n + 1, na + 1);
    while (r - l > 3)
    {
        int m1 = l + (r - l) / 3;
        int m2 = l + (r - l) / 3 * 2;
        int ans1 = solve(m1);
        int ans2 = solve(m2);
        if (ans1 < ans2)
            l = m1;
        else
            r = m2;
    }
    long long ans = INF;
    for (int i = l; i <= r; i++)
    {
        ans = min(ans, solve(i));
    }
    ans = min(pref[n - 1], ans);
    if (ans == INF)
    {
        cout << 1 / 0;
    }
    cout << ans;
    return 0;
}
