#include "bits/stdc++.h"
#define puba push_back
#define ff first
#define ss second
#define bend(_x) begin(_x), end(_x)
#define szof(_x) ((int) (_x).size())
#define TASK_NAME ""

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1e9 + 7;
const ll INFL = 1e18 + 123;
const double PI = atan2(0, -1);
mt19937 tw(960172);
ll rnd(ll x, ll y) { static uniform_int_distribution<ll> d; return d(tw) % (y - x + 1) + x; }

int n;
vector<int> all;
vector<ll> pref;

ll get_sum(int l, int r) {
    return pref[r] - pref[l];
}

ll get_tot_dist(int l, int r, int pos) {
    int mid = lower_bound(all.begin() + l, all.begin() + r, pos) - all.begin();
    ll cur = (ll) pos * (mid - l) - get_sum(l, mid);
    cur += get_sum(mid, r) - (ll) pos * (r - mid);
    return cur;                 
}

int main() {
    //freopen(TASK_NAME ".in", "r", stdin);
    //freopen(TASK_NAME ".out", "w", stdout);
    cerr << fixed << setprecision(15);
    cout << fixed << setprecision(15);
    
    vector<pii> targets;
    for (int i = 0; i < 3; ++i) {
        int x, num;
        scanf("%d%d", &x, &num);
        targets.puba({x, num});
    }

    sort(bend(targets));
    
    scanf("%d", &n);

    for (int i = 0; i < n; ++i) {
        int x;
        scanf("%d", &x);
        all.puba(x);
    }
    
    sort(bend(all));

    pref.puba(0);
    for (int num : all) {
        pref.puba(pref.back() + num);
    }

    ll best = INFL;

    for (int i = max(0, n - targets[1].ss - targets[2].ss); i <= targets[0].ss; ++i) {
        ll cur = get_tot_dist(0, i, targets[0].ff);

        int mid = upper_bound(all.begin() + i, all.end(), targets[1].ff + (targets[2].ff - targets[1].ff) / 2) - all.begin();

        int part1 = mid - i;
        int part2 = n - mid;
        if (part1 > targets[1].ss) {
            part1 = targets[1].ss;
            part2 = n - i - part1;
        }
        if (part2 > targets[2].ss) {
            part2 = targets[2].ss;
            part1 = n - i - part2;
        }

        cur += get_tot_dist(i, i + part1, targets[1].ff);
        cur += get_tot_dist(i + part1, n, targets[2].ff);

        best = min(best, cur);
    }

    cout << best << "\n";
    
    #ifdef LOCAL
        cerr << "time: " << clock() << endl;
    #endif
    return 0;
}