#include <iostream>
#include <string>
#include <vector>

using namespace std;
const int maxn = 1e6 + 2221;

string s;
int p[maxn], la, ra, lb, rb, ans;
bool c[maxn];
pair < int, int > a[maxn]; 


int get (int l, int r) {                
	if (!l)
		return p[r];
	return (p[r] - p[l - 1]);
}

bool check (int len) {
	vector < bool > used(maxn, false);
	for (int i = 0, j = len - 1; j < s.size(); ++j, ++i)
		if (used[get(i, j)]) 
			return true;      
		else
			used[get(i, j)] = true;
	return false;
}

int main() {
	ios_base :: sync_with_stdio(false);
	cin >> s;
	p[0] = s[0] - '0';
	for (int i = 1; i < s.size(); ++i)
		p[i] = (s[i] - '0') + p[i - 1];

	int l = 1, r = s.size() - 1, ans = 0;
	
	while (l <= r) {
		int mid = (l + r) / 2;
		if (check(mid)) {
			ans = mid;
			l = mid + 1;	
		} else 
			r = mid - 1;
	}
	
	for (int i = 0, j = ans - 1; j < s.size(); ++j, ++i) {
		int cnt = get(i, j);
		if (c[cnt]) {
			la = i, ra = j;
			lb = a[cnt].first;
			rb = a[cnt].second;
		} else {
			c[cnt] = true;
			a[cnt] = make_pair(i, j);
		}
	}		

	cout << la + 1 << ' ' << ra + 1 << ' ' << lb + 1 << ' ' << rb + 1;
	return 0;		
}