#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define pb push_back
#define sz size()
#define fi first
#define se second
#define bb begin()
#define ee end()

const int maxn=1e5+228;
ll a,na,b,nb,c,nc;
int n;

vector<int> p(maxn);

int dsu_get(int v)
{
    return (v==p[v]) ? v : (p[v] = dsu_get(p[v]));
}

void dsu_unite(int a,int b)
{
    a=dsu_get(a);
    b=dsu_get(b);
    if(rand() & 1)
    {
        swap(a,b);
    }
    if(a!=b)
    {
        p[a]=b;
    }
}

vector<pair<ll,pair<int,int> > > g;
map<int,int> q,w;


int main()
{
    ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);
    cin >> a >> na >> b >> nb >> c >> nc >> n;
    vector<ll> u(n);
    vector<pair<ll,ll> > res;
    for(int i=0;i<n;i++)
    {
        cin >> u[i];
        ll disa=max(a,u[i])-min(a,u[i]);
        ll disb=max(b,u[i])-min(b,u[i]);
        ll disc=max(c,u[i])-min(c,u[i]);
        ll len=disa+disb+disc;
        res.pb({len,i});
    }
    sort(res.rbegin(),res.rend());
    q[n+1]=na;
    q[n+2]=nb;
    q[n+3]=nc;
    ll cost=0;
    for(int i=0;i<n;i++)
    {
        int s=res[i].se;
        ll disa=max(a,u[s])-min(a,u[s]);
        ll disb=max(b,u[s])-min(b,u[s]);
        ll disc=max(c,u[s])-min(c,u[s]);
        vector<pair<ll,int> > t;
        t.pb({disa,n+1});
        t.pb({disb,n+2});
        t.pb({disc,n+3});
        sort(t.bb,t.ee);
        for(int j=0;j<t.sz;j++)
        {
            int to=t[j].se;
            if(q[to]!=0)
            {
                cost+=t[j].fi;
                q[to]--;
                break;
            }
        }
    }
    cout << cost;
    return 0;
}
/*
0 1
3 2
6 3
4
-2 1 3 2
*/
