#include <stdio.h>
#include <bits/stdc++.h>

using namespace std;

typedef double db;
typedef long long ll;
typedef long double ld;
typedef unsigned int ui;
typedef unsigned long long ull;

typedef pair < db, db > pdd;
typedef pair < db, ld > pdl;
typedef pair < ld, db > pld;
typedef pair < ld, ld > ldp;

typedef pair < ll, ll > pll;
typedef pair < int, ll > pil;
typedef pair < ll, int > pli;
typedef pair < int, int > pii;

#define F first
#define S second

#define en end()
#define bg begin()

#define rev reverse
#define mp make_pair
#define pb push_back

#define y1 y1234567890
#define um unordered_map

#define all(x) x.bg, x.en
#define sz(x) (int)x.size()

#define sqr(x) ((x) * 1ll * (x))
#define sqrd(x) ((x) * 1.0 * (x))

#define forn(i, x) for (int i = 1; i <= x; i++)

const ll inf = (ll)1e18;
const ll mod = (ll)1e9 + 7;

const db eps = (db)1e-9;
const db pi = acos(-1.0);

const int dx[] = {0, 0, 1, 0, -1};
const int dy[] = {0, 1, 0, -1, 0};

const int N = 200500;

ll d[N];
bool u[N];
set < pli > s;
vector < pil > g[N];
vector < int > gn[N];
int n, m, ans, p[N], pr[N], sz[N];

inline bool cmp(int i, int j) {
	return d[i] > d[j];
}

int get(int v) {
	return pr[v] = (v == pr[v] ? v : get(pr[v]));
}

inline void unite(int x, int y) {
	x = get(x);
	y = get(y);
	if (sz[x] < sz[y]) {
		pr[x] = y;
		sz[y] += sz[x];
	}
	else {
		pr[y] = x;
		sz[x] += sz[y];
	}
}

int main() {
	//freopen(".in", "r", stdin);
	//freopen(".out", "w", stdout);
	//freopen(".err", "w", stderr);

	//srand(time(NULL));

	cin.tie(NULL);
	cout.tie(NULL);
	ios_base::sync_with_stdio(false);

	//cout << setprecision(10) << fixed;

	cin >> n;

	for (int i = 1; i < n; i++) {
		int x, y;
		ll z;
		cin >> x >> y >> z;
		z += z;
		g[x].pb({y, z});
		g[y].pb({x, z});
	}

	for (int i = 1; i <= n; i++)
		d[i] = inf;

	cin >> m;

	for (int i = 1; i <= m; i++) {
		int x;
		cin >> x;
		d[x] = 0;
		s.insert({d[x], x});
	}

	while (!s.empty()) {
		pli p = *s.bg;
		s.erase(s.bg);
		int v = p.S;
		for (auto i : g[v]) {
			int to = i.F;
			ll cost = i.S;
			if (d[v] + cost < d[to]) {
				s.erase({d[to], to});
				d[to] = d[v] + cost;
				s.insert({d[to], to});
			}
		}
	}

	//cout << "ok" << endl;

	m = n;

	for (int v = 1; v <= n; v++) {
		for (auto j : g[v]) {
			int to = j.F;
			if (v > to)
				continue;
			ll cur;
			if (d[v] == d[to])
				cur = (j.S >> 1);
			else {
				if (min(d[v], d[to]) + j.S <= max(d[v], d[to]))
					cur = j.S;
				else
					cur = abs(d[to] - d[v]) + (j.S - abs(d[to] - d[v])) / 2;
			}
			cur += min(d[v], d[to]);
			m++;
			d[m] = cur;
			gn[v].pb(m);
			gn[m].pb(v);
			gn[to].pb(m);
			gn[m].pb(to);
		}
	}

	/*cout << m << endl;

	for (int i = 1; i <= m; i++)
		cout << d[i] << " ";
	cout << endl;*/

	for (int i = 1; i <= m; i++)
		p[i] = i;
		
	sort(p + 1, p + 1 + m, &cmp);

	/*for (int i = 1; i <= m; i++)
		cout << d[p[i]] << " ";
	cout << endl;*/

	//return 0;

	for (int i = 1; i <= m; i++) {
		pr[i] = i;
		sz[i] = 1;
	}

	int cnt = 0;

	for (int i = 1; i <= m; i++) {
		int j = i;
		//cout << i << " ";
		while (j < m && d[p[i]] == d[p[j + 1]])
			j++;
		//cout << j << endl;
		for (int k = i; k <= j; k++) {
			u[p[k]] = 1;
			cnt++;
		}
		//cout << "done" << endl;
		for (int k = i; k <= j; k++) {
			int v = p[k];
			for (auto to : gn[v]) {
				if (u[to] && get(v) != get(to)) {
					unite(v, to);
					cnt--;
				}
			}
		}
		ans = max(ans, cnt);
		i = j;
		//cout << "done" << endl;
	}

	cout << ans;

	//cerr << (clock() + 0.0) / CLOCKS_PER_SEC;

	return 0;
}
