#include <stdio.h>
#include <bits/stdc++.h>

using namespace std;

typedef double db;
typedef long long ll;
typedef long double ld;
typedef unsigned int ui;
typedef unsigned long long ull;

typedef pair < db, db > pdd;
typedef pair < db, ld > pdl;
typedef pair < ld, db > pld;
typedef pair < ld, ld > ldp;

typedef pair < ll, ll > pll;
typedef pair < int, ll > pil;
typedef pair < ll, int > pli;
typedef pair < int, int > pii;

#define F first
#define S second

#define en end()
#define bg begin()

#define rev reverse
#define mp make_pair
#define pb push_back

#define y1 y1234567890
#define um unordered_map

#define all(x) x.bg, x.en
#define sz(x) (int)x.size()

#define sqr(x) ((x) * 1ll * (x))
#define sqrd(x) ((x) * 1.0 * (x))

#define forn(i, x) for (int i = 1; i <= x; i++)

const ll inf = (ll)1e18;
const ll mod = (ll)1e9 + 7;

const db eps = (db)1e-9;
const db pi = acos(-1.0);

const int dx[] = {0, 0, 1, 0, -1};
const int dy[] = {0, 1, 0, -1, 0};

const int N = 4050;

int n, m, d[N], c[N], p[N], pr[N][N], pos[N], suff[N], comp[N];
ll dp[N][N];
pair < ll, int > t[N][N * 4];

void build(int v, int tl, int tr, int lvl)
{
	if (tl == tr)
	{
		t[lvl][v] = {inf, tl};
		return;
	}
	int mid = (tl + tr) / 2;
	build(v + v, tl, mid, lvl);
	build(v + v + 1, mid + 1, tr, lvl);
	t[lvl][v] = min(t[lvl][v + v], t[lvl][v + v + 1]);
}

void upd(int id, int v, int tl, int tr, ll val, int lvl)
{   
	if (tl == tr)
	{
		t[lvl][v].first = min(t[lvl][v].first, val);
		return;
	}
	int mid = (tl + tr) / 2;
	if (id <= mid)
		upd(id, v + v, tl, mid, val, lvl);
	else
		upd(id, v + v + 1, mid + 1, tr, val, lvl);
	t[lvl][v] = min(t[lvl][v + v], t[lvl][v + v + 1]);	
}

pair < ll, int > get(int l, int r, int v, int tl, int tr, int lvl)
{
	if (tr < l || tl > r)
		return {inf, -1};
	if (tl >= l && tr <= r)
		return t[lvl][v];
	int mid = (tl + tr) / 2;
	return min(get(l, r, v + v, tl, mid, lvl), get(l, r, v + v + 1, mid + 1, tr, lvl));
}

bool cmp(int i, int j)
{
	return d[i] < d[j];
}

int main() {
	//freopen(".in", "r", stdin);
	//freopen(".out", "w", stdout);
	//freopen(".err", "w", stderr);

	//srand(time(NULL));

	//cin.tie(NULL);
	//cout.tie(NULL);
	//ios_base::sync_with_stdio(false);

	//cout << setprecision(10) << fixed;

	cin >> n >> m;
	forn(i, n)
	{
		cin >> d[i] >> p[i] >> c[i];
		pos[i] = i;
	}
	int big = 4000;
	for (int i = 0; i <= big; i++)
	{
		build(1, 1, n, i);
		for (int j = 1; j <= n; j++)
			dp[j][i] = inf;
	}	
	sort(pos + 1, pos + n + 1, &cmp);
	int cur = 0;
	forn(i, n)
	{
		if (i == 1 || d[pos[i]] != d[pos[i - 1]])
			cur = i;
		suff[pos[i]] = cur;
		comp[pos[i]] = i;
	}
	forn(i, n)
	{
		dp[i][p[i]] = c[i];
		pr[i][p[i]] = 0;
		for (int j = p[i] + 1; j <= big; j++)
		{
			pair < ll, int > res = get(suff[i], n, 1, 1, n, j - p[i]);
			if (dp[i][j] > res.first + c[i])
			{
				dp[i][j] = res.first + c[i];
				pr[i][j] = pos[res.second];
			}
		}
		for (int j = 0; j <= big; j++)
			upd(comp[i], 1, 1, n, dp[i][j], j);
	}
	ll mn = inf;
	int x = -1, y = 0;
	forn(i, n)
	{
		for (int j = m; j <= big; j++)
		{
			if (dp[i][j] < mn)
			{	
				mn = dp[i][j];
				x = i, y = j;
			}
		}	
	}
	if (mn == inf)
	{
		cout << -1 << endl;
		return 0;
	}
	cout << mn << ' ';
	vector < int > v;
	while(x)
	{
		v.pb(x);
		int nxt = pr[x][y];
		y -= p[x];
		x = nxt;
	}
	reverse(all(v));
	cout << (int)v.size() << endl;
	for (int i = 0; i < (int)v.size(); i++)
		cout << v[i] << ' ';

	//cerr << (clock() + 0.0) / CLOCKS_PER_SEC;

	return 0;
}
