#include <bits/stdc++.h>

#define F first
#define S second
#define SZ(x) (int)x.size()
#define pb push_back

typedef long long ll;

using namespace std;

const int N = 200005;

int p[N], n, curans;
ll d[N];
vector <pair <int, ll> > a[N];
bool was[N];

int dad(int v) {
	if (p[v] == v) return v;
	return p[v] = dad(p[v]);
}

inline void unit(int x, int y) {
	   x = dad(x);
	   y = dad(y);
	   if (x != y) 
	   	  p[x] = y, curans--;	
}

int main() {
	#ifdef COMP
	freopen (".in", "r", stdin);
	freopen (".out", "w", stdout);
	#endif
	ios_base::sync_with_stdio(0);
	cin >> n;
	vector <pair<pair <int, int>, ll> > edge;
	for (int i = 1; i < n; i++) {
	    int x, y, w;
		cin >> x >> y >> w;	
		edge.pb({{x, y}, w});
		a[x].pb({y, w});
		a[y].pb({x, w});
	}
	for (int i = 1; i <= n; i++) {
		d[i] = ll(1e18);	
	} 
	int m;
	cin >> m;
	set <pair <ll, int> > s;
	for (int i = 1; i <= m; i++) {
		int x;
		cin >> x;
		d[x] = 0;
		s.insert({d[x], x});
	}
	while (s.size() > 0) {
		  int v = (*s.begin()).S;
		  s.erase(s.begin());
		  for (auto par : a[v]) {
			  int to = par.F;
			  ll len = par.S;
			  if (d[to] > d[v] + len) {
			  	 s.erase({d[to], to});
			  	 d[to] = d[v] + len;
			  	 s.insert({d[to], to});
			  }		  
		  }
	}
	vector <pair <ll, int> > order;
	for (int i = 1; i <= n; i++) {
		order.pb({d[i], i});
		p[i] = i;
	}
	for (auto par : edge) {
		int x = par.F.F;
		int y = par.F.S;
		ll len = par.S;
		if (len <= abs(d[x] - d[y])) continue;
		n++;
		len -= abs(d[x] - d[y]);
		d[n] = len / 2;
		if (len % 2 == 1) d[n]++;
		a[n].pb({y, 1});
		a[n].pb({x, 1});
		a[x].pb({n, 1});
		a[y].pb({n, 1});
		order.pb({d[n], n});	
	}
	sort(order.begin(), order.end());
	reverse(order.begin(), order.end());
	int ans = 0;
	for (int i = 0; i < SZ(order); i++) {
		if (order[i].F == 0) break;
		vector <int> vec;
		while (order[i].F == order[i + 1].F) {
			  vec.pb(order[i].S);
			  was[order[i].S] = 1;
			  i++;
		}
		vec.pb(order[i].S);
		for (auto v : vec) {
	        int cnt = 0;
	        curans++;
			for (auto par : a[v]) {
				int to = par.F;
				if (was[to]) 
				   unit(v, to);
			}
		}
		ans = max(ans, curans);
	}
	cout << ans;
	return 0;
}