#include <bits/stdc++.h>

#define F first
#define S second
#define SZ(x) (int)x.size()
#define pb push_back

typedef long long ll;

using namespace std;

const int N = 3222;

pair<ll, int> t[N * 2][N * 5];

pair<int, int> pr[N * 2][N];

struct kop {
	int d, c, p;
};
                          
kop arm[N];

void compress(int n) {
	vector<pair<int, int> > v;
	for (int i = 1; i <= n; i++) {
		v.pb({arm[i].d, i});
	}  
	sort(v.begin(), v.end());
	int now = 1;
	arm[v[0].S].d = now;
	for (int i = 1; i < SZ(v); i++) {
		if (v[i].F > v[i - 1].F) now++;
		arm[v[i].S].d = now;	
	}
}

void build(int v1, int v, int l, int r, ll x) {
	if (l == r) {
		t[v1][v] = {x, l};
		return;
	}
	int mid = (l + r) / 2;
	build(v1, v + v, l, mid, x);
	build(v1, v + v + 1, mid + 1, r, x);
	t[v1][v] = {x, t[v1][v + v].S};
}

void upd(int v1, int v, int l, int r, int pos, ll x) {
	if (l == r) {
		t[v1][v].F = x;
		t[v1][v].S = pos;
		return;
	}
	int mid = (l + r) / 2;
	if (pos <= mid) upd(v1, v + v, l, mid, pos, x);
	else upd(v1, v + v + 1, mid + 1, r, pos, x);
	if (t[v1][v + v].F < t[v1][v + v + 1].F) {
		t[v1][v] = t[v1][v + v]; 
	}                           
	else t[v1][v] = t[v1][v + v + 1];
}

pair<ll, int> get(int v1, int v, int l, int r, int L, int R) {
	if (r < L || l > R || L > R) return {(ll)1e15, (int)1e9};
	if (L <= l && R >= r) return t[v1][v];
	int mid = (l + r) / 2;
	return min(get(v1, v + v, l, mid, L, R), get(v1, v + v + 1, mid + 1, r, L, R));
}

int Rand() {
	int x = ((rand() << 10) | (rand() << 20) | rand()) % (int)1e9;
	if (x < 0) x += 1e9;
	return x;
}

int main() {
	unsigned int ko;
	asm("rdtsc" : "=A"(ko));
	srand(ko);
	
	#ifdef COMP
	freopen (".in", "r", stdin);
	freopen ("1.out", "w", stdout);
	#endif
	int n, m;
	cin >> n >> m;
	//n = 2000, m = 2000;
	for (int i = 1; i <= n; i++) {
		scanf("%d %d %d", &arm[i].d, &arm[i].c, &arm[i].p);
		//arm[i].d = Rand(), arm[i].c = Rand() % 2000 + 1, arm[i].p = Rand();
	}
	compress(n);
	build(0, 1, 1, n, 0);                                                                               
	for (int i = 1; i <= m + 2001; i++) build(i, 1, 1, n, (ll)1e15);
	for (int i = 1; i <= n; i++) {
		for (int j = m - 1; j >= 0; j--) {
			pair<ll, int> mn = get(j, 1, 1, n, arm[i].d, n);
			if (mn.F == (ll)1e15) continue;
			int now = j + arm[i].c;
			if (get(now, 1, 1, n, arm[i].d, arm[i].d).F > mn.F + (ll)arm[i].p) {
				pr[now][arm[i].d] = {i, mn.S};
				upd(now, 1, 1, n, arm[i].d, mn.F + (ll)arm[i].p);
			}
		}			
	}
	ll ans = (ll)1e15;
	int lay = -1, diam = -1;
	for (int i = m; i <= m + 2001; i++) {
		pair<ll, int> now = get(i, 1, 1, n, 1, n);
		if (ans > now.F) {
			ans = now.F;
			lay = i;
			diam = now.S;
		}
	}
	if (ans >= (ll)1e15) {
		cout << -1;
		return 0;
	}
    vector<int> out;
    while (lay > 0) {
    	out.pb(pr[lay][diam].F);
    	int nex = lay - arm[pr[lay][diam].F].c;
    	diam = pr[lay][diam].S;
   		lay = nex;          
    }
    sort(out.begin(), out.end());
    reverse(out.begin(), out.end());
    while (out.back() == 0) out.pop_back();
    reverse(out.begin(), out.end());
    int koo = 0;
    ll now = 0;
    for (auto i : out) {
    	now += arm[i].p;
    	koo += arm[i].c;
    }
    if (koo < m) assert(0);
    
    printf("%lld %d\n", now, SZ(out));
    for (auto i : out) printf("%d ", i);                                      
	
	return 0;
}