#include <iostream>
#include <map>
#include <string>
#include <stack>
#include <set>
#include <algorithm>
#include <xhash>
using namespace std;

pair<__int64, int> vr[3];

__int64 suma = 0;
multiset<int> ars[4];
//fill s - school with pupils from r - region
void _fr(int s, int r) {

	while (ars[r].size() && vr[s].second) {
		suma += abs(*(--ars[r].end()) - vr[s].first);

		//cout << *(--ars[r].end()) << ' ' << vr[s].first << endl;

		vr[s].second--;
		ars[r].erase((--ars[r].end()));
	}
}

void _fl(int s, int r) {

	while (ars[r].size() && vr[s].second) {
		suma += abs(*(ars[r].begin()) - vr[s].first);
		
		//cout << *(ars[r].begin()) << ' ' << vr[s].first << endl;
		
		vr[s].second--;
		ars[r].erase((ars[r].begin()));
	}
}



int main() {
#ifdef _DEBUG
	freopen("test.in", "r", stdin);
	//freopen("test.out", "w", stdout);

#endif

	ios::sync_with_stdio(0);
	cin >> vr[0].first >> vr[0].second;
	cin >> vr[1].first >> vr[1].second;
	cin >> vr[2].first >> vr[2].second;

	sort(vr, vr + 3);

	int n;
	cin >> n;
	multiset<__int64> ar;
	for (int i = 0; i < n; ++i) {
		int t;
		cin >> t;
		ar.insert(t);
	}

	for (auto i = ar.begin(); i != ar.upper_bound((vr[0].first + vr[1].first) / 2); ++i) {
		ars[0].insert(*i);
	}

	for (auto i = ar.upper_bound((vr[0].first + vr[1].first) / 2); i != ar.lower_bound(vr[1].first); ++i) {
		ars[1].insert(*i);
	}

	for (auto i = ar.lower_bound(vr[1].first); i != ar.upper_bound((vr[1].first + vr[2].first) / 2); ++i) {
		ars[2].insert(*i);
	}

	for (auto i = ar.lower_bound((vr[1].first + vr[2].first + 1) / 2); i != ar.end(); ++i) {
		ars[3].insert(*i);
	}

	_fl(0, 0);

	_fr(2, 3);

	if (!vr[0].second) // leftmost is full
	{
		_fl(1, 0);
		_fl(1, 1);
		_fl(1, 2);
		_fl(1, 3);

		_fr(2, 0);
		_fr(2, 1);
		_fr(2, 2);
		_fr(2, 3);

		cout << suma << endl;
		return 0;
	}

	if (!vr[2].second) // rightmost is full
	{
		_fr(1, 3);
		_fr(1, 2);
		_fr(1, 1);
		_fr(1, 0);

		_fl(0, 0);
		_fl(0, 1);
		_fl(0, 2);
		_fl(0, 3);

		cout << suma << endl;
		return 0;
	}



	int butter = __max(ars[0].size() + ars[1].size() - vr[1].second, 0u);
	while (butter && vr[0].second && vr[2].second && ars[1].size() && ars[2].size())
	{
		int pl = (*ars[1].begin() - vr[0].first) - (vr[1].first - *ars[1].begin()), pr = (vr[2].first - *(--ars[2].end())) - (*(--ars[2].end()) - vr[1].first);
		if (pl < pr)
		{
			suma += (*ars[1].begin() - vr[0].first);

			//cout << *(ars[1].begin()) << ' ' << vr[0].first << endl;

			ars[1].erase(ars[1].begin());
			vr[0].second--;
		}
		else {
			suma += (vr[2].first - *(--ars[2].end()));

			//cout << *(--ars[2].end()) << ' ' << vr[2].first << endl;

			ars[2].erase(--ars[2].end());
			vr[2].second--;
		}
		--butter;
	}



	


	if (!vr[2].second) // rightmost is full
	{
		_fr(1, 3);
		_fr(1, 2);
		_fr(1, 1);
		_fr(1, 0);

		_fl(0, 0);
		_fl(0, 1);
		_fl(0, 2);
		_fl(0, 3);

		cout << suma << endl;
		return 0;
	}

	if (!vr[0].second) // leftmost is full
	{
		_fl(1, 0);
		_fl(1, 1);
		_fl(1, 2);
		_fl(1, 3);

		_fr(2, 0);
		_fr(2, 1);
		_fr(2, 2);
		_fr(2, 3);

		cout << suma << endl;
		return 0;
	}

	if (!vr[1].second) // middle is full
	{

		for (auto i : ars[1]) {
			if (vr[0].second && ((i - vr[0].first) <= (vr[2].first - i) || !vr[2].second)) {
				suma += (i - vr[0].first);
				vr[0].second--;
			}
			else if (vr[2].second && ((i - vr[0].first) >= (vr[2].first - i) || !vr[0].second)) {
				suma += (vr[2].first - i);
				vr[2].second--;
			}

		}

		for (auto i : ars[2]) {
			if (vr[0].second && ((i - vr[0].first) <= (vr[2].first - i) || !vr[2].second)) {
				suma += (i - vr[0].first);
				vr[0].second--;
			}
			else if (vr[2].second && ((i - vr[0].first) >= (vr[2].first - i) || !vr[0].second)) {
				suma += (vr[2].first - i);
				vr[2].second--;
			}

		}


		cout << suma << endl;
		return 0;
	}
	cout << suma << endl;

	return 0;
}