#include <iostream>
#include <string>
#include <map>
#include <stack>

using namespace std;

stack <map <string, int> > s;

int pows[] = {
	1,
	10,
	100,
	1000,
	10000,
	100000,
	1000000,
	10000000,
	100000000,
	1000000000
};

void parse(string& s, string& a, string& b) {
	bool f = true;
	a = "";
	b = "";
	for (char c : s) {
		if (c == '=')
			f = false;
		else
			(f ? a : b) += c;
	}
}

int parseInt(string& a) {
	int ans = 0;
	bool kek = true;
	if (a[0] == '-')
		kek = false;
	for (int i = kek ? 0 : 1; i < a.size(); ++i) {
		ans += (a[i] - '0') * pows[a.size() - i - 1];
	}
	return kek ? ans : -ans;
}

int main() {
	string com, a, b;
	map <string, int> mp;
	s.push(mp);
	while (cin >> com) {
		if (com == "{") {
			auto newMap = s.top();
			s.push(newMap);
			continue;
		}
		if (com == "}") {
			s.pop();
			continue;
		}
		map<string, int>& cur = s.top();
		parse(com, a, b);
		if (b[0] >= '0' && b[0] <= '9' || b[0] =='-') {
			int bb = parseInt(b);
			cur[a] = bb;
		}
		else {
			if (cur[b]) {
				cur[a] = cur[b];
				cout << cur[b] << endl;
			}
			else {
				cur[a] = 0;
				cout << 0 << endl;
			}
		}
	}
	return 0;
}