#define M_E        2.71828182845904523536   // e
#define M_LOG2E    1.44269504088896340736   // log2(e)
#define M_LOG10E   0.434294481903251827651  // log10(e)
#define M_LN2      0.693147180559945309417  // ln(2)
#define M_LN10     2.30258509299404568402   // ln(10)
#define M_PI       3.14159265358979323846   // pi
#define M_PI_2     1.57079632679489661923   // pi/2
#define M_PI_4     0.785398163397448309616  // pi/4
#define M_1_PI     0.318309886183790671538  // 1/pi
#define M_2_PI     0.636619772367581343076  // 2/pi
#define M_2_SQRTPI 1.12837916709551257390   // 2/sqrt(pi)
#define M_SQRT2    1.41421356237309504880   // sqrt(2)
#define M_SQRT1_2  0.707106781186547524401  // 1/sqrt(2)
#include <iostream>
#include <fstream>
#include <sstream>
#include <cmath>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <stack>
#include <string>
#include <unordered_map>
#include <unordered_set>

using namespace std;

#define IN_FILE "in.txt"
#define OUT_FILE "out.txt"

#define EPS 1e-6
#define INF 1e18
#define SMALL_INF 1e8

#pragma warning (disable : 4996)

vector<pair<long long, long long>> nx;
vector<long long> x;
int n;

bool cmp (pair<long long, long long> a, pair<long long, long long> b) {
	return a.second < b.second;
}

int getNotNull () {
	for (int i = 0; i < 3; i++)
		if (nx[i].first)
			return i;
}

int main()
{
#ifdef  _DEBUG
	freopen (IN_FILE, "r", stdin);
	freopen (OUT_FILE, "w", stdout);
#endif
	nx.resize (3);
	int mmin = 1e9, mmax = -1e9;
	for (int i = 0; i < 3; i++) {
		cin >> nx[i].second >> nx[i].first;
	}
	sort (nx.begin (), nx.end (), cmp);
	cin >> n;
	x.resize (n);
	for (int i = 0; i < n; i++) {
		cin >> x[i];
	}
	sort (x.begin (), x.end ());
	long long ans = 0;
	for (int i = 0; i < n; i++) {
		int j = getNotNull ();
		ans += abs (x[i] - nx[j].second);
		nx[j].first--;
	}
	cout << ans << endl;
    return 0;
}

