#include <map>
#include <iostream>
#include <list>
#include <cstring>

using namespace std;

bool isN(const char *ch) {
    do {
        if ((*ch < '0' || *ch > '9') && *ch != '-')
            return false;
    } while (*(++ch) != 0);
    return true;
}

int getVar(const list<map<size_t, int>> &st, const size_t name) {
    for (auto i = st.crbegin(); i != st.crend(); i++) {
        auto j = i->find(name);
        if (j != i->end())
            return j->second;
    }
    return 0;
}

int main() {
    cin.tie({0});
    cin.sync_with_stdio(false);
    cout.tie({0});
    cout.sync_with_stdio(false);

    string s = "{";
    list<map<size_t, int>> st;
    do {
        if (s[0] == '{')
            st.push_back(map<size_t, int>());
        else if (s[0] == '}')
            st.pop_back();
        else {
            int n = s.find('=');
            size_t a = _Hash_bytes(s.c_str(), n, 1337);
//            string b = s.substr(n + 1, s.length() - n - 1);

            if (isN(s.c_str() + n + 1)) {
                st.back()[a] = atoi(s.c_str() + n + 1);
            } else {
                int t = getVar(st, _Hash_bytes(s.c_str() + n + 1, s.length() - n - 1, 1337));
                st.back()[a] = t;
                cout << t << endl;
            }
        }
    } while (cin >> s);
}

/*

a=b
b=123
var=b
b=-34
{
c=b
b=1000000000
d=b
{
a=b
e=var
}
}
b=b



 */