#include <iostream>
#include <cstdio>
#include <vector>
#include <set>
#include <algorithm>
#include <cmath>
#include <string>
#define P(x) {std::cerr << #x << " = " << x << std::endl;}
const int INF = 1000000000;

using namespace std;
vector < int > NextV;
vector < int > PrevV;


bool isPr(long long a){
    long long b = sqrt(a);
    for(int i = 2;i <= b;i++){
        if(a%i == 0){
            return false;
        }
    }
    return true;
}

long long VCount(long long a){
    long long ans = 0;
    while(a != 0){
        a/=10;
        ans++;
    }
    return ans;
}

int main(){
    long long a[] = {1,
                   10,
                   100,
                   1000,
                   10000,
                   100000,
                   1000000,
                   10000000,
                   100000000,
                   1000000000,
                   10000000000,
                   100000000000,
                   1000000000000,
                   10000000000000}; //13
    long long fa,b,f,temp,counter = 0,lowRate;
    cin >> fa >> b;
    //P(fa);
    NextV.push_back(2);
    NextV.push_back(3);
    NextV.push_back(5);
    NextV.push_back(7);
    f = VCount(b);
    lowRate = VCount(fa);
    for(int i = 0;i<NextV.size();i++){
        if(NextV[i] >= fa && NextV[i] <= b){
            counter++;
            //cout << NextV[i] << endl;
        }
    }
    for(int i = 2;i < f+1 ;i++){
        PrevV = NextV;
        NextV.clear();
        if(i < lowRate){
            for(int j = 0;j < PrevV.size();j++){
                temp = PrevV[j];
                for(int l = 0;l < 9;l++){
                    temp += a[i-1];
                    if(isPr(temp)){
                        NextV.push_back(temp);
                    }
                }
            }
        }else{ //copypasta
            for(int j = 0;j < PrevV.size();j++){
                temp = PrevV[j];
                for(int l = 0;l < 9;l++){
                    temp += a[i-1];
                    if(isPr(temp)){
                        NextV.push_back(temp);
                        if(temp >= fa && temp <= b){
                            // << temp << endl;
                            counter++;
                        }
                    }
                }
            }
        }
        //P(i);
        //for(int k =0;k<NextV.size();k++){
        //    cout << NextV[k] << ' ';
        //}
    }
    cout << counter;
    return 0;
}
