#include <bits/stdc++.h>
#define all(x) begin(x), end(x)
#define sz(x) ((int)(x).size())
using namespace std;
using ll = long long; using ld = long double; using ull = unsigned ll;
const int maxn = 2e3;
const int mod = 1e9 + 7;
const ll INF = 1e18;

int n, m, d[maxn], c[maxn], p[maxn], tmp, lst, ost;
ll pr[maxn][maxn];
map<int, int> re;

struct segTree {
    vector<vector<pair<ll, int>>> t;
    segTree() : t(2 * tmp, vector<pair<ll, int>>(m, {INF, -1})) { for(int i = 0; i < 2 * tmp; i++) t[i][0] = {0, -1}; }
    void upd(int v, vector<pair<ll, int>> &vec) {
        t[v += tmp] = vec;
        for(v >>= 1; v; v >>= 1)
            for(int i = 0; i < t[v].size(); i++)
                t[v][i] = min(t[v * 2][i], t[v * 2 + 1][i]);
    }
    pair<ll, int> get(int l, int r, int pos) {
        pair<ll, int> ret = {INF, -1};
        for(l += tmp, r += tmp; l <= r; l = (l + 1) >> 1, r = (r - 1) >> 1) {
            if(l & 1) ret = min(ret, t[l][pos]);
            if(!(r & 1)) ret = min(ret, t[r][pos]);
        }
        return ret;
    }
};

int main() {
    ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    //freopen("in.txt", "r", stdin);
    cin >> n >> m;
    for(int i = 0; i < n; i++) {
        cin >> d[i] >> c[i] >> p[i];
        re[d[i]];
    }
    for(auto it = re.begin(); it != re.end(); it++) it->second = tmp++;
    segTree t;
    ll ans = INF;
    for(int i = 0; i < n; i++) {
        int me = re[d[i]];
        vector<pair<ll, int>> vec(m, {INF, i});
        vec[0] = {0, i};
        for(int j = 1; j < m; j++)
            if(j >= c[i]) {
                pair<ll, int> prev = t.get(me, tmp - 1, j - c[i]);
                if(prev.first != INF) {
                    vec[j] = {prev.first + p[i], i};
                    pr[i][j] = prev.second;
                }
            }
        pair<ll, int> mem;
        for(int j = m; j < 2 * m; j++)
            if(0 <= j - c[i] && j - c[i] < m)
                if(p[i] + (mem = t.get(me, tmp - 1, j - c[i])).first < ans) {
                    ans = p[i] + mem.first;
                    lst = i;
                    ost = j;
                }
        t.upd(me, vec);
    }
    int hi = -1;
    for(int i = 0; i < n; i++)
        if(hi == -1 || c[i] > c[hi])
            hi = i;
    if(hi != -1 && p[hi] < ans) {
        cout << p[hi] << ' ' << 1 << '\n' << hi + 1;
        return 0;
    }
    if(ans == INF) return cout << -1, 0;
    vector<int> id;
    while(ost) {
        id.push_back(lst);
        ll memost = ost;
        ost -= c[lst];
        lst = pr[lst][memost];
    }
    sort(all(id));
    cout << ans << ' ' << id.size() << '\n';
    for(int x : id) cout << x + 1 << ' ';
}
