import sys
import re

lines = sys.stdin.read().split("\n")

vars = [dict()]
curr_level = 0
num_pattern = re.compile('[-0-9]+')

for line in lines:
    if line == "{":
        curr_level += 1
        vars.append(dict(vars[-1]))
    elif line == "}":
        del(vars[-1])
        curr_level -= 1
    elif len(line) == 0:
        break
    else:
        a, b = line.rstrip().split("=")
        if num_pattern.search(b) is None:
            if b in vars[curr_level]:
                vars[curr_level][a] = vars[curr_level][b]
            else:
                vars[curr_level][a] = 0
                vars[curr_level][b] = 0
            print(vars[curr_level][a])
        else:
            vars[curr_level][a] = b
