import sys
import re
import threading
from queue import deque
sys.setrecursionlimit(10**9)
threading.stack_size(67108864)
def main():
    lines = deque(sys.stdin.read().split("\n"))

    vars = [dict()]
    curr_level = 0
    num_pattern = re.compile('[-0-9]+')

    for i in range(len(lines)):
        line = lines[0]
        if line == "{":
            curr_level += 1
            vars.append(dict(vars[-1]))
        elif line == "}":
            del(vars[-1])
            curr_level -= 1
        elif len(line) == 0:
            break
        else:
            a, b = line.rstrip().split("=")
            if num_pattern.search(b) is None:
                if b in vars[curr_level]:
                    vars[curr_level][a] = vars[curr_level][b]
                else:
                    vars[curr_level][a] = 0
                print(vars[curr_level][a])
            else:
                vars[curr_level][a] = b
        lines.popleft()

thread = threading.Thread(target=main)
thread.start()