#include <iostream>
#include <cstdint>
#include <iterator>
#include <utility>
#include <algorithm>
#include <string>
#include <vector>
#include <unordered_set>

using namespace std;

int main()
{
	string line;
	getline(cin, line);
	const auto n = line.length();
	vector<uint32_t> arr(n + 1);
	arr[1] = (line[0] == '1') ? 1 : 0;
	for (uint32_t i = 1; i < n; i++) {
		arr[i + 1] = arr[i] + ((line[i] == '1') ? 1 : 0);
	}
	uint32_t l = 1, r = n + 1, m;
	uint32_t l_i = 0, l_m = 0, l_count = 0;
	while (r - l > 1) {
		m = l + (r - l) / 2;
		bool canFind = false;
		unordered_set<uint32_t> counts;
		for (uint32_t i = 2; i <= n - m + 2; i++)
		{
			const auto count = arr[m + i - 2] - arr[i - 2];
			const auto it = counts.find(count);
			if (it != counts.end()) {
				canFind = true;
				l_i = i - 2, l_m = m, l_count = count;
				break;
			}
			counts.insert(it, count);
		}
		if (canFind)
			l = m;
		else
			r = m;
	}
	for (uint32_t i = 2; i <= n - l_m + 2; i++)
	{
		const auto count = arr[l_m + i - 2] - arr[i - 2];
		if (count != l_count)
			continue;
		// i-1=i starts from 0, loop starts from 2
		cout << (i - 1) << ' ' << (i + l_m - 2) << ' ' << (l_i + 1) << ' ' << (l_i + l_m) << endl;
		break;
	}
	return 0;
}