#include <iostream>
#include <vector>
#include <cmath>
#include <unordered_set>

using namespace std;
typedef long long lint;
unordered_set <lint> pr_l = {2,3,5,7,13,17, 23, 37, 47, 43, 53, 67, 73, 83, 97};
unordered_set <lint> pr = {173, 197, 113, 167, 137, 223, 283, 373, 397, 353,
 317, 313, 367, 383, 337, 347, 467, 443, 523, 547, 673, 653, 617, 613, 683, 647, 643,
 773, 797, 743, 853, 823, 883, 997, 953, 967, 983, 937, 947};

lint getlen(lint n) {
    lint len = 0;
    while (n)
        n /= 10, len++;
    return len;
}

long long step(long long a, lint b){
    long long temp = 1;
    for(lint i = 0; i < b; i++)
        temp *= a;
    return temp;
}

bool prime(long long a)
{
    for(lint i = 2, k = sqrt(a); i <= k; i++)
        if(a % i == 0) return false;
    return true;
}

int main() {
//    cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0);
    vector <bool> is;
    long long n, m, temp, counter = 0;

    unordered_set <long long> new_pr;
    cin >> n >> m;
    lint it = n;
    if(n < 100)
        while(it < 100) {if(pr_l.count(it) && it <= m) counter++; it++;}
    if(m > 100)
        for(lint i : pr)
            if(i >= n && i <= m)
                counter++;

for(lint hod = 3, en = getlen(m); hod <= en; hod++){
    for(lint i = 1; i < 10; i++)
    {
        for(lint j : pr)
        {
            temp = i*step(10,getlen(j));
            temp += j;
            if(prime(temp) && temp <= m) new_pr.insert(temp), counter++;
        }
    }
    pr = new_pr;
    new_pr.clear();

}
cout << counter << endl;
    return 0;
}
