#include<bits/stdc++.h>

#define x first
#define y second
#define sz(s) (int)(s).size()
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define left left228
#define right right228
#define rank rank228
#define y1 y228
#define read(FILENAME) freopen((FILENAME + ".in").c_str(), "r", stdin)
#define write(FILENAME) freopen((FILENAME + ".out").c_str(), "w", stdout)
#define files(FILENAME) read(FILENAME), write(FILENAME)
#define pb push_back
using namespace std;
template<typename T1, typename T2> inline void chkmin(T1 &x, T2 y) {if (x > y) x = y;}
template<typename T1, typename T2> inline void chkmax(T1 &x, T2 y) {if (x < y) x = y;}
const int MAXN = 100001, p = 1e9 + 7;
const string FILENAME = "input";

int sum(int a, int b) {
    a += b;
    return a >= p ? a - p : a;
}

int mul(long long a, int b) {
    return a * b % p;
}

int n;
int s[MAXN];
int minL[MAXN], maxR[MAXN];
int dsu[MAXN];
int ans = 0;

int a[MAXN];
vector<int> group[MAXN];
vector<pair<int, int>> arr;

int get(int i) {
    if (i == dsu[i]) return i;
    return dsu[i] = get(dsu[i]);
}

void add(int i, int j) {
    if (i < 0 || i == n || j < 0 || j == n) return;
    if (a[i] < a[j]) return;
    i = get(i);
    j = get(j);

    //cout << i << '+' << j << ' ' << a[i] << ' ' << a[j] << endl;
    if (i == j) return;
    if (s[i] < s[j]) swap(i, j);
    dsu[j] = i;
    s[i] += s[j];
    chkmax(maxR[i], maxR[j]);
    chkmin(minL[i], minL[j]);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    //read(FILENAME);
    cin >> n;
    arr.resize(n);
    for (int i = 0; i < n; ++i) {
        dsu[i] = minL[i] = maxR[i] = i;
        s[i] = 1;

        cin >> arr[i].x;
        a[i] = arr[i].x;
        arr[i].y = i;
    }
    sort(all(arr));
    int L = 0;
    while (L < n) {
        int R = L;
        while (R < n && arr[L].x == arr[R].x) {
            add(arr[R].y, arr[R].y + 1);
            add(arr[R].y, arr[R].y - 1);
            ++R;
        }
        //cout << arr[L].x << endl;
        int id = 0;
        map<int, int> place;
        for (int i = L; i < R; ++i) {
            if (place.count(get(arr[i].y)) == 0) {
                group[id].clear();
                place[get(arr[i].y)] = id++;
            }
            group[place[get(arr[i].y)]].pb(arr[i].y);
        }
        int pref = 0;
        for (int g = 0; g < id; ++g) {
            int L1 = 0, L2 = 0, L3 = 0;
            int Ln = minL[get(group[g][0])];
            int Rn = maxR[get(group[g][0])];
            int lst = Ln - 1;
            int ask = 0;
            for (int i : group[g]) {
                int L = i - lst;
                int R = Rn - i + 1;
                //cout << L << '_' << R << ' ' << Ln << ' ' << Rn << ' ' << i << endl;
                ask = sum(ask, mul(L, R));
                long long res = 0;
                if (lst >= Ln) {
                    res += mul(L1, mul(lst, i - lst));
                    res += mul(p - (i - lst), L3);
                     //cout << res << "?" << endl;
                    res = mul(res, 2);

                }
                //cout << i - lst + 1 << ' ' << i - lst << endl;
                res += mul(L1, mul(p + i - lst + 1, i - lst));
                res %= p;
                ans = sum(ans, mul(R, res));
                L1 = sum(L1, L);
                L2 = sum(L2, mul(L, mul(i, i)));
                L2 = sum(L2, mul(L, p - i));
                L3 = sum(L3, mul(L, i));
                lst = i;
                //cout << mul(5e8 + 4, mul(R, res)) << endl;
            }
            ans = sum(ans, mul(2, mul(pref, ask)));
            pref = sum(pref, ask);
        }
        L = R;
    }
    cout << mul(5e8 + 4, ans) << endl;
}

