#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
/*
struct ret
{
    int type;
    string a, b;
};
*/

const int N = 1e5 + 7;

vector <pair <int, int> > g[N];
ll dist[N];
bool vis[N];
int pr[N];
bool die[N];

int get(int v)
{
    if (v == pr[v])
    {
        return v;
    }
    else
    {
        return pr[v] = get(pr[v]);
    }
}

void uni(int u, int v)
{
    pr[get(u)] = get(v);
}

bool cmp(pair <ll, pair <int, int> > x, pair <ll, pair <int, int> > y)
{
    if (x.first != y.first)
    {
        return x.first > y.first;
    }
    return x.second > y.second;
}

int main()
{
    #ifdef ONPC
    freopen("a.in", "r", stdin);
    freopen("a.out", "w", stdout);
    #endif // ONPC
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    for (int i = 1; i < n; i++)
    {
        int a, b, l;
        cin >> a >> b >> l;
        a--, b--;
        g[a].push_back({b, l});
        g[b].push_back({a, l});
    }
    for (int i = 0; i < n; i++)
    {
        pr[i] = i;
        dist[i] = 1e18;
    }
    set <pair <ll, int> > q;
    int m;
    cin >> m;
    for (int i = 0; i < m; i++)
    {
        int x;
        cin >> x;
        x--;
        dist[x] = 0;
        q.insert({0, x});
    }
    map <pair <int, int>, ll> ed;
    set <pair <int, int> > s;
    while (!q.empty())
    {
        int v = q.begin()->second;
        q.erase(q.begin());
        ll d = dist[v];
        for (auto x : g[v])
        {
            int to = x.first;
            int len = x.second;
            if (!ed.count({v, to}))
            {
                ed[{v, to}] = ed[{to, v}] = d + len;
            }
            else
            {
                ll was = min(ed[{v, to}], d + len);
                ed[{v, to}] = ed[{to, v}] = was;
            }
            if (dist[to] > dist[v] + len)
            {
                q.erase({dist[to], to});
                dist[to] = dist[v] + len;
                q.insert({dist[to], to});
            }
        }
    }
    vector <pair <ll, pair <int, int> > > f;
    for (auto c : ed)
    {
        if (c.first.first < c.first.second)
            f.push_back({c.second, {c.first.first, c.first.second}});
    }
    for (int i = 0; i < n; i++)
    {
        f.push_back({dist[i], {i, -1}});
    }
    sort(f.begin(), f.end(), cmp);
    int sz = (int) f.size();
    int j = -1;
    int comp = 0;
    int ans = 0;
    for (int i = 0; i < sz; i++)
    {
        while (j + 1 < sz && f[j + 1].first == f[i].first)
        {
            j++;
            int a = f[j].second.first, b = f[j].second.second;
            if (b == -1)
            {
                die[a] = 1;
                comp++;
                for (auto x : g[a])
                {
                    int to = x.first;
                    if (s.count({a, to}))
                    {
                        if (die[to])
                        {
                            if (get(a) != get(to))
                            {
                                comp--;
                                uni(a, to);
                            }
                        }
                        else
                        {
                            comp--;
                        }
                    }
                }
            }
            else
            {
                comp++;
                if (die[a] || die[b]) comp--;
                if (die[a] && die[b])
                {
                    uni(a, b);
                }
                s.insert({a, b});
                s.insert({b, a});
            }
        }
        ans = max(ans, comp);
        i = j;
    }
    cout << ans << '\n';
    /*
    vector <ret> e;
    string s;
    while (cin >> s)
    {
        if (s == "{")
        {
            e.push_back({-1, {"", ""}});
        }
        else if (s == "}")
        {
            e.push_back({1, {"", ""}});
        }
        else
        {
            string first = "";
            string second = "";
            bool ch = false;
            for (int i = 0; i < (int) s.size(); i++)
            {
                if (s[i] == "=")
                {

                }
            }
        }
    }
    */
}
