#include <iostream>
#include <vector>
#include <cmath>

using namespace std;
typedef long long ll;

vector<ll> a;
vector<ll> cnt(10, 0);
vector<ll> pow10(10);

const ll mod = 1000000007;

int len(ll x) {
    return ((int)log10(x) + 1);
}

int main() {
    int n;

    cin >> n;
    a.resize(n);

    pow10[0] = 1;
    pow10[1] = 10;
    pow10[2] = 100;
    pow10[3] = 1000;
    pow10[4] = 10000;
    pow10[5] = 100000;
    pow10[6] = 1000000;
    pow10[7] = 10000000;
    pow10[8] = 100000000;
    pow10[9] = 1000000000;

    for (int i = 0; i < n ; i ++) {
        cin >> a[i];
        cnt[len(a[i])] ++;
    }

    ll answ = 0;

    for (int i = 0; i < n; i ++) {
        int x = len(a[i]);
        cnt[x] --;

        for (int j = 0; j < 10; j ++) {
            answ += (((pow10[j] * cnt[j]) % mod) * a[i]) % mod;
            answ += (cnt[j] * a[i]) % mod;
            //cout << a[i] << ' ' << x << ' ' << cnt[j] << ' ' << j << ' ' << (((pow10[j] * cnt[j]) % mod) * a[i]) % mod << endl;
            answ %= mod;
        }

        cnt[x] ++;
    }

    cout << answ;

    return 0;
}
