#include <iostream>
using namespace std;

#define MAX_N int(2e5)
typedef long long int64;

int a[MAX_N], n, pows[12];

int64 num(int64 d, int64 c) {
    int64 k = 0, b = c;
    for(; b; ++k)
        b /= 10;
    return d * pows[k] + c;
}

int64 solve() {
    int64 sum = 0;
    for(int i(0); i < n; ++i) {
        for(int j(0); j < n; ++j) {
            if(a[i] != a[j]) {
                //cout << a[i] << " " << a[j] << " " << num(a[i], a[j]) << endl;
                sum += num(a[i], a[j]);
            }
        }
    }
    return sum;
}

int main() {
    pows[0] = 1;
    for(int i(1); i < 12; ++i)
        pows[i] = pows[i - 1] * 10;
    cin >> n;
    for(int i(0); i < n; ++i)
        cin >> a[i];
    cout << solve() << endl;
    return 0;
}
