#include <bits/stdc++.h>
using namespace std;

const int MAXN = 100005;
long long pref[3][MAXN];

inline long long get(int p, int l, int r) {
    if (r <= l) {
        return 0;
    }

    return pref[p][r] - pref[p][l];
}

int main() {
#ifdef DEBUG
    freopen("input", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);

    vector<pair<int, int>> pts;
    for (int i = 0; i < 3; i++) {
        int x, nx;
        cin >> x >> nx;
        pts.push_back({x, nx});
    }
    sort(pts.begin(), pts.end());

    int n;
    cin >> n;
    vector<int> x(n);
    for (int i = 0; i < n; i++) {
        cin >> x[i];
    }
    sort(x.begin(), x.end());

    for (int p = 0; p < 3; p++) {
        for (int i = 0; i < n; i++) {
            pref[p][i + 1] = pref[p][i] + abs(x[i] - pts[p].first);
        }
    }

    int n1 = pts[0].second, n2 = pts[1].second, n3 = pts[2].second;
    int x1 = pts[0].first, x2 = pts[1].first, x3 = pts[2].first;

    int b23 = 0;
    while (b23 < n && abs(x[b23] - x2) <= abs(x[b23] - x3)) {
        b23++;
    }
    b23--;

    long long ans = 1000000000000000000LL;
    for (int p1 = 0; p1 <= n && p1 <= n1; p1++) {
        int left = n - p1;
        int s3 = min(0, left - n2);
        int p2 = min(0, left - n3);
        if (s3 + p2 > left) {
            continue;
        }
        int last2 = p1 + p2 - 1;
        int first3 = n - s3 + 1;

        if (b23 <= last2) {
            long long cur = 0;
            cur += pref[0][p1];
            cur += get(1, p1, last2);
            cur += get(2, last2 + 1, n);

            ans = min(ans, cur);
        } else if (b23 >= first3) {
            long long cur = 0;
            cur += pref[0][p1];
            cur += get(1, p1, first3 - 1);
            cur += get(2, first3, n);

            ans = min(ans, cur);
        } else {
            long long cur = pref[0][p1];
            cur += get(1, p1, b23);
            cur += get(2, b23, n);

            ans = min(ans, cur);
        }
    }

    cout << ans << endl;

    return 0;
}