import java.io.*;
import java.util.*;

public class C {
	public void solve() throws IOException {
		StringBuilder ans = new StringBuilder();
		TreeMap<String, Integer> map = new TreeMap<>();
		LinkedList<TreeMap<String, Integer>> changes = new LinkedList<>();
		changes.add(new TreeMap<>());

		String str = br.readLine();
		while (str != null) {
			if (str.charAt(0) == '{') {
				changes.add(new TreeMap<>());
			} else if (str.charAt(0) == '}') {
				TreeMap<String, Integer> last = changes.removeLast();

				for (String s : last.keySet()) {
					map.put(s, last.get(s));
				}
			} else {
				String[] var = str.split("=");

				boolean flag = true;

				int len = var[1].length();

				for (int i = 0; i < len; i++) {
					if (var[1].charAt(i) != '-' && (var[1].charAt(i) < '0' || var[1].charAt(i) > '9')) {
						flag = false;
					}
				}

				TreeMap<String, Integer> lastChange = changes.getLast();

				if (flag) {
					int x = Integer.parseInt(var[1]);

					if (!lastChange.containsKey(var[0])) {
						int last = 0;
						if (map.containsKey(var[0])) {
							last = map.get(var[0]);
						}
						lastChange.put(var[0], last);
					}

					map.put(var[0], x);
				} else {
					if (!map.containsKey(var[1])) {
						map.put(var[1], 0);
					}

					int x = map.get(var[1]);

					if (!lastChange.containsKey(var[0])) {
						int last = 0;
						if (map.containsKey(var[0])) {
							last = map.get(var[0]);
						}
						lastChange.put(var[0], last);
					}

					map.put(var[0], x);
					ans.append(x + "\n");
				}
			}

			str = br.readLine();
		}

		out.println(ans.toString());
	}

	public void run() {
		try {
			br = new BufferedReader(new InputStreamReader(System.in));
			// br = new BufferedReader(new FileReader(new File("test.txt")));
			out = new PrintWriter(System.out);

			solve();

			out.close();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		}
	}

	BufferedReader br;
	PrintWriter out;

	public static void main(String[] args) throws IOException {
		Locale.setDefault(Locale.US);
		new C().run();
	}
}
