import java.io.*;
import java.util.*;

public class C1 {
	@SuppressWarnings("unchecked")
	public void solve() throws IOException {
		LinkedList<TreeMap<String, Integer>> map = new LinkedList<>();
		map.add(new TreeMap<>());

		String str = br.readLine();
		while (str != null) {
			if (str.charAt(0) == '{') {
				TreeMap<String, Integer> newMap = (TreeMap<String, Integer>) map.getLast().clone();
				map.add(newMap);
			} else if (str.charAt(0) == '}') {
				map.removeLast();
			} else {
				String[] var = str.split("=");

				TreeMap<String, Integer> hash = map.getLast();
			
				try {
					int x = Integer.parseInt(var[1]);
					hash.put(var[0], x);
				} catch (Exception e) {
					if (!hash.containsKey(var[1])) {
						hash.put(var[1], 0);
					}
					int x = hash.get(var[1]);
					hash.put(var[0], x);
					out.println(x);
				}
				
			}
			str = br.readLine();
		}
	}

	public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
//        	br = new  BufferedReader(new FileReader(new File("test.txt")));
            out = new PrintWriter(System.out);

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new C1().run();
    }
}
