import java.io.*;
import java.util.*;

public class C1 {
	public void solve() throws IOException {
		StringBuilder ans = new StringBuilder();
		LinkedList<TreeMap<String, Integer>> map = new LinkedList<>();
		map.add(new TreeMap<>());

		String str = br.readLine();
		while (str != null) {
			if (str.charAt(0) == '{') {
				TreeMap<String, Integer> newMap = (TreeMap<String, Integer>) map.getLast().clone();
				map.add(newMap);
			} else if (str.charAt(0) == '}') {
				map.removeLast();
			} else {
				String[] var = str.split("=");

				TreeMap<String, Integer> hash = map.getLast();

				boolean flag = true;

				int len = var[1].length();

				for (int i = 0; i < len; i++) {
					if (var[1].charAt(i) != '-' && (var[1].charAt(i) < '0' || var[1].charAt(i) > '9')) {
						flag = false;
					}
				}

				if (flag) {
					int x = Integer.parseInt(var[1]);
					hash.put(var[0], x);
				} else {
					if (!hash.containsKey(var[1])) {
						hash.put(var[1], 0);
					}

					int x = hash.get(var[1]);
					hash.put(var[0], x);
					ans.append(x + "\n");
				}
			}

			str = br.readLine();
		}

		out.println(ans.toString());
	}

	public void run() {
		try {
			br = new BufferedReader(new InputStreamReader(System.in));
			// br = new BufferedReader(new FileReader(new File("test.txt")));
			out = new PrintWriter(System.out);

			solve();

			out.close();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		}
	}

	BufferedReader br;
	PrintWriter out;

	public static void main(String[] args) throws IOException {
		Locale.setDefault(Locale.US);
		new C1().run();
	}
}
