#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;

long long  get(long long q) {
	long long res = 0;
	while (q > 0) {
		res++;
		q /= 10;
	}
	return res;
}
const long long MOD = 1e9 + 7;

int main() {
	cin.tie(0);
	cout.tie(0);
	ios::sync_with_stdio(0);

	long long n;
	cin >> n;
	vector < long long > a(n);
	vector < long long > count(10, 0);
	vector < long long > pow(10);

	pow[0] = 1;

	for (int i = 1; i < pow.size(); i++) {
		pow[i] = 10 * pow[i - 1];
		pow[i] %= MOD;
	}
	for (int i = 0; i < n; i++) {
		cin >> a[i];
		long long len = get(a[i]);
		count[len]++;
	}

	long long sum = 0;


	for (int i = 0; i < n; i++) {
		long long len = get(a[i]);

		for (int j = 0; j < count.size(); j++) {

			long long y;
			if (j == len) {
				y = pow[j] * (count[j] - 1);
			}
			else {
				y = pow[j] * count[j];
			}
			long long temp = a[i] * y;
			temp %= MOD;

			sum += temp;
			sum %= MOD;
		}

		sum += a[i] * (n - 1);
		sum %= MOD;
	}

	cout << sum;
	return 0;
}