#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <string>
#include <set>

using namespace std;

int main()
{
	string s;
	cin >> s;
	vector <vector <int>> dp(s.size(), vector <int>(s.size() + 1, -1));
	for (int i = 0; i < s.size(); ++i)
	{
		dp[i][1] = s[i] - '0';
	}
	for (int i = 0; i < s.size(); ++i)
	{
		for (int j = 2; j < s.size() - i + 1; ++j)
		{
			dp[i][j] = dp[i][j - 1] + s[i + j - 1] - '0';
		}
	}
	int ans_size = -1, ans_count = -1;
	for (int j = s.size(); j > 0; --j)
	{
		set <int> sizes;
		for (int i = 0; i < s.size(); ++i)
		{
			if (sizes.count(dp[i][j]) == 1 && dp[i][j] != -1)
			{
				ans_size = j;
				ans_count = dp[i][j];
				goto q;
			}
			sizes.insert(dp[i][j]);
		}
	}
q:
	pair <int, int> first_ans(-1, -1), second_ans(-1, -1);
	bool flag = false;
	for (int i = 0; i < s.size(); ++i)
	{
		if (dp[i][ans_size] == ans_count)
		{
			if (!flag)
			{
				first_ans = { i + 1, i + ans_size };
				flag = true;
			}
			else
			{
				second_ans = { i + 1, i + ans_size };
			}
		}
	}
	cout << first_ans.first << " " << first_ans.second << " " << second_ans.first << " " << second_ans.second;
	return 0;
}