#include <cstdio>
#include <bits/stdc++.h>
#include <cstdio>

using namespace std;

typedef long long ll;

const int N = 4001;
const ll INF = 100000000000000000;

ll dp[N][N];
int pr[N][N];
ll d[N], c[N], p[N];
vector<int> best[N];
vector<int> answ;

int main()
{
    ios::sync_with_stdio(0); cin.tie(0);
    int n, m;
    cin >> n >> m;
    for (int i = 1; i <= n; i++)
        cin >> d[i] >> p[i] >> c[i];
    for (int i = 0; i < N; i++)
        for (int j = 0; j < N; j++)
            dp[i][j] = INF, pr[i][j] = -1;
    dp[0][0] = 0;
    for (int i = 1; i <= n; i++)
        for (int j = N - 1; j >= 0; j--)
        {
            if (j <= p[i])
            {
                dp[i][j] = c[i];
                pr[i][j] = 0;
            }
            if (j >= p[i])
            {
                if (best[j - p[i]].size())
                {
                    int l = -1, r = best[j - p[i]].size();
                    while (r - l > 1)
                    {
                        int mid = (r + l) / 2;
                        if (d[best[j - p[i]][mid]] < d[i])
                            l = mid;
                        else
                            r = mid;
                    }
                    if (r < best[j - p[i]].size())
                    {
                        if (dp[i][j] > dp[best[j - p[i]][r]][j - p[i]] + c[i])
                        {
                            dp[i][j] = dp[best[j - p[i]][r]][j - p[i]] + c[i];
                            pr[i][j] = best[j - p[i]][r];
                        }

                    }
                }
            }
            while (best[j].size() && d[best[j].back()] >= d[i] && dp[best[j].back()][j] > dp[i][j])
                best[j].pop_back();
            if (!best[j].size() || d[best[j].back()] < d[i])
                best[j].push_back(i);
        }
  /*  for (int i = 0; i <= n; i++)
    {
        for (int j = 0; j <= m + 3; j++)
            cout << dp[i][j] << " ";
        cout << endl;
    }*/
    ll ans = INF - 10LL;
    int pos = -1;
    int mem = -1;
    for (int i = 1; i <= n; i++)
        for (int j = m; j < N; j++)
            if (dp[i][j] < ans)
            {
                ans = dp[i][j];
                mem = j;
                pos = i;
            }
    if (pos == -1)
    {
        cout << -1;
        return 0;
    }
    cout << dp[pos][mem] << endl;
    while (pos > 0)
    {
        answ.push_back(pos);
        int x = mem - p[pos];
        pos = pr[pos][mem];
        mem = x;
    }
    cout << answ.size() << endl;
    sort(answ.begin(), answ.end());
    for (int i = 0; i < answ.size(); i++)
        cout << answ[i] << " ";
    return 0;
}
/*
2 2
1 1 1
2 3 2

2 4
1 1 1
2 3 2

2 4
1 1 1
1 3 2

2 6
1 3 1
2 4 2
*/
