import java.io.*;
import java.lang.reflect.Array;
import java.util.*;

public class Main {

    public class pair implements Comparable<pair> {
        long x;
        int a;

        public int compareTo(pair p) {
            if (x != p.x) {
                return Long.compare(x, p.x);
            }
            return a - p.a;
        }

        pair(long u, int i) {
            x = u;
            a = i;
        }
    }

    public class paird implements Comparable<paird> {
        long x;
        int a;

        public int compareTo(paird p) {
            if (x != p.x) {
                return Long.compare(x, p.x);
            }
            return a - p.a;
        }

        paird(long u, int i) {
            x = u;
            a = i;
        }
    }

    public void solve() throws IOException {
        pair[] a = new pair[3];
        long res = 0;
        a[0] = new pair(2 * nextInt(), nextInt());
        a[1] = new pair(2 * nextInt(), nextInt());
        a[2] = new pair(2 * nextInt(), nextInt());
        TreeSet<pair> c = new TreeSet<>();
        Arrays.sort(a);
        int m = nextInt();
        int mm[] = new int[m];
        for (int i = 0; i < m; i++) {
            mm[i] = nextInt();
        }
        Arrays.sort(mm);
        for (int i = 0; i < m; i++) {
            c.add(new pair(2 * mm[i], m - i - 1));
        }
        while (a[0].a > 0 && c.size() > 0) {
            long p = c.first().x;
            if (Math.abs(p - a[0].x) <= Math.abs(p - a[1].x)) {
                res += Math.abs(p - a[0].x);
                a[0].a--;
                c.pollFirst();
            } else {
                break;
            }
        }
        while (a[2].a > 0 && c.size() > 0) {
            long p = c.last().x;
            if (Math.abs(p - a[2].x) <= Math.abs(p - a[1].x)) {
                res += Math.abs(p - a[2].x);
                c.pollLast();
                a[2].a--;
            } else {
                break;
            }
        }
        int k = a[1].a - c.size();
        k = -k;
        if (k <= 0) {
            for (pair cc : c) {
                res += Math.abs(a[1].x - cc.x);
            }
        } else  {
            long res1 = Long.MAX_VALUE;
            long pr[] = new long[c.size() + 1];
            long prc[] = new long[c.size() + 1];
            long prb[] = new long[c.size() + 1];
            long sfb[] = new long[c.size() + 1];
            int i = 1;
            long ccc = 0;
            for (pair cc : c) {
                pr[i] = pr[i - 1] + Math.abs(a[0].x - cc.x);
                prb[i] = prb[i - 1] + Math.abs(a[1].x - cc.x);
                prc[i] = prc[i - 1] + Math.abs(a[2].x - cc.x);
                ccc += Math.abs(a[2].x - cc.x);
                i++;
            }
            for (i = Math.max(0, k - a[2].a); i <= Math.min(k, a[0].a); i++) {
                res1 = Math.min(res1, pr[i] + prb[c.size() - k + i] - prb[i] + ccc - prc[c.size() - k + i]);
            }
            res += res1;
        }
        out.print((res) / 2);
    }

    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    boolean hasNext() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            try {
                in = new StringTokenizer(br.readLine());
            } catch (Exception e) {
                return false;
            }
        }
        return true;
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new Main().run();
    }

}