#include <bits/stdc++.h>

#define pub push_back
#define mp make_pair
#define x first
#define y second

using namespace std;

typedef long long ll;

struct vert{
    int pred, r, len, mi;
};

struct cnm{
    vert t[100007];
    cnm() { for (int i = 0; i < 100007; i++) t[i].pred = i, t[i].r = 0, t[i].len = 1, t[i].mi = i; }

    int get(int v){
        if (t[v].pred == v) return v;
        t[v].pred = get(t[v].pred);
        return t[v].pred;
    }

    void merge(int a, int b){
        a = get(a), b = get(b);
        if (a != b){
            if (t[a].r < t[b].r) swap(a, b);
            t[b].pred = a;
            t[a].len += t[b].len;
            t[a].mi = min(t[a].mi, t[b].mi);
            if (t[a].r == t[b].r) t[a].r++;
        }
    }
} cc;

const int mod = (int)1e9 + 7;

int ans;
int n;
int a[100007];

void add(int &a, int b){
    a += b;
    if (a >= mod) a -= mod;
}

int mult(ll a, ll b){
    return a * (ll)b % mod;
}

map<int, vector<int> > ma;
bool ok[100007];

int pref[100007];

int SUPERSUM(int n){
    return ((ll)n * (n + 1) / (ll)2) % mod;
}

pair<int, int> solve(vector<int> a, int len){
    int now = 0;

    pref[a.size()] = 0;
    pref[a.size() + 1] = 0;
    for (int i = (int)a.size() - 1; i >= 1; i--){
        pref[i] = pref[i + 1];
        add(pref[i], mult(a[i] - a[i - 1], len - a[i]));
    }

    pref[0] = pref[1];
    add(pref[0], mult(a[0] + 1, len - a[0]));

    for (int i = 0; i < (int)a.size() - 1; i++){
        int val = a[i] + 1;
        int sum = pref[i + 2];
        add(sum, len - a[i + 1]);
        int cnt = a[i + 1] - a[i];
        int wtf = len - a[i + 1];
        add(now, mult(cnt, mult(val, sum)));
        add(now, mult(SUPERSUM(cnt - 1), mult(val, wtf)));
    }

    //cout << "===" << now << ' ' << len << ' ';
    //for (int x : a) cout << x << ' ';
    //cout << endl;
    return mp(now, pref[0]);
}

int bp(ll a, ll k){
    if (k == 1) return a;
    if (k % 2 == 1){
        return mult(a, bp(a, k - 1));
    } else {
        int q = bp(a, k / 2);
        return mult(q, q);
    }
}

int main() {
#ifdef WIN
    freopen("01", "r", stdin);
#endif // WIN
    ios_base::sync_with_stdio(0); cin.tie(0);
    cin >> n;
    int AHAHA = bp(2, mod - 2);
    for (int i = 0; i < n; i++) cin >> a[i];
    for (int i = 0; i < n; i++) ma[a[i]].pub(i);
    for (auto c : ma){
        for (auto v : c.y) ok[v] = 1;
        for (auto v : c.y){
            if (v + 1 < n && ok[v + 1]) cc.merge(v, v + 1);
            if (v - 1 >= 0 && ok[v - 1]) cc.merge(v, v - 1);
        }
        vector<pair<int, int> > gg;
        for (auto v : c.y) gg.pub(mp(cc.get(v), v));
        sort(gg.begin(), gg.end());
        int i = 0;
        vector<int> addnew;
        while(1){
            if (i >= gg.size()) break;
            int j = i;
            vector<int> ww;
            while(j + 1 < gg.size() && gg[j + 1].x == gg[i].x) j++;
            for (int s = i; s <= j; s++) ww.pub(gg[s].y - cc.t[cc.get(gg[i].y)].mi);
            auto ff = solve(ww, cc.t[cc.get(gg[i].y)].len);
            add(ans, ff.x);
            addnew.pub(ff.y);
            i = j + 1;
        }
        //for (int x : addnew) cout << x << ' ';
        //cout << endl;
        int nowadd = 0;
        int sum = 0;
        for (int x : addnew) add(sum, x);
        for (int x : addnew){
            sum -= x;
            if (sum < 0) sum += mod;
            add(nowadd, mult(x, sum));
            add(sum, x);
        }
        add(ans, mult(AHAHA, nowadd));
        //cout << ans << endl;
    }
    cout << ans;
}

