#include <iostream>
#include <cstdio>
#include <cmath>
#include <queue>
#include <algorithm>
#include <string>
#include <vector>
#include <map>
#include <unordered_map>

using namespace std;

#define ff first
#define ss second
typedef long long ll;

int solve();

int main(){
    ios_base::sync_with_stdio(0);
#ifdef home
    freopen ("input.txt", "r", stdin);
#else
    cin.tie(0);
    cout.tie(0);
#endif // home
    solve();
}

int stoi(string &s) {
    ll ans = 0;

    int i = 0;
    bool fl = 0;
    if (s[0] == '-') fl = 1, i = 1;
    for (; i < s.size(); i++) {
        ans = ans * 10 + (s[i] - '0');
    }
    if (fl) return -ans;
    return ans;
}

unordered_map<string, int> cur[(int)5e4 + 3];

string s1[2];

int solve() {
    string s;

    int bal = 0;
    while (cin >> s) {
        if (s == "{") {
            for (auto t : cur[bal]) {
                cur[bal + 1][t.first] = t.second;
            }
            bal++;
        }
        if (s == "}") {
            cur[bal].clear();
            bal--;
        }
        if (s != "}" && s != "{") {
            s += '=';
            int sz = 0;
            for (int i = 0; i < s.size(); i++) {
                string cur = "";
                while (i < s.size() && s[i] != '=') {
                    cur += s[i];
                    i++;
                }
                if (cur != "") s1[sz++] = cur;
            }

            if (isdigit(s1[1].back())) {
                cur[bal][s1[0]] = stoi(s1[1]);

            } else {
                int out = cur[bal][s1[1]];
                cout << out << '\n';
                cur[bal][s1[0]] = out;
            }
        }
    }
    return 0;

}
