#include <bits/stdc++.h>

#define ll long long
#define rep(i, l, r) for (int i = l; i < r; i++)
#define repb(i, l, r) for (int i = l; i > r; i--)
#define fi first
#define se second
#define sz(a) (int)a.size()

using namespace std;

const int maxN = 2005;
const ll INF = 1e18;

int darr[maxN];
int carr[maxN];
int cost[maxN];

ll dp[maxN][maxN * 4];

ll get(int st, int v, int l, int r, int a, int b) {
    if (a <= l && r <= b) {
        return dp[st][v];
    }
    if (b <= l || r <= a) {
        return INF;
    }

    int m = (l + r) / 2;
    return min(get(st, v * 2, l, m, a, b), get(st, v * 2 + 1, m, r, a, b));
}

void set_st(int st, int v, int l, int r, int i, ll x) {
    if (l == r - 1) {
        dp[st][v] = x;
        return;
    }

    int m = (l + r) / 2;
    if (i < m) set_st(st, v * 2, l, m, i, x);
    else set_st(st, v * 2 + 1, m, r, i, x);

    dp[st][v] = min(dp[st][v * 2], dp[st][v * 2 + 1]);
}

int main()
{
    freopen("in.txt", "r", stdin);
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n, m;
    cin >> n >> m;

    vector<int> coord;
    for (int i = 0; i < n; i++) {
        cin >> darr[i] >> carr[i] >> cost[i];
        coord.push_back(darr[i]);
    }
    sort(coord.begin(), coord.end());
    coord.resize(unique(coord.begin(), coord.end()) - coord.begin());

    for (int i = 0; i < n; i++) {
        darr[i] = lower_bound(coord.begin(), coord.end(), darr[i]) - coord.begin();
    }

    for (int i = 0; i < maxN * 4; i++) dp[0][i] = 0;
    for (int j = 1; j <= m; j++) {
        for (int i = 0; i < maxN * 4; i++) dp[j][i] = INF;
    }

    for (int i = 0; i < n; i++) {
        for (int j = m; j >= 0; j--) {
            ll lval = get(j, 1, 0, coord.size(), darr[i], darr[i] + 1);
            ll nval = get(max(0, j - carr[i]), 1, 0, coord.size(), darr[i], coord.size()) + cost[i];
            if (nval < lval) {
                set_st(j, 1, 0, coord.size(), darr[i], nval);
            }
        }
    }

    cout << get(m, 1, 0, coord.size(), 0, coord.size()) << endl;

    return 0;
}
