#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <queue>
#include <fstream>

using namespace std;

typedef long long ll;
typedef long double ld;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    pair<int, int> a, b, c;
    cin >> a.first >> a.second;
    cin >> b.first >> b.second;
    cin >> c.first >> c.second;

    vector<pair<int, int>> qqq{a, b, c};

    sort(qqq.begin(), qqq.end());

    a = qqq[0];
    b = qqq[1];
    c = qqq[2];

    int n;
    cin >> n;
    vector<int> v(n);
    vector<bool> done(n, false);
    for (int &i : v) {
        cin >> i;
    }
    sort(v.begin(), v.end());

    ll ans = 0;

    int i = 0;
    int j = n - 1;
    while (a.second > 0 && i < n && 2 * v[i] <= (a.first + b.first)) {
        --a.second;
        ans += abs(a.first - v[i]);
        ++i;
    }

    while (c.second > 0 && j >= i && 2 * v[j] >= (c.first + b.first)) {
        --c.second;
        ans += abs(c.first - v[j]);
        --j;
    }


    while (j - i + 1 > b.second) {
            if (2 * v[i] - a.first - c.first - 2 * b.first + 2 * v[j] <= 0 && a.second > 0 || c.second == 0) {
                ans += abs(a.first - v[i]);
                --a.second;
                ++i;
            } else {
                ans += abs(c.first - v[j]);
                --c.second;
                --j;
            }
        }
        while (i <= j) {
            ans += abs(v[i] - b.first);
            ++i;
        }
    }
    cout << ans;
    return 0;
}
