#include <fstream>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <math.h>
#include <alg.h>

using namespace std;

#ifdef _DEBUG
ifstream cin("input.txt");
ofstream cout("output.txt");
#else
#include <iostream>
#endif

typedef long long ll;
typedef pair <int, int> pii;

vector <vector <ll> > cnt;
int N = 12;

bool isPrime(ll n) {
	for (ll i = 2; i * i <= n; i++) {
		if (n % i == 0) {
			return 0;
		}
	}
	return true;
}

void _count() {
	cnt.resize(N);
	cnt[1] = { 2, 3, 5, 7 };
	ll x = 10;
	for (ll len = 2; len < N; len++) {
		for (auto i : cnt[len - 1]) {
			for (ll t = 1; t <= 9; t++) {
				ll now = i + t * x;
				if (isPrime(now)) {
					cnt[len].push_back(now);
				}
			}
		}
		x *= 10;
	}
	return;
}

int main() {
	_count();
	ll l, r;
	cin >> l >> r;
	ll ans = 0;
	for (ll len = 1; len < N; len++) {
		for (auto now : cnt[len]) {
			if (l <= now && now <= r) {
				ans++;
			}
		}
	}
	cout << ans;
	return 0;
}