#include <iostream>
#include <vector>
#include <algorithm>
#include <climits>
#include <cmath>
#include <set>

using namespace std;

/*int count_d(int x)
{
	int res = 0;

	do {
		res++;
		x /= 10;
	} while (x > 0);

	return res;
}

long long p10(int x)
{
	long long res = 1;
	for (int i = 1; i <= x; i++)
		res *= 10;

	return res;
}

const long long BASE = 1e+9 + 7;

int main()
{
	int n;
	cin >> n;

	vector<int> a(n);
	vector<int> d(n);
	vector<int> count(10, 0);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
		d[i] = count_d(a[i]);
		count[d[i]]++;
	}

	long long ans = 0;
	for (int i = 0; i < n; i++)
		for (int j = 1; j <= 9; j++) {
			int tms = count[j] - (d[i] == j);

			ans = (ans + (long long)a[i] * tms * (1LL + p10(j))) % BASE;
		}

	cout << ans << "\n";

	cout << (1100000000 + 1000000001) % BASE;
}*/

/*int main()
{
	long long n;
	cin >> n;

	cout << ((2 * n)*(2 * n) + (2 * n)*(2 * n)*(2 * n) + n*n*(2 * n)*(2 * n));
}*/
int main()
{
	freopen("input.txt", "r", stdin);
	ios::sync_with_stdio(0);
	cin.tie(0);

	vector<pair<int, int>> h(3);
	for (int i = 0; i < 3; i++)
		cin >> h[i].first >> h[i].second;

	sort(h.begin(), h.end());

	int n;
	cin >> n;
	vector<int> a(n);

	for (int i = 0; i < n; i++)
		cin >> a[i];

	sort(a.begin(), a.end());

	long long ans = 0;

	for (int i = 0; i < n; i++) {
		int cl = -1, cr = -1, lcap = 0, rcap = 0;
		for (int j = 0; j < 3; j++) {
			if (cr == -1 && h[j].first >= a[i] && h[j].second > 0)
				cr = j;
			if (h[j].first < a[i] && h[j].second > 0)
				cl = j;

			if (h[j].first >= a[i])
				rcap += h[j].second;
			if (h[j].first < a[i])
				lcap += h[j].second;
		}

			if (cl != -1 && rcap <= n - i - 1) {
				ans += a[i] - h[cl].first;
				h[cl].second--;
			}
			else {
				int mv = -1;
				if (cl == -1)
					mv = cr;
				else if (cr == -1)
					mv = cl;
				else
					mv = (h[cr].first - a[i] >= a[i] - h[cl].first ? cl : cr);

				ans += abs(a[i] - h[mv].first);
				h[mv].second--;
			}
	}

	cout << ans << endl;
}