#include <iostream>
#include <vector>
#include <algorithm>
#include <climits>
#include <cmath>
#include <set>
#include <map>
#include <stack>
#include <string>

using namespace std;

int count_d(int x)
{
	int res = 0;

	do {
		res++;
		x /= 10;
	} while (x > 0);

	return res;
}

long long p10(int x)
{
	long long res = 1;
	for (int i = 1; i <= x; i++)
		res *= 10;

	return res;
}

const long long BASE = 1e+9 + 7;

int main()
{
	int n;
	cin >> n;

	vector<int> a(n);
	vector<int> d(n);
	vector<int> count(10, 0);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
		d[i] = count_d(a[i]);
		count[d[i]]++;
	}

	long long ans = 0;
	for (int i = 0; i < n; i++)
		for (int j = 1; j <= 9; j++) {
			int tms = count[j] - (d[i] == j);

			ans = (ans + ((long long)a[i] * tms) % BASE * (1LL + p10(j))) % BASE;
		}

	cout << ans << "\n";
}

/*int main()
{
	long long n;
	cin >> n;

	cout << ((2 * n)*(2 * n) + (2 * n)*(2 * n)*(2 * n) + n*n*(2 * n)*(2 * n));
}*/

/*const int BASE = 1e+9;
const int p = 29;

int get_hash(const string &s)
{
	long long h = 0;
	for (int i = 0; i < s.size(); i++)
		h = (h * p + s[i] - 'a') % BASE;
	return h;
}

int main()
{
	map<int, string> v; //hash, string
	map<int, stack<int>> cur_val; //hash, cur_v
	stack<set<int>> nw; //stack<hash>

	string s;
	while (cin >> s) {
		//string a = 
	}
}
*/