#include <iostream>
#include <vector>
#include <algorithm>
#include <climits>
#include <cmath>
#include <set>

using namespace std;

void no()
{
	cout << "No" << endl;
	exit(0);
}

int main()
{
	int n;
	cin >> n;
	int m;
	cin >> m;

	if (n != m + 1)
		no();

	vector<int> a(m);
	for (int i = 0; i < m; i++)
		cin >> a[i];

	vector<int> t(n);
	for (int i = 0; i < n; i++)
		t[i] = i + 1;

	int i = 0, j = 0, ans;
	while (i < n && j < n - 1) {
		if (t[i] == a[j]) {
			i++;
			j++;
		}
		else if (t[i] == a[j] - 1 && i == j) {
			i++;
			ans = t[i - 1];
		}
		else {
			cout << "No" << endl;
			return 0;
		}
	}

	cout << "Yes" << endl << ans << endl;
}

/*int main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);

	vector<pair<int, int>> h(3);
	for (int i = 0; i < 3; i++)
		cin >> h[i].first >> h[i].second;

	int n;
	cin >> n;
	vector<int> a(n);

	for (int i = 0; i < n; i++)
		cin >> a[i];

	long long ans = 0;
	for (int i = 0; i < n; i++) {
		int dst, d = INT_MAX;
		for (int j = 0; j < 3; j++) {
			if (h[j].second > 0 && d > abs(a[i] - h[j].first)) {
				dst = j;
				d = abs(a[i] - h[j].first);
			}
		}

		h[dst].second--;
		ans += (long long)d;
	}

	cout << ans << endl;
}*/