#include <bits/stdc++.h>

using namespace std;

string inttostr(int n) {
	string s;
	while (n > 0) {
		s += n % 10 + '0';
		n /= 10;
	}

	reverse(s.begin(), s.end());
	return s;
}

int strtoint(string &s) {
	long long res = 0;
	for (int i = 0; i < s.length(); ++i) {
		res += s[i] - '0';
		res *= 10;
	}

	return res / 10;
}



int solve() {
	ifstream in("input.txt");
	ofstream out("output.txt");
vector<long long> arr;
long long cnt[10];
long long mul[10];
map<long long, pair<long long, long long>> ar;
long long MOD = 1e9 + 7;
    long long f = 1;
    for (long long i = 1; i < 10; i++)
    {
        f *= 10;
        mul[i] = f;
    }
    long long n;
    in >> n;
    long long z;
    for (long long i = 0; i < n; i++)
    {
        in >> z;
        arr.push_back(z);
        ar[z].second++;
        if (ar[z].second == 1)
        {
            long long s = z;
            while(s > 0)
            {
                s /= 10;
                ar[z].first++;
            }
        }
        cnt[ar[z].first]++;
    //  cout << z << " " << ar[z].first << " " << ar[z].second << endl;
    }
//  for (long long i = 0; i < 10; i++)
//      cout << cnt[i] << " " << mul[i] << endl;
    //cout << endl;
    long long summ = 0;
    for (long long i = 0; i < arr.size(); i++)
    {
    //  cout << arr[i] << " " << summ << endl;
        for (long long j = 0; j < 10; j++)
        {
            summ = ((arr[i] * cnt[j] * mul[j]) % MOD + summ) % MOD;
        }
        summ = ((summ - arr[i] * mul[ar[arr[i]].first]*ar[arr[i]].second) % MOD + MOD) % MOD;
        summ = (summ + ((n - ar[arr[i]].second) * arr[i] )% MOD + MOD) % MOD;
    }
    out << summ;
}

void false_solve() {
	//ifstream in("input.txt");
	//ofstream out("foutput.txt");

	int n;
	cin >> n;

	vector<int> b(n);
	for (int i = 0; i < n; ++i)
		cin >> b[i];

	long long sum = 0;
	const int MOD = 1e9 + 7;
	n = b.size();
	for (int i = 0; i < n; ++i) {
		string s = inttostr(b[i]);
		for (int j = 0; j < n; ++j) {
			if (b[i] == b[j])
				continue;
			string g = inttostr(b[j]);
			g = s + g;
			sum += strtoint(g);
			sum %= MOD;
		}
	}

	cout << sum;
}

bool valid() {
	ifstream in("output.txt");
	ifstream fin("foutput.txt");

	string s, t;
	while (in >> s) {
		fin >> t;
		if (s != t)
			return false;
	}

	return true;
}

long long seed, a, b, m;
void init() {
	ifstream in("random.txt");
	in >> seed;
	a = 1020;
	b = 1227;
	m = 1e9 + 7;
}

int random() {
	ofstream out("random.txt");
	seed = (seed * a + b) % m;
	out << seed;
	return seed;
}

void gen() {
	ofstream out("input.txt");
	int n = random() % 100000 + 2;
	out << n << '\n';
	for (int i = 0; i < n; ++i)
		out << random() % 400 + 3 << ' ';
}

int main() {
	false_solve();
	return 0;
	init();

	for (int test = 1; test < 10; ++test) {
		gen();
		solve();
		false_solve();

		if (!valid()) {
			cout << "NO";
			return 0;
		}
	}

	cout << "YES";

	return 0;
}
