#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;

typedef long long ll;

const int MAXN = 1e5 + 7;
const ll INF = 1e18;

ll pref[MAXN];
ll ppl[MAXN];
ll d[MAXN];
ll d2[MAXN];
int pl2[MAXN];
ll d1[MAXN];
int pl1[MAXN];
ll a, b, c;
int ia, ib, ic;
int na, nb, nc;
int n;

ll D1(int i) {
	if (i == n) return 0;
	if (n - i > nc) return INF;
	if (i < ic)
		return pref[n] - pref[ic] - c * (n - ic) + c * (ic - i) - pref[ic] + pref[i];
	return pref[n] - pref[i] - c * (n - i);
}

int main() {
	cin >> a >> na >> b >> nb >> c >> nc;
	if (a > b) {
		swap(a, b);
		swap(na, nb);
	}
	if (a > c) {
		swap(a, c);
		swap(na, nc);
	}
	if (b > c) {
		swap(b, c);
		swap(nb, nc);
	}
	cin >> n;
	for (int i = 0; i < n; ++i) {
		cin >> ppl[i];
	}
	sort(ppl, ppl + n);
	for (int i = 0; i < n; ++i) {
		pref[i + 1] = pref[i] + ppl[i];
	}
	ia = upper_bound(ppl, ppl + n, na) - ppl;
	ib = upper_bound(ppl, ppl + n, nb) - ppl;
	ic = upper_bound(ppl, ppl + n, nc) - ppl;
	vector<int> v;
	for (int i = 0; i <= n; ++i) {
		d1[i] = D1(i);
		if (i) d1[i] += abs(ppl[i - 1] - b) + d1[i - 1] - D1(i - 1);
		while (v.size() && d1[i] > d1[v.back()])
			v.pop_back();
		if (v.size())
			pl1[i] = v.back();
		else
			pl1[i] = -1;
		v.push_back(i);
	}
	//cout << ic << '\n';
	//for (int i = 0; i < n; ++i)
	//	cout << D1(i) << ' ';
	//cout << '\n';
	//for (int i = 0; i < n; ++i)
	//	cout << pl1[i] << ' ';
	//cout << '\n';
	ll mi = n;
	for (int i = n; i >= 0; --i) {
		if (d1[mi] > d1[i]) mi = i;
		if (mi - i > nb) {
			mi = pl1[mi];
		}
		d[i] = -d1[i] + D1(i) + d1[mi];
	}
	//v.resize(0);
	//for (int i = 0; i <= n; ++i) {
	//	d2[i] = d[i];
	//	if (i) d[i] += abs(ppl[i - 1] - a) + d2[i - 1] - d[i - 1];
	//	while (v.size() && d2[i] > d2[v.back()])
	//		v.pop_back();
	//	if (v.size())
	//		pl2[i] = v.back();
	//	else
	//		pl2[i] = -1;
	//	v.push_back(i);
	//}
	//mi = n;
	ll sum = 0;
	ll res = INF;
	for (int i = 0; i <= na; ++i) {
		ll cres = d[i] + sum;
		if (res > cres) res = cres;
		sum += abs(ppl[i] - a);
	}
	cout << res << '\n';
	//while (1) ++res;
}

