import java.io.*;
import java.util.*;

public class C {
    static Map<String, String>[] stack = new Map[100000];
    static Map<String, Stack<Integer>> lastLayer = new HashMap<>();

    static TreeMap<String, TreeMap<Integer, String>> variables = new TreeMap<String, TreeMap<Integer, String>>();

    static int head = 0;

    static void exec() throws IOException {
        stack[head] = new HashMap<>();
        head++;
        while (reader.ready()) {
            String command = reader.readLine();
            if (command.equals("{")) {
                stack[head] = new HashMap<>();
                head++;
            } else if (!command.equals("}")) {
                String[] ss = command.split("=");
                String name = ss[0];
                String value = ss[1];
                boolean needOut = false;
                try {
                    Integer.parseInt(value);
                } catch (NumberFormatException e) {
                    needOut = true;
                    boolean foundValue = false;
                    String oldValue = value;
                    // System.out.println("***");
                    for (int i = head - 1; i >= 0; i--) {
                        // System.out.println(vars.toString());
                        Map<String, String> vars = stack[i];
                        if (vars.containsKey(oldValue)) {
                            value = vars.get(oldValue);
                            foundValue = true;
                            break;
                        }
                    }
                    // System.out.println("'" + value + "'");
                    if (!foundValue) {
                        value = "0";
                    }
                }
                if (!lastLayer.containsKey(name)) {
                    lastLayer.put(name, new Stack<>());
                }

                stack[head - 1].put(name, value);
                if (needOut) {
                    writer.write(value);
                    writer.newLine();
                }
                // System.out.println();
            } else {
                head--;
            }
        }
    }

    static void exec2() throws IOException {
        int cnt = 0;
        while (reader.ready()) {
            String command = reader.readLine();

            if (command.equals("{")) {
                cnt++;
            } else if (!command.equals("}")) {
                String[] ss = command.split("=");
                String name = ss[0];
                String value = ss[1];
                boolean needOut = false;
                try {
                    Integer.parseInt(value);
                } catch (NumberFormatException e) {
                    needOut = true;
                    if (!variables.containsKey(value)) {
                        TreeMap<Integer, String> tmp = new TreeMap<Integer, String>();
                        tmp.put(0, "0");
                        variables.put(value, tmp);
                    }
                    TreeMap<Integer, String> tmpha = variables.get(value);
                    value = tmpha.get(tmpha.floorKey(cnt));
                }
                if (!variables.containsKey(name)) {
                    TreeMap<Integer, String> tmp = new TreeMap<Integer, String>();
                    tmp.put(0, "0");
                    variables.put(name, tmp);
                }
                variables.get(name).put(cnt, value);

                if (needOut) {
                    writer.write(value);
                    writer.newLine();
                }


            } else {
                cnt--;
            }
        }
    }

    public static BufferedReader reader;
    static BufferedWriter writer = new BufferedWriter(new OutputStreamWriter(System.out));

    public static void main(String[] args) throws IOException {
        // reader = new BufferedReader(new InputStreamReader(new FileInputStream("input.in")));
        reader = new BufferedReader(new InputStreamReader(System.in));
        exec2();
        writer.flush();
        writer.close();
    }
}
