#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cmath>
#include <set>
#include <algorithm>
#include <iomanip>
#include <map>
#include <string>
#include <vector>
using namespace std;

pair < long long, long long > v[3];
long long x;
const int len = 2e5;
const long long inf = 1ll << 61;
long long a[len];

long long l[len], r[len];

long long c[len], d[len];

long long cl(int f, int s) {
	if(f != -1)
		return l[f] + c[f + 1] + d[s - 1] + r[s] - d[f] - c[s];
	return d[s - 1] + r[s] - c[s];
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	for (int i = 0; i < 3; i++)
		cin >> v[i].first >> v[i].second;
	cin >> x;
	for (int i = 0; i < x; i++)
		cin >> a[i];

	sort(a, a + x);
	sort(v, v + 3);

	long long lpos = v[0].second - 1;
	lpos = min(lpos, x - 1);
	long long rpos = x - v[2].second;
	rpos = max(rpos, 0ll);

	for (int i = 0; i <= lpos; i++) {
		l[i] = (i - 1 >= 0 ? l[i - 1] : 0) + abs(a[i] - v[0].first);
	}

	for (int i = x - 1; i >= rpos; i--) {
		r[i] = r[i + 1] + abs(a[i] - v[2].first);
	}

	for (int i = 0; i < x; i++) {
		if (a[i] >= v[1].first) {
			d[i] = (i - 1 >= 0 ? d[i - 1] : 0) +
				abs(a[i] - v[1].first);
		}
	}
	for (int i = x - 1; i >= 0; i--) {
		if (a[i] <= v[1].first) {
			c[i] = c[i + 1] +
				abs(a[i] - v[1].first);
		}
	}
	long long ans = inf;

	for (int i = 0; i <= lpos; i++) {
		if (x - i - 1 <= v[1].second) {
			ans = min(ans, cl(i, x));
		}

		if (i + 1 >= rpos) {
			ans = min(ans, l[i] + r[i + 1]);
		}
	}

	if (rpos == 0)
		ans = min(ans, r[0]);

	for (int i = x - 1; i >= rpos; i--) {
		if (i <= v[1].second) {
			ans = min(ans, cl(-1, i));
		}
	}

	for (long long i = 0; i <= lpos; i++) {
		long long L = max(rpos, i + 1), R = min(x - 1, i + v[1].second + 1);
		while (R - L > 1) {
			int m1 = L + (R - L) / 3;
			int m2 = R - (R - L) / 3;

			if (cl(i, m1) < cl(i, m2))
				R = m2;
			else
				L = m1;
		}

		for (int j = L; j <= R; j++) {
			if (ans > cl(i, j) && j - i - 1 <= v[1].second && x - j <= v[2].second) {
				ans = cl(i, j);
			}
		}
	}
	cout << ans;
}