#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cmath>
#include <set>
#include <algorithm>
#include <iomanip>
#include <map>
#include <string>
#include <vector>
using namespace std;

#define X first
#define Y second

const int len = 2010;
const long long INF = (1ll << 61);
pair<long long, int> d[len][len * 4];
long long dp[len][len], n, m, kd[len], kc[len], kp[len];
long long pr[len][len], in = 1, N = 1, prv, prin, no;
pair<long long, int> toc, obr = { INF, -1 };
map <long long, int> w;
set <long long> q;
vector<long long> ans;

void build(int B, int v, int vl, int vr)
{
	d[B][v] = obr;
	if (vl + 1 == vr)
		return;
	int vm = (vl + vr) / 2;
	build(B, v * 2 + 1, vl, vm);
	build(B, v * 2 + 2, vm, vr);
}

void upd(int B, int v, int vl, int vr, int L, int R, int ca, int cb)
{
	if (vl >= R || L >= vr)
		return;
	if (L <= vl && vr <= R)
	{
		if (d[B][v].X > ca)
		{
			d[B][v] = { ca, cb };
		}
		return;
	}
	int vm = (vl + vr) / 2;
	upd(B, v * 2 + 1, vl, vm, L, R, ca, cb);
	upd(B, v * 2 + 2, vm, vr, L, R, ca, cb);
	if (d[B][v * 2 + 1].X < d[B][v * 2 + 2].X)
	{
		d[B][v] = d[B][v * 2 + 1];
	}
	else
	{
		d[B][v] = d[B][v * 2 + 2];
	}
}

pair<long long, int> get(int B, int v, int vl, int vr, int L, int R)
{
	if (vl >= R || L >= vr)
		return obr;
	if (L <= vl && vr <= R)
	{
		return d[B][v];
	}
	int vm = (vl + vr) / 2;
	pair<long long, int> tmp1 = get(B, v * 2 + 1, vl, vm, L, R);
	pair<long long, int> tmp2 = get(B, v * 2 + 2, vm, vr, L, R);
	if (tmp1.X < tmp2.X)
		return tmp1;
	else
		return tmp2;
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	cin >> n >> m;
	for (int i = 1; i <= m; i++)
	{
		dp[0][i] = INF;
	}
	pr[0][0] = -1;
	for (int i = 1; i <= n; i++)
	{
		cin >> kd[i] >> kc[i] >> kp[i];
		q.insert(kd[i]);
	}
	for (set<long long>::iterator it = q.begin(); it != q.end(); it++)
	{
		w[*it] = in;
		in++;
	}
	while (N < (in + 2))
		N *= 2;
	for (int i = 1; i <= m; i++)
	{
		build(i, 0, 0, N);
	}
	for (int i = 1; i <= n; i++)
	{
		kd[i] = w[kd[i]];
		for (int j = m; j >= 1; j--)
		{
			if (j <= kc[i])
			{
				pr[i][j] = -1;
				dp[i][j] = kp[i];
				upd(j, 0, 0, N, kd[i], kd[i] + 1, kp[i], i);
			}
			else
			{
				toc = get(j - kc[i], 0, 0, N, kd[i], N);
				if (toc.X != INF)
				{
					dp[i][j] = toc.X + kp[i];
					pr[i][j] = toc.Y;
					upd(j, 0, 0, N, kd[i], kd[i] + 1, kp[i] + toc.X, i);
				}
				else
				{
					dp[i][j] = INF;
					pr[i][j] = -1;
				}
			}
		}
	}
	toc = get(m, 0, 0, N, 0, N);
	if (toc.X == INF)
	{
		cout << -1;
		return 0;
	}
	cout << toc.X << " ";
	prv = toc.Y;
	prin = m;
	while (true)
	{
		ans.push_back(prv);
		if (pr[prv][prin] == -1)
			break;
		no = prv;
		prv = pr[prv][prin];
		prin = prin - kc[no];
	}
	reverse(ans.begin(), ans.end());
	cout << ans.size() << endl;
	for (int i = 0; i < ans.size(); i++)
	{
		cout << ans[i] << " ";
	}
}