#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cmath>
#include <set>
#include <algorithm>
#include <iomanip>
#include <map>
#include <string>
using namespace std;

const int len = 2e5;
const long long mod = 1e9 + 7;
long long a[len];
int ln(int x) {
	int ans = 0;
	while (x > 0) {
		x /= 10;
		ans++;
	}
	return ans;
}

long long pw(long long x, long long y) {
	if (y == 0)
		return 1;
	return (x * pw(x, y - 1)) % mod;
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	int x;
	cin >> x;
	long long sum = 0;
	for (int i = 0; i < x; i++) {
		cin >> a[i];
		sum += a[i];
	}
	long long ans = 0;
	for (int i = 0; i < x; i++) {
		long long now = sum - a[i];
		now *= pw(10, ln(a[i]));
		now %= mod;
		if (now < 0)
			now += mod;
		now += a[i] * (x - 1);
		now %= mod;
		if (now < 0)
			now += mod;
		ans += now;
		ans %= mod;
		if (ans < 0)
			ans += mod;
	}
	cout << ans;
}