#define _USE_MATH_DEFINES
#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <string>
#include <map>
#include <vector>
#include <set>
#include <algorithm>
#include <math.h>
#include <cmath>
#include <stack>
#include <queue>
#include <deque>
#include <climits>
#include <stdio.h>
#include <ctime>
using namespace std;

typedef long long ll;
typedef unsigned long long llu;

#define all(n) n.begin(), n.end()
#define speed ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
#define files freopen("input.txt", "rt", stdin); freopen("output.txt", "wt", stdout)

bool eof = 0;

string Read()
{
	char c = _getc_nolock(stdin);
	while (!isalpha(c) && !isdigit(c) && c != '=' && c != '}' && c != '{' && c != '-')
	{
		if (c == -1)
			break;
		c = _getc_nolock(stdin);
	}
	string x = "\nsToP\n";
	while (isalpha(c) || isdigit(c) || c == '=' || c == '}' || c == '{' || c == '-')
	{
		if (x == ("\nsToP\n"))
			x.clear();
		x.push_back(c);
		c = _getc_nolock(stdin);
	}
	if (c == -1)
		eof = 1;
	return x;
}

void callStack()
{
	map<string, int> nv;
	stack<map<string, int>> cll;
	cll.push(nv);
	while (!cll.empty())
	{
		nv = cll.top();
		cll.pop();
		string d;
		while (!eof)
		{
			d = Read();
			if (d == "\nsToP\n")
				break;
			if (d.front() == '}')
				break;
			if (d == "{")
			{
				cll.push(nv);
				continue;
			}
			string v1, v2;
			int i = 0, val = INT_MAX;
			while (d[i] != '=') v1.push_back(d[i++]);
			++i;
			if (isdigit(d[i]) || d[i] == '-')
				val = atoi(d.substr(i, d.size() - i).c_str());
			else
				v2 = d.substr(i, d.size() - i);
			if (val == INT_MAX)
			{
				if (nv.find(v2) == nv.end())
					nv[v2] = 0;
				nv[v1] = nv[v2];
				cout << nv[v2] << endl;
			}
			else
				nv[v1] = val;
		}
	}
}

int main()
{
	//speed;
	//files;
	callStack();
	return 0;
}