
#include <bits/stdc++.h>

using namespace std;

#define F first
#define S second
#define pb push_back
#define m_p make_pair
#define m_t make_tuple

typedef long long ll;
typedef long double ld;

const int mod = (int)(1e9) + 7;

const int N = 100100;

ll pref[N][3];
pair<int, int> p[3];
int x[N];

ll sum(int l, int r, int x){
  if (r - l + 1 > p[x].S) return 1e16;
  if (l > r) return 0;
  return pref[r][x] - (l == 0 ? 0 : pref[l - 1][x]);
}

int main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  cout.tie(0);
#ifdef LOCAL
  freopen("input.txt", "r", stdin);
//  freopen("output.txt", "w", stdout);
#endif // LOCAL
  for (int i = 0; i < 3; i++){
    cin >> p[i].F >> p[i].S;
  }
  sort(p, p + 3);
  int n;
  cin >> n;
  for (int i = 0; i < n; i++) cin >> x[i];
  sort(x, x + n);
  for (int i = 0; i < n; i++) {
    for (int j = 0; j < 3; j++){
      pref[i][j] = abs(p[j].F - x[i]);
      if (i > 0) pref[i][j] += pref[i - 1][j];
    }
  }
  ll ans = 1e18;
  for (int i = -1; i < p[0].S; i++){
    ll cur = sum(0, i, 0);
    if (i == n - 1){
      ans = min(ans, cur);
      continue;
    }
//    cerr << ans << endl;
    int l = i + 1, r = min(i + 1 + p[1].S - 1, n - 1);
    if (n - l <= p[2].S)
      ans = min(ans, cur + sum(l, n - 1, 2));
    if (n - l <= p[1].S)
      ans = min(ans, cur + sum(i + 1, n - 1, 1));
    int cl, cr;
    if ((p[2].F - p[1].F) % 2 == 1){
      cl = l;
      cr = r;
    }
    else{
      int mid = (p[2].F + p[1].F) >> 1;
      int l1 = (int)(lower_bound(x, x + n, mid) - x);
      int r1 = (int)(upper_bound(x, x + n, mid) - x) - 1;
      l1 = max(l1, l);
      r1 = min(r1, r);
      if (l1 <= r1 && l1 < n && x[l1] == mid){
        if (l1 - l >= p[1].S){
          cur += sum(l, min(l + p[1].S - 1, n - 1), 1);
          cur += sum(min(l + p[1].S - 1, n - 1) + 1, n - 1, 2);
          ans = min(ans, cur);
          continue;
        }
        if (r1 - l + 1 == p[1].S){
          cur += sum(l, r1, 1);
          cur += sum(r1 + 1, n - 1, 2);
          ans = min(ans, cur);
          continue;
        }
        if (r1 - l + 1 > p[1].S){
          cl = r1 + 1, cr = min(l + p[1].S - 1, n - 1);
        }
        else{
          cur += sum(l, min(l + p[1].S - 1, n - 1), 1);
          cur += sum(min(l + p[1].S - 1, n - 1) + 1, n - 1, 2);
          ans = min(ans, cur);
          continue;
        }
      }
      else{
        cl = l;
        cr = r;
      }
    }
    cl = max(cl, n - 1 - p[2].S);
    while (cr - cl >= 7){
      int l1 = cl + (cr - cl) / 3;
      int r1 = cr - (cr - cl) / 3;
      ll sl = sum(l, l1, 1) + sum(l1 + 1, n - 1, 2);
      ll sr = sum(l, r1, 1) + sum(r1 + 1, n - 1, 2);
      if (sl < sr){
        cr = r1;
      }
      else{
        cl = l1;
      }
    }
    for (int j = cl; j <= cr; j++){
      ans = min(ans, cur + sum(l, j, 1) + sum(j + 1, n - 1, 2));
    }
//    cout << i << ' ' << ans << endl;
  }
  cout << ans << endl;
  return 0;
}
