#include <iostream>
#include <vector>
#include <string>

using namespace std;

typedef long long ll;
typedef long double ld;

#define forn(i, n) for (int i = 0; i < n; i++)

const ll mod = (ll)1e+9 + 7ll;

int dec(ll x)
{
	int res = 0;
	if (x == 0ll)
		return 1;

	while (x)
	{
		res++;
		x /= 10ll;
	}
	return res;
}

ll have[15];

ll pow10(ll n)
{
	ll res = 1ll;
	while (n)
	{
		res = (res * 10ll) % mod;
		n--;
	}
	return res;
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	ll n;
	cin >> n;

	ll sum = 0ll;
	vector <ll> arr(n);
	forn(i, n)
	{
		cin >> arr[i];
		have[dec(arr[i])]++;
		sum = (sum + (arr[i] * (n - 1ll)) % mod) % mod;
	}

	forn(i, n)
	{
		for (ll j = 1; j < 15ll; j++)
		{
			ll d1 = (arr[i] * pow10(j)) % mod, d2;
			if (dec(arr[i]) == j)
				d2 = d1 * (have[j] - 1ll) % mod;
			else
				d2 = d1 * have[j] % mod;
			sum = (sum + d2) % mod;
		}
	}
	cout << sum;
	
    return 0;
}

