from sys import setrecursionlimit
import threading

setrecursionlimit(10 ** 9)
threading.stack_size(67108864)


def main():
    try:
        level = 0
        p = dict()
        todel = [set()]
        while True:
            s = input()
            if s == '{':
                level += 1
                todel.append(set())
            elif s == '}':
                level -= 1
                for x in todel[-1]:
                    p[x].pop()
                todel.pop()
            else:
                p1, z = s.split('=')
                try:
                    z = int(z)
                except ValueError:
                    try:
                        z = p[z][-1]
                    except KeyError:
                        z = 0
                    print(z, flush=False)
                if p1 in todel[-1]:
                    p[p1][-1] = z
                else:
                    todel[-1].add(p1)
                    try:
                        p[p1].append(z)
                    except KeyError:
                        p[p1] = [z]
    except EOFError:
        pass

thread = threading.Thread(target=main)
thread.start()
