#include <iostream>
#include <string>
#include <vector>
#include <map>
#include <stack>
#include <algorithm>
#include <math.h>

#define mp make_pair
#define pb push_back

typedef long long ll;

using namespace std;

pair <ll, ll> q[3];
pair <ll, ll> l, r, m;
ll n;
ll a[101000];
ll ans;

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	for (ll i = 0; i < 3; i++) {
		cin >> q[i].first >> q[i].second;
	}
	sort(q, q + 3);
	l = q[0];
	m = q[1];
	r = q[2];
	cin >> n;
	for (ll i = 0; i < n; i++) {
		cin >> a[i];
	}
	sort(a, a + n);
	double x = (l.first + m.first) / 2, y = (m.first + r.first) / 2;
	ll lu = 0, ru = n - 1;
	while (a[lu] <= x && l.second > 0) {
		ans += abs(a[lu] - l.first);
		l.second--;
		lu++;
	}
	while (a[ru] >= y && r.second > 0) {
		ans += abs(a[ru] - r.first);
		r.second--;
		ru--;
	}
	if (l.second == 0) {
		while (lu <= ru) {
			if (m.second > 0) {
				ans += abs(a[lu] - m.first);
				m.second--;
			}
			else {
				ans += abs(a[lu] - r.first);
				r.second--;
			}
			lu++;
		}
	}
	if (r.second == 0) {
		while (ru >= lu) {
			if (m.second > 0) {
				ans += abs(a[ru] - m.first);
				m.second--;
			}
			else {
				ans += abs(a[ru] - l.first);
				l.second--;
			}
			ru--;
		}
	}
	ll res = 0;
	ll uk1 = lu;
	while (m.second > 0 && lu <= ru) {
		res += abs(a[lu] - m.first);
		lu++;
		m.second--;
	}
	ll supres = res;
	ll uk = lu;
	ll q1 = ru;
	ll q2 = r.second;
	while (q2 >= 0 && q1 >= lu)
	{
		supres += abs(a[q1] - r.first);
		q1--;
		q2--;
	}
	q2 = l.second;
	while (q2 >= 0 && q1 >= lu)
	{
		supres += abs(a[q1] - l.first);
		q2--;
		q1--;
	}
	while (q1 >= lu)
	{
		supres += abs(a[q1] - m.first);
		q1--;
	}

	while (uk <= ru)
	{
		res += abs(a[uk] - r.first);
		uk++;
		r.second--;
	}
	if (l.second >= 0 && r.second >= 0)
		supres = min(res, supres);
	while (lu <= ru)
	{
		res += abs(a[uk1] - l.first);
		res -= abs(a[uk1] - m.first);
		res -= abs(a[lu] - r.first);
		res += abs(a[lu] - m.first);
		uk1++;
		lu++;
		r.second++;
		l.second--;
		if (l.second >= 0 && r.second >= 0)
			supres = min(res, supres);
	}
	cout << ans + supres;
}