// anime.cpp : Defines the entry point for the console application.
//

#include <iostream>
#include <vector>
#include <algorithm>
#include <cstdio>
#include <string>
#include <map>
#include <stack>

using namespace std;


int main()
{
	map<string, stack<pair<int, int> > >dct;
	string s;
	vector<int> answ;
	long long depth = 0;
	while (cin >> s)
	{
		if (s == "{")
		{
			depth++;
		}
		else if (s == "}")
		{
			depth--;
		}
		else if (s != "")
		{
			string t;
			int p = 0;
			while (s[p] != '=')
			{
				t.push_back(s[p]);
				p++;
			}
			p++;
			if (s[p] >= 'a' && s[p] <= 'z')
			{
				string t2;
				while (p < s.size())
				{
					t2.push_back(s[p]);
					p++;
				}
				while (!dct[t2].empty() && dct[t2].top().second > depth)
					dct[t2].pop();
				if (dct[t2].empty())
					dct[t2].push({ 0, depth });
				if (t != t2)
				{
					while (!dct[t].empty() && dct[t].top().second >= depth)
						dct[t].pop();
					dct[t].push({ dct[t2].top().first, depth });
				}
				cout << dct[t].top().first << endl;
			}
			else
			{
				bool mins = 0;
				if (s[p] == '-')
				{
					mins = 1;
					p++;
				}
				int num = 0;
				while (p < s.size())
				{
					num = num * 10 + (s[p] - '0');
					p++;
				}
				if (mins)
					num = -num;
				while (!dct[t].empty() && dct[t].top().second >= depth)
					dct[t].pop();
				dct[t].push({ num, depth });
			}
		}
	}
	return 0;
}