import java.util.*;
import java.io.*;

public class C {
	FastScanner in;
	PrintWriter out;
	
	static HashMap<Long, Integer> mem;

	public void solve() {
		mem = new HashMap<Long, Integer>();

		while (in.hasNext()) {
			String s = in.next();
	 
			if (s.compareTo("{") == 0) {
				
				work();
				continue;
			}
			int i = 0;
			for (; i < s.length(); i++) {
				if (s.charAt(i) == '=')
					break;
			}

			String a = s.substring(0, i);
			String b = s.substring(i + 1);

			if (b.charAt(0) == '-' || ('0' <= b.charAt(0) && b.charAt(0) <= '9')) {
				mem.put(get(a), Integer.parseInt(b));
			} else {
				if (!mem.containsKey(get(a))) {
					mem.put(get(a), 0);
				}
				if (!mem.containsKey(get(b))) {
					mem.put(get(b), 0);
				}
				mem.put(get(a), mem.get(get(b)));
				out.println(mem.get(get(b)));
			}
		}
	}

	public void work() {
		Deque<Long> retn = new LinkedList<Long>();
		Deque<Integer> retv = new LinkedList<Integer>();
		while (true) {
			String s = in.next();
			if (s.compareTo("{") == 0) {
				work();
				continue;
			}
			if (s.compareTo("}") == 0) {
				while (!retn.isEmpty()) {
					long n = retn.pollFirst();
					int v = retv.pollFirst();
					mem.put(n, v);
				}
				return;
			}
			int i = 0;
			for (; i < s.length(); i++) {
				if (s.charAt(i) == '=')
					break;
			}

			String a = s.substring(0, i);
			String b = s.substring(i + 1);

			if (b.charAt(0) == '-' || ('0' <= b.charAt(0) && b.charAt(0) <= '9')) {
				retn.addFirst(get(a));
				retv.addFirst(mem.get(get(a)));
				mem.put(get(a), Integer.parseInt(b));
			} else {
				if (!mem.containsKey(get(a))) {
					mem.put(get(a), 0);
				}
				if (!mem.containsKey(get(b))) {
					mem.put(get(b), 0);
				}
				retn.addFirst(get(a));
				retv.addFirst(mem.get(get(a)));
				mem.put(get(a), mem.get(get(b)));
				out.println(mem.get(get(b)));
			}
		}
	}
	
	public long get(String s) {
		long hash = 0;
		for (int i = 0; i < s.length(); i++) {
			hash *= 31;
			hash += (s.charAt(i)-'a'+1);
		}
		return hash;
	}

	public void run() {
		in = new FastScanner();
		out = new PrintWriter(new BufferedWriter(new OutputStreamWriter(System.out)));
		solve();
		out.close();
	}

	class FastScanner {
		StringTokenizer st;
		BufferedReader br;

		FastScanner() {
			br = new BufferedReader(new InputStreamReader(System.in));
		}

		String next() {
			while (st == null || !st.hasMoreTokens()) {
				try {
					st = new StringTokenizer(br.readLine());
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
			return st.nextToken();
		}

		int nextInt() {
			return Integer.parseInt(next());
		}

		long nextLong() {
			return Long.parseLong(next());
		}

		double nextDouble() {
			return Double.parseDouble(next());
		}

		boolean hasNext() {
			if (st != null && st.hasMoreTokens())
				return true;
			try {
				String s = br.readLine();
				if (s == null) {
					return false;
				} else {
					st = new StringTokenizer(s);
					return true;
				}
			} catch (IOException e) {
				e.printStackTrace();
			}
			return false;
		}
	}

	public static void main(String[] args) {
		new C().run();
	}
}
