#include <bits/stdc++.h>
using namespace std;

#define F first
#define S second
#define pb push_back
#define mp make_pair
#define fst first
#define snd second
#define rep(i,a,n) for(int i=(a);i<(n);++i)
#define per(i,a,n) for(int i=(n)-1;i>=(a);--i)
#define all(x) (x).begin(),(x).end()

template <typename T1, typename T2>
bool umin(T1 &x, const T2 &y) {if(x>y)return x=y,true; return false;}
template <typename T1, typename T2>
bool umax(T1 &x, const T2 &y) {if(x<y)return x=y,true; return false;}

template<typename T>
T getint() {
    T x = 0, p = 1;
    char ch;
    do {ch = getchar();} while(ch <= ' ');
    if (ch == '-') p = -1, ch = getchar();
    while ('0' <= ch && ch <= '9') {
        x = x*10 + ch-'0';
        ch = getchar();
    }
    return x*p;
}

typedef long long ll;
typedef long double ld;
typedef pair<int,int> pii;
typedef vector<int> vi;
typedef vector<ll> vll;

const int N = (int)1e6+10;
const int INF = (int)2e9+10;
const ll mod = (ll)1e9+7;
const ll LLINF = (ll)1e18+10;
const ld pi = (ld)acos(-1.0);

ll cnt;
ll pot[N];
vector<ll> res;


bool isprime(ll x) {
    if (x == 1 || x == 0) return false;
    for(ll d = 2; 1ll*d*d <= x; ++d) {
        if (x % d == 0) return false;
    }
    return true;
}

void solve(ll x, int add) {
    if(x > (ll)1e10) return;
    if (add > 11) return;
   // if (add == 9) ++cnt;
//    cout << x << ' ' << add << endl;
    rep(i, 1, 10) {
        ll cur = x+i*pot[add];
        if (isprime(cur)) {
            res.push_back(cur);
            solve(cur, add+1);
        }
    }
}


int main()
{
    ios_base::sync_with_stdio(0);
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);

    ll l, r;
    cin >> l >> r;
    pot[0] = 1;
    rep(i, 1, 13) pot[i] = pot[i-1] * 10;
    solve(0, 0);
    sort(all(res));
//    cout << cnt << endl;
//    cout << res.size() << endl;
    cout << upper_bound(all(res), r)-lower_bound(all(res), l) << endl;
    return 0;
}
