#include <iostream>
#include <string>
#include <algorithm>
#include <vector>
#include <sstream>
#include <map>
#include <stack>

using namespace std;

int main() {
    map<string, int> val;

    string in;
    stack<vector<pair<string, int>>> ba;
    ba.push(vector<pair<string, int>>(0));
    stringstream s;

    while(getline(cin, in)) {
        if(in == "0")
            break;
        if(in == "{")
            ba.push(vector<pair<string, int>>(0));
        else if(in == "}") {
            for(auto p : ba.top())
                val[p.first] = p.second;
            ba.pop();
        }
        else {
            bool w = false;
            string a, b;
            for(char now : in) {
                if(now == '=') {
                    w = true;
                    continue;
                }

                if(!w)
                    a += now;
                else
                    b += now;
            }

            if(b[0] <= '9') {
                s << b;
                int now;
                s >> now;
                s.clear();
                ba.top().push_back(make_pair(a, val[a]));
                val[a] = now;
                //cout << b << endl;
            }
            else {
                ba.top().push_back(make_pair(a, val[a]));
                val[a] = val[b];
                cout << val[b] << endl;
            }
        }
    }


    return 0;
}
