#include <iostream>
#include <string>
#include <algorithm>
#include <vector>
#include <sstream>

using namespace std;

const long long M = 1e9 + 7;

bool prime(long long n) {
    if(n == 1)
        return false;
    for(long long d = 2; d * d <= n; d++) {
        if(n % d == 0)
            return false;
    }
    return true;
}

bool ok(long long n) {
    stringstream s;
    string str;
    s << n;
    s >> str;
    s.clear();
    bool ans = true;
    string now;
    for(int i = str.size() - 1; i >= 0; i--) {
        now = str[i] + now;
        long long curr;
        if(str[i] == '0')
            ans = false;
        s << now;
        s >> curr;
        s.clear();
        ans = ans && prime(curr);
    }
    return ans;
}

int main() {
    /*int now = 2;
    int cnt = 0;
    while(now < 10000000) {
        if(ok(now)) {
            cout << now << endl;
            cnt++;
        }
        now++;
    }
    cout << endl << cnt << endl;

    vector<vector<long long>> ans(11);
    for(int i = 1; i < 10; i++)
        ans[0].push_back(i);

    stringstream s;

    for(int i = 0; i < 10; i++) {
        for(long long now : ans[i]) {
            s << now;
            string st;
            s >> st;

        }
    }*/
    long long k;
    cin >> k;

    long long n = 4 * k * k * k * k + 8 * k * k * k + 5 * k * k + k;
    cout << n << endl;

    return 0;
}
