#include <iostream>
#include <string>
#include <algorithm>
#include <vector>
#include <sstream>

using namespace std;

const long long M = 1e9 + 7;

int fac(long long n) {
    if(n < 10)
        return 0;
    else if(n < 100)
        return 1;
    else if(n < 1000)
        return 2;
    else if(n < 10000)
        return 3;
    else if(n < 100000)
        return 4;
    else if(n < 1000000)
        return 5;
    else if(n < 10000000)
        return 6;
    else if(n < 100000000)
        return 7;
    else
        return 8;
}

int main() {
    long long sum = (long long)0;
    int n;
    cin >> n;
    vector<long long> v(n);
    for(int i = 0; i < n; i++) {
        cin >> v[i];
        sum += v[i];
        sum %= M;
    }

    long long ans = (long long)0;
    for(int i = 0; i < n; i++) {
        long long now = (sum - v[i] + M) % M;
        for(int j = 0; j < fac(v[i]) + 1; j++)
            now = (now * 10) % M;
        now += (long long)(n - 1) * v[i];
        now %= M;

        ans += now;
        ans %= M;
    }

    cout << ans << endl;

    return 0;
}
