#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <unordered_map>

long long tenPowers[10];

bool isPrime(long long n) {
	for (long long i = 2; i * i <= n; ++i) {
		if (n % i == 0) {
			return false;
		}
	}
	return true;
}

int main(void) {
	std::ios::sync_with_stdio(false);
	long long a, b;
	std::cin >> a >> b;
	tenPowers[0] = 1;
	for (int i = 1; i < 10; ++i) {
		tenPowers[i] = tenPowers[i - 1] * 10;
	}
	std::vector<long long>cur({ 3, 5, 7 });
	long long answ = 0;
	for (auto i : cur) {
		if (a <= i && i <= b) {
			answ++;
		}
	}
	for (int level = 1; level < 10; ++level) {
		std::vector<long long> new_cur;
		for (int i = 0; i < cur.size(); ++i) {
			for (int z = 1; z < 10; ++z) {
				if (isPrime(tenPowers[level] * z + cur[i])) {
					new_cur.push_back(tenPowers[level] * z + cur[i]);
					if (a <= tenPowers[level] * z + cur[i] && b >= tenPowers[level] * z + cur[i]) {
						answ++;
					}
				}
			}
		}
		std::swap(new_cur, cur);
	}
	std::cout << answ;
	return 0;
}