#include <iostream>
#include <vector>
#include <string>
#include <stack>
#include <unordered_map>
using namespace std;

pair<string, string> temp;
string s, x, y;
vector<int> p_pow(10, 1);

pair<string, string> razb(string &s) {
	bool b = false;
	pair<string, string> ans = { "", "" };
	for (char ch : s) {
		if (ch == '=')
			b = true;
		else {
			if (b)
				ans.second += ch;
			else
				ans.first += ch;
		}
	}
	return ans;
}

int numb(string s) {
	int ans = 0, start = 0;
	bool minus = false;
	if (s[0] == 45) {
		minus = true;
		start = 1;
	}
	for (int i = start; i < s.length(); i++) {
		ans += p_pow[s.length() - 1 - i] * (s[i] - 48);
	}
	if (minus)
		ans *= -1;
	return ans;
}

void dno(unordered_map<string, int> &m) {
	stack<pair<string, int> > st;
	while (true) {
		cin >> s;
		if (s == "{")
			dno(m);
		else if (s == "}")
			break;
		else {
			temp = razb(s);
			x = temp.first;
			y = temp.second;
			if (m.count(x) > 0)
				st.push({ x, m[x] });
			else
				st.push({ x, 0 });
			if (y[0] < 97) {
				m[x] = numb(y);
			}
			else {
				if (m.count(y) > 0) {
					m[x] = m[y];
					cout << m[y] << '\n';
				}
				else {
					m[x] = 0;
					cout << "0\n";
				}
			}
		}
	}
	while (!st.empty()) {
		m[st.top().first] = st.top().second;
		st.pop();
	}
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	for (int i = 1; i < 10; i++) {
		p_pow[i] = p_pow[i - 1] * 10;
	}
	unordered_map<string, int> m;
	while (cin >> s) {
		if (s == "{")
			dno(m);
		else {
			temp = razb(s);
			x = temp.first;
			y = temp.second;
			if (y[0] < 97) {
				m[x] = numb(y);
			}
			else {
				if (m.count(y) > 0) {
					m[x] = m[y];
					cout << m[y] << '\n';
				}
				else {
					m[x] = 0;
					cout << "0\n";
				}
			}
		}
	}
}