#include <bits/stdc++.h>

#define len(v) ((int)v.size())


using namespace std;


bool is_char(char c) {
	return ('a' <= c && c <= 'z') || ('A' <= c && c <= 'Z');
}


map<string, string> values;


void solve() {
	
	vector<pair<string, string>> changes;
	string s;
	while (cin >> s) {
		if (s == "{") {
			solve();			
		} else if (s == "}") {
			reverse(changes.begin(), changes.end());
			for (pair<string, string> change : changes) {
				values[change.first] = change.second;
			}
			return;
		} else {
			int eq = -1;
			for (int i = 0; i < len(s); i++) {
				if (s[i] == '=') {
					eq = i;
					break;
				}
			}
			string first = string(s.begin(), s.begin() + eq);
			string second = string(s.begin() + eq + 1, s.end());
			if (!values.count(first)) values[first] = "0";
			if (!values.count(second)) values[second] = "0";
			changes.emplace_back(first, values[first]);
			if (is_char(second[0])) {
				cout << values[second] << "\n";
				values[first] = values[second];
			} else {
				values[first] = second;
			}
		}
	}
	exit(0);
}


signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	solve();	

}
