#include <bits/stdc++.h>


using namespace std;

int n, m;
int cur = 1;

struct Edge {
	int to;
	double w;
	int id;

	Edge() {}
	Edge(int _to, int _w, int _id) {
		to = _to;
		w = _w;
		id = _id;
	}
};

struct Event {
	double dead_at;
	int eid;

	Event() {}
	Event(int _eid, double _dead_at) {
		eid = _eid;
		dead_at = _dead_at;
	}

	friend bool operator<(const Event &a, const Event &b) {
		return make_pair(a.dead_at, a.eid) < make_pair(b.dead_at, b.eid);
	}
};

vector<vector<Edge>> g;
vector<int> fuck;
vector<bool> alive_edge;
vector<bool> alive;
vector<double> death_time;
vector<pair<int, int>> edges;


signed main() {
	cin >> n;
	m = n - 1;
	
	g.resize(n);
	alive.resize(n, true);
	alive_edge.resize(m, true);
	fuck.resize(m, 0);
	death_time.resize(n, -1);
	edges.resize(m);
	
	for (int i = 0; i < m; i++) {
		int a, b;
		cin >> a >> b;
		a--;
		b--;
		edges[i].first = a;
		edges[i].second = b;
		int w;
		cin >> w;
		g[a].emplace_back(b, w, i);
		g[b].emplace_back(a, w, i);
	}

	set<Event> events;
	
	auto kill = [&events](int v, double time) {
		if (!alive[v]) return;
		death_time[v] = time;
		alive[v] = false;
		int near = 0;
		for (Edge sub : g[v]) {
			if (!alive_edge[sub.id]) continue;
			near++;
			if (death_time[sub.to] == -1) {
				events.emplace(sub.id, time + sub.w);
			} else {
				events.emplace(sub.id, time + (sub.w - death_time[sub.to]) / 2);
			}
		}
		cur += near - 1;
	};

	int k;
	cin >> k;
	for (int i = 0; i < k; i++) {
		int x;
		cin >> x;
		x--;
		kill(x, 0);
	}
	int rez = 0;
	double pref = -1e9;
	while (!events.empty()) {
		Event e = *events.begin();
		events.erase(events.begin());
		if (e.dead_at != pref) {
			rez = max(rez, cur);
		}

		alive_edge[e.eid] = false;
		kill(edges[e.eid].first, e.dead_at);
		kill(edges[e.eid].second, e.dead_at);
	}
	cout << rez << endl;
}

