#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef vector<int> vi;

#define X first
#define Y second
#define inb push_back
#define mk make_pair
#define all(v) (v).begin(), (v).end()

const ll LINF = 8e18;

int solve()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    vector<pii> pt(3);
    for (int i = 0; i < 3; ++i)
    {
        cin >> pt[i].X >> pt[i].Y;
    }
    sort(all(pt));
    ll ans = LINF;
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; ++i)
        cin >> a[i];
    sort(all(a));
    vector<ll> pr(n);
    pr[0] = a[0];
    for (int i = 1; i < n; ++i)
    {
        pr[i] = pr[i - 1] + a[i];
    }
    auto get_sum = [&](int l, int r)
    {
        if (!l)
            return pr[r];
        return pr[r] - pr[l - 1];
    };
    vector<vector<ll>> p(3, vector<ll>(n));
    for (int i = 0; i < 3; ++i)
        p[i][0] = abs(pt[i].X - a[0]);
    for (int id = 0; id < 3; ++id)
    {
        for (int i = 1; i < n; ++i)
        {
            p[id][i] = p[id][i - 1] + abs(a[i] - pt[id].X);
        }
    }
    auto gsr = [&](int id, int l, int r)
    {
        if (l > r)
            return 0ll;
        if (!l)
            return p[id][r];
        return p[id][r] - p[id][l - 1];
    };
    for (int cnt1 = 0; cnt1 <= min(n, pt[0].Y); ++cnt1)
    {
        int ost = n - cnt1;
        if (ost > pt[1].Y + pt[2].Y)
            continue;
        int l = max(0, n - cnt1 - pt[2].Y), r = min(pt[1].Y, n - cnt1);
        while (r - l > 3)
        {
            int m1 = l + (r - l) / 3;
            int m2 = r - (r - l) / 3;
            ll f1 = gsr(1, cnt1, cnt1 + m1 - 1) + gsr(2, cnt1 + m1, n - 1);
            ll f2 = gsr(1, cnt1, cnt1 + m2 - 1) + gsr(2, cnt1 + m2, n - 1);
            if (f1 >= f2)
                l = m1;
            else
                r = m2;
        }
        for (; l <= r; ++l)
        {
            ans = min(ans, gsr(0, 0, cnt1 - 1) + gsr(1, cnt1, cnt1 + l - 1) + gsr(2, cnt1 + l, n - 1));
        }
    }
    cout << ans << "\n";
    return 0;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie();
    cout.tie();
    #ifdef _DEBUG
    freopen("01.txt", "r", stdin);
    #endif // _DEBUG
    solve();
    return 0;
}

