#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>

using ll = long long;

ll MOD = 1e9 + 7;

ll mod(ll x) {
    return ((x % MOD + MOD) % MOD);
}
int main() {
    int n;
    std::cin >> n;
    std::vector<ll> a(n + 1);
    ll s = 0;
    ll k = 0;
    for (int i = 1; i <= n; ++i) {
        std::cin >> a[i];
    }
    for (int i = 1; i <= n; ++i) {
        s += mod(a[i]);
        s = mod(s);
        k += mod(ll(pow(10, (ll)log10(a[i]) + 1)));
        k = mod(k);
    }
    //std::cout << s << " " << k << "\n";
    ll sum = 0;
    for (int i = 1; i <= n; ++i) {
        sum += mod(mod(a[i] * (k - (ll)pow(10, (ll)log10(a[i]) + 1)) + s - a[i]));

    }
    std::cout << sum;
    return 0;
}

