#include <bits/stdc++.h>

using namespace std;

struct node
{
    map<char, node*> tr;
    node* par;
    long long val;
    bool term;
    node() {
        term = false;
        val = 0;
    }
};

string add;

node* add_string(node* n, int pr, long long v)
{
    if (pr == add.size())
    {
        node *nn = new node(*n);
        nn->term = true;
        nn->val = v;
        return nn;
    }

    if (n->tr.find(add[pr]) == n->tr.end()) {
        node *nn = new node(*n);
        node *tmp = nn;
        for (;pr < add.size(); ++pr) {
            node *tmp2 = new node();
            tmp2->par = tmp;
            tmp->tr[add[pr]] = tmp2;
            tmp = tmp2;
        }
        tmp->term = 1;
        tmp->val = v;
        return nn;
    } else {
        node *nn = new node(*n);
        nn->tr[add[pr]] = add_string(n->tr[add[pr]], pr + 1, v);
        return nn;
    }
}

long long get_val(node *n, string key) {
    node* tmp = n;
    for (char c : key) {
        if (tmp->tr.find(c) == tmp->tr.end())
            return 0;
        tmp = tmp->tr[c];
    }
    if (!tmp->term)
        return 0;
    return tmp->val;
}

vector<node*> rev;
int r = 0;

int main() {
    rev.push_back(new node());
    stack<int> rs;
    rs.push(0);
    string q;
    while (cin >> q) {
        if (q == "{") {
            node * new_root = rev[r];
            rev.push_back(new_root);
            r = rev.size() - 1;
            rs.push(r);
        } else
        if (q == "}") {
            rs.pop();
            r = rs.top();
        } else {
            string name = "";
            int i;
            for (i = 0; i < q.size(); ++i)
            {
                if (q[i] == '=') break;
                name += q[i];
            }
            long long v = 0;
            string from = "";
            for (i++; i < q.size(); ++i)
                from += q[i];
            if (from[0] >= 'a' && q[0] <= 'z') {
                v = get_val(rev[r], from);
                cout << v << endl;
            } else {
                v = atoi(from.c_str());
            }
            add = name;
            node* p = add_string(rev[r], 0, v);
            rev.push_back(p);
            r = rev.size() - 1;
            rs.pop();
            rs.push(r);
        }
    }
}