﻿using System;

namespace ConsApp2
{
    class Program
    {
        static void Main(string[] args)
        {
            int n = int.Parse(Console.ReadLine());
            long[] a = Array.ConvertAll(Console.ReadLine().Split(), long.Parse);
            long[] aPows = new long[a.Length];

            const int powsCount = 9;
            long[] powers = new long[powsCount];
            long[] powValues = { 10, 100, 1000, 10_000, 100_000, 1_000_000, 10_000_000, 100_000_000 , 1_000_000_000 };

            for(int i = 0; i < n; i++)
            {
                long number = a[i];
                for(int j = 0; j < powsCount; j++)
                    if(number < powValues[j])
                    {
                        powers[j]++;
                        aPows[i] = j;
                        break;
                    }
            }

            long answer = 0;
            long module = 1_000_000_007;
            for(int i = 0; i < n; i++)
            {
                long number = a[i];
                powers[aPows[i]]--;
                answer += number * (n - 1);

                for(int j = 0; j < powsCount; j++)
                {
                    answer += number * powers[j] * powValues[j];
                }

                powers[aPows[i]]++;
            }

            Console.WriteLine(answer % module);
            //Console.ReadKey();
        }
    }
}
