#include <iostream>
#include<string>
#include <map>
#include <vector>

using namespace std;

map<string, vector<int>> m;

int to_int(string s) {
	int n = 0;
	for (int i = 0; i<int(s.size()); i++) {
		if (s[i] == '-') {
			continue;
		}
		n = n * 10 + int(s[i] - '0');
	}
	if (s[0] == '-') {
		n = -n;
	}
	return n;
}

void rec() {
	string s;
	map<string, int> m1;
	while (cin >> s) {
		if (s == "{") {
			rec();
			continue;
		}
		else if (s == "}") {
			for (auto it = m1.begin(); it != m1.end(); it++) {
				int k = (*it).second;
				string str = (*it).first;
				for (int j = 0; j<k; j++) {
					m[str].pop_back();
				}
				if (m[str].empty()) {
					m.erase(str);
				}
			}
			return;
		}
		string s1, s2;
		bool b2 = 0;
		int i = 0;
		for (; i<s.size(); i++) {
			if (s[i] == '=') {
				i++;
				break;
			}
			s1.push_back(s[i]);
		}
		for (; i<s.size(); i++) {
			s2.push_back(s[i]);
			if (s[i] >= '0' && s[i] <= '9') {
				b2 = 1;
			}
		}
		if (b2) {
			int k = to_int(s2);
			m[s1].push_back(k);
			m1[s1]++;
		}
		else {
			if (m.find(s2) == m.end()) {
				m[s2].push_back(0);
				m1[s2]++;
			}
			m[s1].push_back(m[s2].back());
			m1[s1]++;
			cout << m[s2].back() << "\n";
		}
	}
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	map<string, int> m;
	rec();
}
