#include <bits/stdc++.h>

using namespace std;

map<string,int> vars;

int sToN(string &s) {
    int ans = 0;
    int i = 0;
    bool neg = false;
    if (s[0] == '-')
        neg = true, i++;
    while (i < (int)s.length()) {
        ans *= 10;
        ans += s[i++] - '0';
    }
    return neg ? -ans : ans;
}

void processBlock() {
    stack<pair<string,int>> hist;
    string s, a, b;
    while (cin >> s) {
        if (s[0] == '{') {
            processBlock();
        } else if (s[0] == '}') {
            while (!hist.empty()) {
                vars[hist.top().first] = hist.top().second;
                hist.pop();
            }
            return;
        } else if (s.length() > 0) {
            int i = 0;
            while (s[i] != '=')
                i++;
            a = s.substr(0, i);
            b = s.substr(++i);
            if (isdigit(b[0]) || b[0] == '-') {
                hist.push({a, vars[a]});
                vars[a] = sToN(b);
            }
            else {
                if (!vars.count(b))
                    vars[b] = 0;
                hist.push({a, vars[a]});
                vars[a] = vars[b];
                cout << vars[a] << "\n";
            }
        }
    }
}
//#define FILETEST

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    #ifdef FILETEST
    freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    #endif // FILETEST

    string s, a, b;
    while (cin >> s) {
        if (s[0] == '{') {
            processBlock();
        } else if (s.length() > 0) {
            int i = 0;
            while (s[i] != '=')
                i++;
            a = s.substr(0, i);
            b = s.substr(++i);
            if (isdigit(b[0]) || b[0] == '-') {
                vars[a] = sToN(b);
            }
            else {
                if (!vars.count(b))
                    vars[b] = 0;
                vars[a] = vars[b];
                cout << vars[a] << "\n";
            }
        } else
            break;
    }

    return 0;
}
