#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
const int MOD = 998244353;

int main() {
    int n, m;
    while (scanf("%d%d", &n, &m) == 2) {
        vector<vector<int> > e(n);
        vector<set<int> > neib(n);
        set<int> vert;
        map<pair<int, int>, pair<int, int> > mp;
        auto combPar = [&](pair<int, int> x, pair<int, int> y) {
            return make_pair(1LL * x.first * y.first % MOD, (1LL * x.first * y.second + 1LL * x.second * y.first) % MOD);
        };
        auto combSeq = [&](pair<int, int> x, pair<int, int> y) {
            return make_pair((1LL * x.first * y.second + 1LL * x.second * y.first) % MOD, 1LL * x.second * y.second % MOD);
        };
        auto get = [&](int u, int v) {
            if (u > v) swap(u, v);
            if (!mp.count({u, v})) mp[{u, v}] = {1, 0};
            return mp[{u, v}];
        };
        auto addNeib = [&](int u, int v) {
            if (u == 0 || u == n - 1) return;
            neib[u].insert(v);
            if (neib[u].size() == 2) vert.insert(u);
        };
        auto addEdge = [&](int u, int v, pair<int, int> t) {
            if (u > v) swap(u, v);
            addNeib(u, v);
            addNeib(v, u);
            auto o = get(u, v);
            mp[{u, v}] = combPar(t, o);
        };
        for (int i = 0; i < m; i++) {
            int u, v;
            scanf("%d%d", &u, &v);
            --u; --v;
            addEdge(u, v, {1, 1});
        }
        vert.clear();
        for (int i = 1; i < n - 1; i++) {
            if (neib[i].size() == 2) vert.insert(i);
        }
        while (!vert.empty()) {
            int v = *vert.begin();
            vert.erase(v);
            vector<int> u;
            for (int x : neib[v]) u.push_back(x);
            neib[u[0]].erase(v);
            neib[u[1]].erase(v);
            addEdge(u[0], u[1], combSeq(get(v, u[0]), get(v, u[1])));
        }
        printf("%d\n", get(0, n - 1).second);
    }
}